  	      subroutine azelplot(filename,plotf,
     1        LINEWD,NDOTSZ,x1vp,x2vp,y1vp,y2vp,fracvp)


! change from standalone program to a subroutine to be used with
! fakesat_menu   DWM 23JUL93                                    


C This programs works with the AZELPLOT option in the program
C test3.f. With this option AZELPLOT produces a file: azelplot.dat
C which lists for all the tracking stations at every
C observation time the :
C (1) azimuth (deg)
C (2) azimuth rate (deg/minute)
C (3) elevation (deg)
C (4) elevation rate (deg/minute)
C (5) range (km)
C (6) rate (km/s)
C This program takes this file and plots the data out

!       logical cons,plotcons,plotgrt
        character  plotf*80,filename*21

      PARAMETER  (MAXT=500)    !max number of time steps
      PARAMETER  (MAXORB=2)    !max number of orbiters
      PARAMETER  (MAXNST=10)   !max number of tracking stations
      PARAMETER  (MAXST=40)    !max number of GRTs + orbiters
      PARAMETER  (MAXCONS=20)  !max number of spacecraft constraints

      PARAMETER  (MAXAZ=20)    !max number of horizon mask sections


      real x1vp,x2vp,y1vp,y2vp,fracvp
      real data(7+MAXNST+MAXAZ+MAXNST*MAXT,7,MAXNST)
      real t1,t2,t3,min(6),max(6)
      real xleft(6),xright(6),ybot(6),ytop(6),x(10000),y(10000)
      real zenith,xcircle(360),ycircle(360),x2(10000)
      real rcircle,rangle,tick
      character*80 title(6)*80,tname(6)*10,info(6)*30
      character*80 xlabel(6),ylabel(6),text
      integer nst
      logical flag,tickplot
      integer LINEWD,NDOTSZ

      character xlab1*4,xlab2*3,xlab3*2,xlab4*2,xlab5*2


!      integer YEAR,DAY1,IHR1,IMIN1,ISEC1

!	write(*,*) 'in azelplot : '
!	write(*,*) 'filename:'
!	write(*,'(a)') filename
!	write(*,*) 'plotfile: '
!	write(*,'(a)') plotf


	dr=3.141592654/180.0

	info(1)=': azimuth vs time '
	info(2)=': azimuth rate vs time'
	info(3)=': elevation vs time'
	info(4)=': elevation rate vs time'
	info(5)=': range (1000 km) vs time'
	info(6)=': range rate (km/s) vs time'

!	xlabel(5)='Time from start of observartion (hr)'
!	xlabel(6)='Time from start of observartion (hr)'
	xlabel(1)=' '	
	xlabel(2)=' '
	xlabel(3)=' '
	xlabel(4)=' '



	ylabel(1)= 'azimuth (deg)'
	ylabel(2)= 'az rate (deg/min)'
	ylabel(3)= 'elevation (deg)'
	ylabel(4)= 'el rate (deg/min)'
	ylabel(5)= 'range (1000 km)'
	ylabel(6)= 'range rate (km/s)'
	
 
!      write(*,*) 'What file contains az/el data as a function of time ?'
!     write(*,*) '(usually azelplot.dat)'
!      read(*,'(a)') filename

300	continue
      
      open(1, file=filename, status='old',err=999)

!      write(*,*) 'suppress data below elevation 0 (deg) ? (1=yes)'
!      read(*,*) ielev

	ielev = 1 
 
      read(1,*) nst

	do i=1,nst
	read(1,'(a)') tname(i)
	end do



	read(1,*) IYREF,IDREF,IHREF,IMREF,ISREF

	write(xlab1,'(i4)') IYREF
	write(xlab2,'(i3)') IDREF
	write(xlab3,'(i2)') IHREF
	write(xlab4,'(i2)') IMREF
	write(xlab5,'(i2)') ISREF

!	xlabel(5)='TIME (hr) FROM REF EPOCH ('//xlab1//' day '//xlab2//
!     1  ' '//xlab3//':'//xlab4//':'//xlab5//')'

	xlabel(5)='Time (hours) from 0 UT on  day '//xlab2//
     1  ' of '//xlab1


	time1=float(IDREF)+float(IHREF)/24.0+float(IMREF)/1440.0
     1          +float(ISREF)/86400.0 

	time0=float(IDREF)

	dtime=24.0*(time1-time0)

!	write(*,*) 'time1,time0,dtime: '
!	write(*,*)  time1,time0,dtime


	xlabel(6)=xlabel(5)

! plot tick dots every hour

	read(1,*) t1
	read(1,*) t2
	read(1,*) t3

! need to re-set t1,t2 to get correct x-axis range

	t1=t1+dtime
	t2=t2+dtime


	tick=1.0
! due to rounding errors used to get 2 dots at each epoch
	t3=0.995*t3




C	do time=t1,t2,t3
C	  it=it+1
C	  x(it)=time
C	 do j=1,nst
C	  read(1,*)  itel,(data(it,k,j),k=1,6)
C	  write(*,*) x(it)
C	  write(*,*) itel,(data(it,k,j),k=1,6)
C	 end do
C	end do

	iostat=0

	it=0
 

	do while (iostat.eq.0)
	    it=it+1
	 do j=1,nst
	   read(1,*,iostat=iostat,end=25)  itel,(data(it,k,j),k=1,7)
	   data(it,5,j)=data(it,5,j)/1000.0
	  if(j.eq.1) then
	    x(it)=data(it,7,j)
	    x(it)=x(it)+dtime
!	    write(*,*) it,x(it)
C	   write(*,*) x(it)
	  end if
C	  write(*,*) itel,(data(it,k,j),k=1,6)
	 end do
	end do

25	continue

	close(1)

	it=it-1

	if(it.gt.MAXT) goto 5000



C	min(1)=-180.0
C	max(1)=180.0

C	min(3)=-90.0
C	max(3)=90.0

	iopt=0

	t1plot=t1
	t2plot=t2

200	continue

	if(iopt.eq.2) then
	 write(*,*) 'Time from start of observation (hr)'
	 write(*,fmt='(''ranges from '',f10.5,'' to '',f10.5)') t1,t2
	 write(*,*) 'range to be plotted is now set'
	 write(*,fmt='(''from '',f10.5,'' to '',f10.5)') t1plot,t2plot
	 write(*,*) 'What range do you want ?'
	 write(*,*) 'Minimum time from start of observation (hr) = ?'
 	 read(*,*) t1plot
	 write(*,*) 'Maximum time from start of observation (hr) = ?'
	 read(*,*) t2plot
	end if

100	continue

	itmin=1
 	itmax=1

	 do j=1,it
	  if(x(j).le.t1plot) itmin=j
	  if(x(j).le.t2plot) itmax=j
C	  write(*,*) 'j,x(j),t1plot,itmin ',j,x(j),t1plot,itmin
	end do

C	write(*,*) 'itmin ',itmin
C	write(*,*) 't1plot,t2plot ',t1plot,t2plot	
C	write(*,*) 'it,itmin,itmax ',it,itmin,itmax

!      call pgbegin(20, plotf, 1, 1)

	CALL PGSLW(LINEWD)



	do i=1,nst

C	if(i.gt.1) then
	 flag=.true.

! comment out 3-May-94
!	 call pgask(.true.)
!	 call pgadvance

C	end if

	 if(i.gt.1) call pgadvance

	 do k=1,6
	   title(k)=tname(i)//info(k)
	 end do

	 initial=0

	 do j=itmin,itmax




	 isetlim=1

	 if(ielev.eq.1.and.data(j,3,i).lt.0.0) isetlim=0
	  

	  if(isetlim.eq.1) then
	   if(initial.eq.0) then
	    min(1)=data(j,1,i)
	    max(1)=data(j,1,i)
	    min(2)=data(j,2,i)
	    max(2)=data(j,2,i)
	    min(3)=data(j,3,i)
	    max(3)=data(j,3,i)
	    min(4)=data(j,4,i)
	    max(4)=data(j,4,i)
	    min(5)=data(j,5,i)
	    max(5)=data(j,5,i)
	    min(6)=data(j,6,i)
	    max(6)=data(j,6,i)
	    initial=initial+1
	  else
	   if(data(j,1,i).lt.min(1)) min(1)=data(j,1,i) 	  
	   if(data(j,1,i).gt.max(1)) max(1)=data(j,1,i)	 
	   if(data(j,2,i).lt.min(2)) min(2)=data(j,2,i) 	  
	   if(data(j,2,i).gt.max(2)) max(2)=data(j,2,i)
	   if(data(j,3,i).lt.min(3)) min(3)=data(j,3,i) 	  
	   if(data(j,3,i).gt.max(3)) max(3)=data(j,3,i)	 	  
	   if(data(j,4,i).lt.min(4)) min(4)=data(j,4,i) 	  
	   if(data(j,4,i).gt.max(4)) max(4)=data(j,4,i) 
	   if(data(j,5,i).lt.min(5)) min(5)=data(j,5,i) 	  
	   if(data(j,5,i).gt.max(5)) max(5)=data(j,5,i) 
	   if(data(j,6,i).lt.min(6)) min(6)=data(j,6,i) 	  
	   if(data(j,6,i).gt.max(6)) max(6)=data(j,6,i) 
	 end if
	end if

	end do

	do i2=1,6
	  if(abs(max(i2)-min(i2)).lt.0.0001) then
	     max(i2)=max(i2)+1.0
	     min(i2)=min(i2)-1.0
	  else
	    max(i2)=max(i2)+0.05*(max(i2)-min(i2))
	    min(i2)=min(i2)-0.05*(max(i2)-min(i2))
	  end if
	end do



c	alpha=0.35
	alpha=0.2

	height=1.0/(4*alpha+3)
        space=height*alpha
        width=0.5*(1-3*space)

	xleft(1)=space
        ybot(1)=3*space+2*height
	xleft(2)=xleft(1)+width+space
        ybot(2)=ybot(1)

	xleft(3)=space
        ybot(3)=2*space+height
	xleft(4)=xleft(3)+width+space
        ybot(4)=ybot(3)

	xleft(5)=space
        ybot(5)=space
	xleft(6)=xleft(5)+width+space
        ybot(6)=ybot(5)

	do k=1,6
	  xright(k)=xleft(k)+width
	  ytop(k)=ybot(k)+height
	end do

	do k=1,6
	  ytop(k)=0.5+0.45*ytop(k)
	  ybot(k)=0.5+0.45*ybot(k)
	end do

	call pgbbuf


!	call pgvport(0.0,1.0,0.0,1.0)
	call pgvport3(0.0,1.0,0.0,1.0,x1vp,x2vp,y1vp,y2vp,fracvp)

	call pgwindow(0.0,1.0,0.0,1.0)


c	call pgsci(7)
	call pgsci(1)	
        call pgsch(1.0)
         text='Tracking station: '//tname(i)
        call pgtext(0.4,0.95,text)


	do k=1,6


	call pgsch(0.5)
	call pgsls(1)
	call pgsci(1)

!	call pgvport(xleft(k),xright(k),ybot(k),ytop(k))
	call pgvport3(xleft(k),xright(k),ybot(k),ytop(k),x1vp,x2vp,y1vp,y2vp,fracvp)

	call pgwindow(t1plot,t2plot,min(k),max(k))
	call pgbox('bcnst',0,0,'bcnst',0,0)
c	call pgsci(7)
	call pgsci(1)	
c	call pglabel(xlabel,ylabel(k),title(k))

C-gam	call pglabel(xlabel(k),ylabel(k),'')
	call pglabel(xlabel(k),ylabel(k),' ')

	end do


!	call pgvport(0.0,1.0,0.0,1.0)
	call pgvport3(0.0,1.0,0.0,1.0,x1vp,x2vp,y1vp,y2vp,fracvp)


	call pgwindow(0.0,1.0,0.0,1.0)
!	call pgsci(7)
!        call pgsch(1.0)
!         text='Tracking station: '//tname(i)
!        call pgtext(0.4,0.95,text)

c	call pgsci(7)
	call pgsci(1)	
	call pgsch(0.7)
!        call pgtext
!     1   (0.65,0.45,'Polar Plot: Zenith Angle vs Azimuth')
	call pgsch(0.5)

	if(ielev.eq.1) then  
!	 call pgtext(0.73,0.25,'EAST (Az=90)  ,Za=90 ')
!	 call pgtext(0.5,0.47,'NORTH (Az=0) ,Za=90')
	else
!	 call pgtext(0.73,0.25,'EAST (Az=90)  ,Za=180 ')
!	 call pgtext(0.5,0.47,'NORTH (Az=0) ,Za=180')
	end if

!	call pgsch(0.5)
	call pgsls(1)
c        call pgsci(7)
        call pgsci(1)        

!	call pgvport(0.3,0.7,0.05,0.45)
	call pgvport3(0.3,0.7,0.05,0.45,x1vp,x2vp,y1vp,y2vp,fracvp)

	if(ielev.eq.1) then
	call pgwnad(-90.0,90.0,-90.0,90.0)
	else
	call pgwnad(-180.0,180.0,-180.0,180.0)
	end if
	call pgbox('ast',0,0,'ast',0,0)

c	call pgsci(7)
	call pgsci(1)	
	call pgsch(0.7)

	if(ielev.eq.1) then 
	call pgsch(0.7)
        call pgtext
     1   (70.0,70.0,'Polar Plot: Zenith Angle vs Azimuth')
	call pgsch(0.5)
	 call pgtext(100.0,0.0,'EAST (Az=90)  ,Za=90 ')
	 call pgtext(0.0,100.0,'NORTH (Az=0) ,Za=90')
	else
	call pgsch(0.7)
        call pgtext
     1   (40,190,'Polar Plot: Zenith Angle vs Azimuth')
	call pgsch(0.5)
	 call pgtext(190.0,0,'EAST (Az=90)  ,Za=180 ')
	 call pgtext(0.0,190,'NORTH (Az=0) ,Za=180')
	end if

!	call pgsch(0.5)
	call pgsls(1)
        call pgsci(7)



  
	call pgsci(1)

	doj1=1,4
            rcircle=45.0*float(j1)
	 do j2=1,360
            rangle=float(j2)
            xcircle(j2)=rcircle*cos(rangle*dr)
            ycircle(j2)=rcircle*sin(rangle*dr)
	 end do
           call pgsls(4)
	   call pgline(360,xcircle,ycircle)
           call pgsls(1)
       end do

	call pgebuf





	do k=1,6

!	call pgvport(xleft(k),xright(k),ybot(k),ytop(k))
	call pgvport3(xleft(k),xright(k),ybot(k),ytop(k),x1vp,x2vp,y1vp,y2vp,fracvp)

	call pgwindow(t1plot,t2plot,min(k),max(k))

	call pgbbuf

	do j=1,it
	 y(j)=data(j,k,i)
	end do

C	call pgline(it,x,y)

	do j=1,it

	  if(amod(x(j),tick).lt.t3) then
	   TICKPLOT=.true.
!	   write(*,*) x(j),tick,t3,amod(x(j),tick)
	  else
	   TICKPLOT=.false.
	  end if

	if(j.eq.1) then
	 call pgmove(x(j),y(j))
	else
	  if(data(j,3,i).gt.0) then
           call pgsls(1)
	   call pgsci(3)
	   call pgdraw(x(j),y(j))
	   if(TICKPLOT) then
            CALL PGSLW(NDOTSZ)
	    call pgpoint(1,x(j),y(j),17)
            CALL PGSLW(LINEWD)
	   end if
	  else
	   if(ielev.eq.1) then 
	    call pgmove(x(j),y(j))
	   else
	    call pgsls(4)
            call pgsci(2)
	    call pgdraw(x(j),y(j))
	   if(TICKPLOT) then
            CALL PGSLW(NDOTSZ)
	    call pgpoint(1,x(j),y(j),17)
            CALL PGSLW(LINEWD)
	   end if
	   end if	   
	  end if
	 end if
	end do

	call pgebuf
	
	end do




	do j=1,it
         zenith=90.0-data(j,3,i)
	 x2(j)=zenith*sin(data(j,1,i)*dr)
	 y(j)=zenith*cos(data(j,1,i)*dr)
 	end do

	call pgsch(0.5)
	call pgsls(1)
        call pgsci(7)

!	call pgvport(0.3,0.7,0.05,0.45)
	call pgvport3(0.3,0.7,0.05,0.45,x1vp,x2vp,y1vp,y2vp,fracvp)

	if(ielev.eq.1) then
	call pgwnad(-90.0,90.0,-90.0,90.0)
	else
	call pgwnad(-180.0,180.0,-180.0,180.0)
	end if
!	call pgbox('ast',0,0,'ast',0,0)
        call pgsci(7)
  
	call pgsci(1)


	doj1=1,4
            rcircle=45.0*float(j1)
	 do j2=1,360
            rangle=float(j2)
            xcircle(j2)=rcircle*cos(rangle*dr)
            ycircle(j2)=rcircle*sin(rangle*dr)
	 end do
           call pgsls(4)
	   call pgline(360,xcircle,ycircle)
           call pgsls(1)
       end do

         rcircle=5.0
	 do j2=1,360
            rangle=float(j2)
            xcircle(j2)=rcircle*cos(rangle*dr)
            ycircle(j2)=rcircle*sin(rangle*dr)
	 end do
          call pgsci(2)
	   call pgpoly(360,xcircle,ycircle)
	    xcircle(1)=90.*cos(95.*dr)
            ycircle(1)=90.*sin(95.*dr)
	    xcircle(2)=0.
            ycircle(2)=0.            
	    xcircle(3)=90.*cos(85.*dr)
            ycircle(3)=90.*sin(85.*dr)
	 do j2=84,94
            rangle=float(j2)
            xcircle(j2-80)=90.*cos(rangle*dr)
            ycircle(j2-80)=90.*sin(rangle*dr)
	 end do            
	   call pgpoly(14,xcircle,ycircle)            	   
           call pgsci(1)
	

	do j=itmin,itmax

	  if(amod(x(j),tick).lt.t3) then
	   TICKPLOT=.true.
	  else
	   TICKPLOT=.false.
	  end if


	if(j.eq.itmin) then
	 call pgmove(x2(j),y(j))
	else
	  if(data(j,3,i).gt.0) then
           call pgsls(1)
	   call pgsci(3)
           if(data(j-1,3,i).lt.0.0) call pgsci(7)
	   call pgdraw(x2(j),y(j))
	   if(TICKPLOT) then
	    CALL PGSLW(NDOTSZ)
	    call pgpoint(1,x2(j),y(j),17)
            CALL PGSLW(LINEWD)
	   end if
	  else
	   if(ielev.eq.1) then 
	    call pgmove(x2(j),y(j))
	   else
	    call pgsls(4)
            call pgsci(2)
            if(data(j-1,3,i).gt.0.0) call pgsci(7)  
	    call pgdraw(x2(j),y(j))
	   if(TICKPLOT) then
	    CALL PGSLW(NDOTSZ)
	    call pgpoint(1,x2(j),y(j),17)
            CALL PGSLW(LINEWD)
	   end if
	   end if	   
	  end if
	 end if

	end do





	end do

!	call pgend

!	write(*,*) 'options: '
!	write(*,*) '0 = end program'
!	write(*,*) '1 = another plotting device'
!	write(*,*) '2 = re-plot with different time range'
!	write(*,*) '3 = change suppress data below elevation 0 (deg)'
!	write(*,*) 'which option ?'
!	read(*,*) iopt

	iopt = 0

	if(iopt.eq.1) goto 100
	if(iopt.eq.2) goto 200
	if(iopt.eq.3) goto 300

	return

  999 write(*,*) 'ERR I/O'
      return 

5000  continue

      write(*,*) ' '
      write(*,*) 'number of time steps in data set is: ',it
      write(*,*) 'this exceeds the maximum allowed   :'  ,MAXT
      write(*,*)  ' '
      write(*,*) 'ABORTING plotting of data set'
      write(*,*) ' '
      write(*,*) 'try using a smaller time range or '
      write(*,*) 'a larger integration period '
      write(*,*) ' '

      return
     
      end

