

	SUBROUTINE CONS(jdtoday,iday,IUT,SVEC,SAT,
     2    TEL,nst,VISIBLE,OBS,yz,out1,out2,NORAPCS,
     3    TELOPT,TELANG,SUNANGIN,VIS,COMPLOT,
     4    IUT1,azeltime,ECLIPLOT,
     5    ecc,man,viscon,TYPSAT,apply,
     6    SATA,TELA,SATB,TELB,IORB,RIG,
     7	  asemi,IUT3,TREC,year,yepoch,mepoch,depoch,
     8    POWERBUD,POWERPLT,batcap,eclip,teclip,gps,cooler,PRIOR,
     9    consver,yzplot,plotsat,yz1,angte,ang_source,
     A    ang_es,NOSUNANG,sunavoid,teldir2,telangle2)

 
	
C Using VSOP constraints (from ISAS document sept 1989) calculates
C if VSOP can observe the source, given the constraints, as a function
C of spacecraft YZ-plane rotation angle. This angle is defined as follows:
C project inertial X axis onto spacecraft YZ-plane, angle between this
C projection and spacecraft Y-axis is angle in question.
C If it can observe returns value 1.0 in array OBS.
C subrountine adap
C major difference between my results and Gurvits appears to be due to radiator
C constraint 2.1c. examine this possibility by including logical noradiator 
C which switches off this constraint. DWM 11-JUN-90
C
C 3 RH co-ordinate systems needed:
C (i) X,Y,Z         Inertial frame X RA=0,Dec=0, Z North Pole
C		    (0,0,0) at Earth's centre e.g. rsun
C (ii) X1,Y1,Z1     Inertial frame X1 RA=0,Dec=0, Z1 North Pole
C		    (0,0,0) at Satellite e.g. rsun1
C (ii) X2,Y2,Z2     Inertial frame X2=source direction, Y2=direction given
C                   by cross product of  source direction and sun direction
C                   (0,0,0) at Satellite e.g. rsun2

C D.W. Murphy 29-SEP-89

	implicit none
	
	include 'svlbsched.inc'
	
	integer ihra,imra,igdec,imdec	
	integer nst,var,var2,count,var3,c(100),add,iday,TELOPT
	integer TYPSAT,NTVIS,Nviscon,cout(100),IORB,year
        INTEGER JDAY,IHR,IMIN,ISEC                 ! RPL variables
       double precision teta,fi,ax0(3),ax1(3),ax2(3),angxe,angxm,angxs
       double precision angxem,angxmm,angxsm,fim
	double precision ang1,ang2,TELANG,asemi	
	double precision jd,jdtoday,IUT,sat(3),tel(3,NST),jd1990
	double precision sata(3),tela(3,NST),satb(3),telb(3,NST)
	double precision xra,xdec
!	double precision pi,dr,rd,rade,radm,dp,rm,yz(3),SUNANG
!VP PI is now defined in svlbsched
	double precision dr,rd,rade,radm,dp,rm,yz(3),SUNANG,SUNANG1
	double precision SUNANGIN,IUT3
	double precision ZoS,nZoSyz,nZoSzx,s1,s2,SoD,MoD,EoD,HoT	
	double precision su15,su45,su30		
	double precision eps,NoS,SyzonZ,NoR,Soz,ZoR,SonX,RmoX,RoX
	double precision ras,decs,lamdas,betas,ms,rs,ram,decm
	double precision ang,i(3),j(3),k(3),x(3),y(3),z(3),x1(3)
	double precision angs1,angs2,angs3,angm1,angm2,angm3,ange1,ange2,ange3
	double precision SVEC(3),ie(3),je(3),ke(3),kem(3),j0(3),k0(3)
	double precision rsun(3),rmoon(3),TREC
	double precision nsun(3),ecc,man,dt

C-gam	double precision nsun(3),manstart,nustart,manstop,nustop
	double precision         manstart,nustart,manstop,nustop

	double precision rsun1(3),rmoon1(3),rearth1(3)
	double precision rsun2(3),rmoon2(3),tperiod
	double precision rearth2(3),nsun2(3),tleft
	double precision nmoon2(3),nearth2(3),Syz(3),angyz,angyz1
! warning x2 will only work with <= 10 tracking stations
	double precision pcs,rmin,dist,ange,angm,rot(3,3),x2(3,10),h(3)
	double precision d1(3),d2(3),d3(3),obs(720,4),n(3),xlim
	double precision n3(3),psi0,psipr,dpsi,arg1,arg2,fipr,del_u1,del_u2
	double precision mSoX,mRmoX,mROX,REM,HEIGHT
        double precision RAPOGEE,RPERIGEE,ALTITUDE
	double precision east(3),north(3),n1(3),PRIOR
	double precision aza,azb,zenitha,zenithb,azdot,zenithdot,timehr
	double precision xa(3),x1a(3),x2a(3),na(3)
	double precision xb(3),x1b(3),x2b(3),nb(3)

C-gam   double precision zenith,az,dp1,dp2,azeltime,IUT1,IUT3
        double precision zenith,az,dp1,dp2,azeltime,IUT1

	double precision VISout,noflag,HoTlim(1000),HoTRA
        double precision azmin(1000),azmax(1000),elength,etime
        double precision estart2,estop2,dyz,powergen,teclip

C-gam   double precision tperiod,pappltot2,pvlbi,gps,mancrit,preqoff2
        double precision         pappltot2,pvlbi,gps,mancrit,preqoff2

        double precision batcap,pappl,preq,pshunt,pappltot,preqoff
	double precision rasat1,decsat1,lamdasat1,betasat1,rsat1
	double precision rasat2,decsat2,lamdasat2,betasat2,rsat2,sate1(3)
        integer numaz,yepoch,mepoch,depoch,consver

        double precision yz1(NST),angte(NST),ang_source(3),ang_es
	double precision dist_es
	
	double precision sunavoid(NSUNAVOIDMAX),teldir2(3),telangle2

        REAL*8 ECLIPMULT,ECLIPADD,ESTART,ESTOP,DUR
        LOGICAL EFLAG,ETEST,EFLAGOLD
        LOGICAL apply(20),flage,RIG,yzplot
	logical Flag,VISIBLE(nst),out1,out2,noout
	logical viscon(nst),out3,eclip,cooler
	logical NORAPCS,SRCUP,flagrad,VIS,complot
	logical flag1(20),ECLIPLOT,POWERBUD,POWERPLT,plotsat
	logical bad_sun_ang, NOSUNANG
	logical fls1,fls2,fls3,flm1,flm2,flm3,fle1,fle2,fle3
	logical fl12,fl23,fl13

	double precision alphzh,rrzh,deltzh
	integer ihzh,imzh,idzh,idmzh
	character*1 sig

      COMMON /ECLIPSES/ ECLIPMULT,ECLIPADD,ESTART,ESTOP,DUR,
     2                  RAPOGEE,RPERIGEE,EFLAG,ETEST,EFLAGOLD

!		write(*,*) 'in CONS:TYPSAT,YZ(1),YZ(2),YZ(3) '
!		write(*,*)  	TYPSAT,YZ(1),YZ(2),YZ(3)



	if(eclipmult.ge.1.0d0.and.apply(20)) then
	 out3=.true.
	else
	 out3=.false.
	end if


	noout=.not.(out1.or.out2.or.out3)


C	write(*,*) 'out1,out2,noout ',out1,out2,noout

	if(out2) write(20,*) ' '
        if(out2) write(20,*) 'fakesat:  details of constraints'
        if(out2) write(20,*) ' '

C Flag true: Cant observe because of constraints

! pi is now defined in svlbsched.inc

!        pi=3.141592654d0
        
        
        dr=pi/180.0d0
        rd=1/dr

C Earth and moon radius from Lang pg.526
	rade=6378160.0d0
	radm=1738000.0d0

C Angles used for constraints

C 1.1 Cooling
	   zos=90.0d0

C (this used to be 100.0d0)

C 1.2 Power Generating

C old comments:
C nZoSyz  really should depend on mission lifetime
C 40 degrees at start 20 degrees at end

C new comments:
C nZoSyz now fixed at 30.0d0

	nZoSyz=30.0d0 ! 1.2a

	nZoSzx=30.0d0 ! 1.2b

C 1.3 Star sensors

	    s1=35.0d0 
	    s2=15.0d0

c	   SoD=30.0d0 ! 1.3a
	   SoD=40.0d0 	   
	   MoD=30.0d0 ! 1.3b
c	   Eod=25.0d0 ! 1.3c
	   Eod=30.0d0 !  
	   
	   su15=15.0d0*dr
	   su45=45.0d0*dr
	   su30=30.0d0*dr
C 1.4 telemetry antenna

C RADIOASTRON:
C For 15GHz downlink 0.15d0 else 0.5d0
C We use 15GHz downlink case

c	HoTRA=90.0d0+0.15d0
	   HoTRA=90.0d0	   
    

C RADIOASTRON 
C old comments:
C angle eps can be between 30 and 40 degrees (to be chosen at end 1989)
C set	           eps=35.0
C new comments:
C This angle now chosen to be 30 degrees
C
	         teta=150.0d0*dr
	 fi=180.0d0*dr
	 ax0(1)=dcos(teta)
	 ax0(2)=-dsin(teta)*sin(fi)
	 ax0(3)=sin(teta)*cos(fi)
	         teta=105.0d0*dr
	 fi=134.0d0*dr
	 ax1(1)=dcos(teta)
	 ax1(2)=-dsin(teta)*sin(fi)
	 ax1(3)=sin(teta)*cos(fi)	 
	         teta=100.5d0*dr
	 fi=226.0d0*dr
	 ax2(1)=dcos(teta)
	 ax2(2)=-dsin(teta)*sin(fi)
	 ax2(3)=sin(teta)*cos(fi)
        angxem=30.0d0
	angxmm=30.0d0
	angxsm=40.0d0       
	  eps=30.0
c         2011 28 jule
	  eps=17.5	  	  
	  del_u1=16.308
	  del_u2=0.4034
c             3 variant
	  del_u1=15.2
	  del_u2=-0.45
	  
c             4 variant
	  del_u1=15.0262
	  del_u2=0.3215
	  

C 2.1 Passive cooling system

	    PCS=43.0d0   
	    NoS=103.0d0 !2.1a


	if(consver.eq.1) then
	 SyzonZ=35.0d0  !2.1b
	else
c	 SyzonZ=30.0d0  !2.1b
	 SyzonZ=10.0d0  !2.1b	 
	end if

	    NoR=90.0d0  !2.1c

C 2.2 active cooling system

	if(consver.eq.1) then
	    SoZ=100.0d0 !2.2a
	   rmin=11500000.0d0 !2.2b
	else
	    SoZ=90.0d0 !2.2a
	   rmin=20000000.0d0 !2.2b
	end if

	    ZoR=30.0d0       !2.2b

C 2.3 Cold plate 

c	   SonX=120.0d0
	   SonX=90.0d0	   
C (this angle was 90 degrees now 120 degrees)	


C 2.4 Radioastronomical receivers for RADIOASTRON
C     (Solar Power constraint for VSOP)

	   SUNANG=SUNANGIN
	   SUNANG1=1.65d2

           if(.not.NORAPCS)  SUNANG=30.0d0 !2.4a

	   if(TYPSAT.eq.2)   then
	    if(consver.eq.1) then
		SUNANG=30.0d0
	    else
		SUNANG=90.0d0
c    for ask Kardashov
c		SUNANG=60.0d0
		SUNANG1=1.65d2
	    end if
	   end if


	 if(consver.eq.1) then
	   RmoX=20.0d0
	 else
	   RmoX=5.0d0
	 end if

	 if(.not.NORAPCS) then
	     RoX=0.0d0
	 else
	  if(consver.eq.1) then
	    RoX=30.0d0 !2.4b
	  else
	    RoX=5.0d0 !2.4b
	  end if
	 end if

C Monitoring star sensor

	  if(consver.eq.1) then
	   mSoX=40.0d0
	  else
	   mSoX=30.0d0
	  end if

	  mRmoX=20.0d0
	   mRoX=30.0d0


	jd=jdtoday+IUT/(86400.0d0*60.0d0)-dble(iday-1)

	jd1990=jd-2447892.5

c        print*,'jd,jdtoday,iut,iday=',jd,jdtoday,iut,iday
	call  SUN(jd,ras,decs,lamdas,betas,ms,rs)
c	print*,'ras,decs,lamdas,betas,ms,rs=',ras,decs,lamdas,betas,ms,rs
	
	ras=ras*15.0d0
	call  polar(rs,ras,decs,rsun)
c	call NORM(rsun,j0)
c	print*, j0

	
	
	call  MOON(jd,ram,decm,rm)
	ram=ram*15.0d0
	call  polar(rm,ram,decm,rmoon)

	call DIFF(SAT,rsun,rsun1)
	call DIFF(SAT,rmoon,rmoon1)

	do var=1,3
	rearth1(var)=-1.0d0*SAT(var)
	end do


	call DOTP(sat,sat,dist,ang)
	dist=dsqrt(dist)
c	print*,'dist,ANG=',dist,ANG

	ange=rd*dasin(rade/dist)
	angm=rd*dasin(radm/rm)

	if(plotsat) then
	 call dotp(rearth1,rsun1,dist_es,ang_es)
	end if




	

C  unit vectors


	ie(1)=1.0d0
	ie(2)=0.0d0
	ie(3)=0.0d0

	je(1)=0.0d0
	je(2)=1.0d0
	je(3)=0.0d0

	ke(1)=0.0d0
	ke(2)=0.0d0
	ke(3)=1.0d0
	
	kem(1)=0.0d0
	kem(2)=0.0d0
	kem(3)=-1.0d0	

	i(1)=svec(1)
	i(2)=svec(2)
	i(3)=svec(3)

	call VECP(rsun1,svec,y)
	call NORM(y,j0)
	call VECP(svec,j0,z)
	call NORM(z,k0)

	if(out2) then
        write(20,*) ' '
        write(20,*) '**Preliminary Calculations**'
        write(20,*) ' '
	write(20,*) 'sun:r,ra,dec'
	write(20,*) rs,ras,decs
	    xra=ras/15.0
	    ihra=int(xra)
	    xra=60.0*(xra-dble(ihra))
	    imra=int(xra)
	    xra=60.0*(xra-dble(imra))
	    xdec=abs(decs)
	    igdec=int(xdec)
	    xdec=60.0*(xdec-dble(igdec))
	    imdec=int(xdec)
	    xdec=60.0*(xdec-dble(imdec))
	write(20,*) ihra,imra,xra,igdec,imdec,xdec	
	write(20,*) 'rsun'
	write(20,*) (rsun(var),var=1,3)
	write(20,*) 'rsun1'
	write(20,*) (rsun1(var),var=1,3)
	write(20,*) 'moon:r,ra,dec'
	write(20,*) rm,ram,decm
	write(20,*) 'rmoon'
	write(20,*) (rmoon(var),var=1,3)
	write(20,*) 'rmoon1'
	write(20,*) (rmoon1(var),var=1,3)
	write(21,'(g25.10)') jd1990
	alphzh=datan2(rmoon1(2),rmoon1(1))*rd
	if(alphzh<0.0d0) alphzh=alphzh+360.0d0
	alphzh=alphzh/15.0d0
	ihzh=alphzh
	alphzh=60.0d0*(alphzh-ihzh)
	imzh=alphzh
	alphzh=60.0d0*(alphzh-imzh)
	sig=' '
	rrzh=dsqrt(rmoon1(1)*rmoon1(1)+rmoon1(2)*rmoon1(2))
	if(rmoon1(3)<0.0d0) sig='-'
	deltzh=dabs(rmoon1(3))
	deltzh=datan2(deltzh,rrzh)*rd
	idzh=deltzh
	deltzh=60.0d0*(deltzh-idzh)
	idmzh=deltzh
	deltzh=60.0d0*(deltzh-idmzh)
	write(15,'(g25.18,2i3,f5.1,2x,a1,2i3,f5.1)') 
     1	jd,ihzh,imzh,alphzh,sig,idzh,idmzh,deltzh
	write(20,*) 'satellite vector'
	write(20,*) (sat(var),var=1,3)
	write(20,*) 'rearth1'
	write(20,*) (rearth1(var),var=1,3)
	write(20,*) 'distance and angular size of earth'
	write(20,*) dist,ange*2.0d0
	write(20,*) 'distance and angular size of moon'
	write(20,*)  rm,angm*2.0d0
	write(20,*) 'source vector SVEC'
	write(20,*) (svec(var),var=1,3)
	write(20,*) 'unit vectors before yz rotation'
	write(20,*) (svec(var),var=1,3)
	write(20,*) (j0(var),var=1,3)
	write(20,*) (k0(var),var=1,3)
	write(20,*) ' '
	write(20,*) '**Number days since 0 UT 1st Jan 1990**',jd1990
	write(20,*)
	end if

	add=0



	do var=1,nst
	 viscon(var)=.false.
	end do

! If we find an angyz for which we meet the spacecraft constraints and
! VISIBLE(var) is true then we set viscon(var) to true

	   NTVIS=0   ! # tracking stations from which orbiter visible
           Nviscon=0 ! # tracking stations for which all constraints met



	do var=1,NST
	 if(VISIBLE(var)) NTVIS=NTVIS+1
	 yz1(var)=-10.0
	 angte(var)=-10.0
	end do




            JDAY = INT(IUT/(24.*3600.*60.))
            REM = IUT - 24.*3600.*60.*JDAY
            IHR = INT(REM/(3600.*60.))
            REM = REM - 3600.*60.*IHR
            IMIN = INT(REM/3600.)
            ISEC = (REM - 3600.*IMIN + 0.1)/60.
            JDAY = JDAY + 1             ! Start of year is Day 1



	 if((IUT.GE.IUT1).and.POWERPLT.and.POWERBUD) then
            write(26,'(1x,I4,1x,I5,3(1x,I2))') 
     1          YEAR,JDAY,IHR,IMIN,ISEC
	 end if





	 if((IUT.GE.IUT1).and.out1.and.IORB.eq.1) then
            write(19,'(1x,I4,1x,I5,3(1x,I2))') 
     1          YEAR,JDAY,IHR,IMIN,ISEC
	 end if

!	 if((IUT.GE.IUT1).and.out1.and.IORB.eq.1) then
!            write(*,'(1x,I4,1x,I5,3(1x,I2))') 
!     1          YEAR,JDAY,IHR,IMIN,ISEC
!	 end if


!	write(*,*) 'cons: yz(1),yz(2),yz(3)'
!	write(*,*) yz(1),yz(2),yz(3)




	do angyz=yz(1),yz(2),yz(3)




	if(out2) write(20,*) ' '
	if(out2) write(20,*) '**angyz** ',angyz

	do var=1,23+nst
	 c(var)=0
	end do

	add=add+1

	 flage=.false.


!     IF ((ECLIPMULT.NE.0.).or.ECLIPLOT) THEN

      if((.NOT.POWERBUD).and.typsat.eq.1) then
      IF ((apply(20)).or.ECLIPLOT) THEN
         CALL NORM (RSUN,NSUN)
         IF (SRCUP(SAT,NSUN)) THEN         ! not in eclipse
            EFLAG = .FALSE.
            IF (EFLAGOLD) THEN                   ! in eclipse last time?
               ESTOP = IUT
               manstop=man*rd
               IF (ESTART.NE.-1.D05) THEN      ! did you observe the start?
                  DUR = ESTOP - ESTART
                  IMIN = DUR/3600.
                  if(.not.NORAPCS) WRITE(40,201) IMIN
201               FORMAT(' ECLIPSE DURATION = ',I8,' MINUTES')
	         IF(ECLIPLOT) then
		  estart2=estart/(24.0*60.0*60.0*60.0)              		  
		  estop2 =estop /(24.0*60.0*60.0*60.0)
	          estart2=estart2+1.0              		  
	          estop2=estop2+1.0              		  
		  elength=(estop2-estart2)*24.0*60.0 ! eclipse length in minutes
	          etime=(estop2+estart2)/2.0         ! time at eclipse center in days
c	          write(41,*) etime,elength,estart2,estop2
c	          write(*,*) etime,elength,estart2,estop2
		  call KEP(manstart,ecc,1.0d-6,nustart)
		  call KEP(manstop,ecc,1.0d-6,nustop)

!	          write(41,*) etime,elength,nustart,nustop

! write out lamdas, lamda-spacecraft, beta-spacecraft

! values at start of eclipse

		  rsat1 = dsqrt(sate1(1)**2 + sate1(2)**2 + sate1(3)**2)
		  decsat1 = rd*asin(sate1(3)/rsat1)
	          rasat1 = rd*datan2(sate1(2),sate1(1))/15.0
	          call cnvrt1(rasat1,decsat1,lamdasat1,betasat1,1)

! values at end of eclipse

		  rsat2 = dsqrt(sat(1)**2 + sat(2)**2 + sat(3)**2)
		  decsat2 = rd*asin(SAT(3)/rsat2)
	          rasat2 = rd*datan2(SAT(2),SAT(1))/15.0
	          call cnvrt1(rasat2,decsat2,lamdasat2,betasat2,1)

	          write(41,'(f10.4,1x,f6.2,6(1x,f7.2))') 
     1        etime,elength,nustart,nustop,lamdasat1-lamdas,betasat1,
     2        lamdasat2-lamdas, betasat2


!	          write(*,*) etime,elength,nustart,nustop
c		  write(*,*) 'manstart,ecc,nustart ',manstart,ecc,nustart	          
c		  write(*,*) 'manstop,ecc,nustop ',manstop,ecc,nustop	          
		 END IF
               END IF
            END IF
         ELSE
            EFLAG = .TRUE.    ! in eclipse
            IF (.NOT.EFLAGOLD) THEN     ! out of eclipse last time?
               ESTART = IUT
               manstart=man*rd
            END IF
            JDAY = INT(IUT/(24.*3600.*60.))
            REM = IUT - 24.*3600.*60.*JDAY
            IHR = INT(REM/(3600.*60.))
            REM = REM - 3600.*60.*IHR
            IMIN = INT(REM/3600.)
            ISEC = (REM - 3600.*IMIN + 0.1)/60.
            JDAY = JDAY + 1             ! Start of year is Day 1
            HEIGHT = dist/1000. - 6370.
            if(.not.NORAPCS) WRITE (40,200) JDAY,IHR,IMIN,ISEC,HEIGHT
200         FORMAT(' IN ECLIPSE ',I3,2X,I2,':',I2,':',I2,8X,'ALTITUDE ',
     2              F7.0,' km')
         END IF

         EFLAGOLD = EFLAG


         IF (ETEST.and.(.NOT.RIG)) RETURN

	 IF(RIG) then
	  IF(EFLAG) then
            FLAG = .TRUE.      ! Can't observe because of eclipse constraint
	    flage=.true.
	    sate1(1) = sat(1)
	    sate1(2) = sat(2)
	    sate1(3) = sat(3)
            IF (noout) GO TO 1000
            C(20) = 1
	  END IF
	 ELSE
          IF (EFLAG.OR.((IUT-ESTART).LE.(DUR*ECLIPMULT+ECLIPADD))) THEN
            FLAG = .TRUE.      ! Can't observe because of eclipse constraint
	    flage=.true.
	    sate1(1) = sat(1)
	    sate1(2) = sat(2)
	    sate1(3) = sat(3)
            IF (noout) GO TO 1000
            C(20) = 1          
	  END IF
	 END IF

!	    write(*,*) (IUT-IUT1)/3600,(IUT-ESTART)/3600,flag


       END IF
       end if ! if((.NOT.POWERBUD).and.typsat.eq.1) then
            
	
	 do var=1,3

	  j(var)=dcos(angyz*dr)*j0(var)+dsin(angyz*dr)*k0(var)
	  k(var)=-dsin(angyz*dr)*j0(var)+dcos(angyz*dr)*k0(var)

	 end do


	  rot(1,1)=i(1)
	  rot(1,2)=i(2)
	  rot(1,3)=i(3)

	  rot(2,1)=j(1)
	  rot(2,2)=j(2)
	  rot(2,3)=j(3)

	  rot(3,1)=k(1)
	  rot(3,2)=k(2)
	  rot(3,3)=k(3)


C convert sun, moon and earth vectors to X2,Y2 and Z2 frame


	do var=1,3
	  rsun2(var)  = 0.0d0
	  rmoon2(var) = 0.0d0
	  rearth2(var)= 0.0d0
	 do var2=1,3

	  rsun2(var)  = rsun2(var)  + rot(var,var2)*rsun1(var2)
	  rmoon2(var) = rmoon2(var) + rot(var,var2)*rmoon1(var2)
	  rearth2(var)= rearth2(var)+ rot(var,var2)*rearth1(var2)

	 end do
	end do


	 call NORM(rsun2,nsun2)
	 call NORM(rmoon2,nmoon2)
	 call NORM(rearth2,nearth2)


	if(plotsat) then
	 if(angyz.eq.yz(1)) then
	  call dotp(ie,nearth2,dp1,ang1)
	  ang_source(1)= ang1
	  call dotp(ie,nmoon2,dp1,ang1)
	  ang_source(2)= ang1
	  call dotp(ie,nsun2,dp1,ang1)
	  ang_source(3)= ang1
	 end if
	end if

	if(out2) then
	 write(20,*) ' '
 	 write(20,*) 'unit vectors after yz rotation = rotation matrix'
	 write(20,*) (i(var),var=1,3)
	 write(20,*) (j(var),var=1,3)
	 write(20,*) (k(var),var=1,3)
	 write(20,*) 'rsun2'
	 write(20,*) (rsun2(var),var=1,3)
	 write(20,*) 'rmoon2'
	 write(20,*) (rmoon2(var),var=1,3)
	 write(20,*) 'rearth2'
	 write(20,*) (rearth2(var),var=1,3)
	 write(20,*) 'nsun2'
	 write(20,*) (nsun2(var),var=1,3)
	 write(20,*) 'nmoon2'
	 write(20,*) (nmoon2(var),var=1,3)
	 write(20,*) 'nearth2'
	 write(20,*) (nearth2(var),var=1,3)
	 write(20,*) ' '
	end if

	 	  
	flag=.true.
	flagrad=.false.


C Passive Cooling: Radiator-Earth Normal constraint

C Require that in 1 orbit constraint must be met for 21 out of 24 hrs

	if(apply(6)) then

		n(1)=dcos(PCS*dr)
       	 	n(2)=0.0d0
		n(3)=dsin(PCS*dr)


	  call DOTP(n,nearth2,dp,ang)

	 if(out2) then
	  write(20,*) '2.1c angle earth vector and radiator normal ',ang
	  write(20,*) '2.1c constraint: ang must be ge NoR+ange i.e. ',
     1 	  Nor+ange
	 end if

	 if(ang.le.NoR+ange) then
	  flagrad=.true.
	  C(6)=1
	 end if

	if((.not.VIS).and.noout.and.(.not.complot)) goto 1000

        end if






C High Gain antenna

	if(apply(1)) then
	if(out2) write(20,*) '**1.4 telemetry antenna**'

	DO var3=1,nst

	flag1(var3)=.true.
c             write(*,*) '+++++++VISIBLE(var3)=',VISIBLE(var3)
	 if(VISIBLE(var3).or.COMPLOT.or.plotsat) then

	    x(1)=tel(1,var3)
	    x(2)=tel(2,var3)
	    x(3)=tel(3,var3)

	   call DIFF(sat,x,x1)

	   do var=1,3
	      x2(var,var3)=0.0d0
	    do var2=1,3
	      x2(var,var3)=x2(var,var3)+rot(var,var2)*x1(var2)
	    end do
	   end do

	   call NORM(x2(1,var3),n)

	end if 

	 if(VISIBLE(var3).or.COMPLOT) then
  
	 if(COMPLOT) then

	    xa(1)=tela(1,var3)
	    xa(2)=tela(2,var3)
	    xa(3)=tela(3,var3)

	   call DIFF(sata,xa,x1a)

	   do var=1,3
	      x2a(var)=0.0d0
	    do var2=1,3
	      x2a(var)=x2a(var)+rot(var,var2)*x1a(var2)
	    end do
	   end do

	   call NORM(x2a,na)

	    xb(1)=telb(1,var3)
	    xb(2)=telb(2,var3)
	    xb(3)=telb(3,var3)

	   call DIFF(satb,xb,x1b)

	   do var=1,3
	      x2b(var)=0.0d0
	    do var2=1,3
	      x2b(var)=x2b(var)+rot(var,var2)*x1b(var2)
	    end do
	   end do

	   call NORM(x2b,nb)

	end if

C Major change: Redefine telemetry antenna options in terms of
C HoTLIM dependence on Azimuth


C For NORAPCS:
C Define Azimuth=0 along +Z axis Azimuth=+90 along +Y axis
C For RAPCS
C Simpler to define azimuth in a plane perpendicular to pointing
C direction of telemetry antenna which lies in XZ plane
C DWM 15-MAR-91
C NOTE: in our coordinate system +X points towards the source
C       and solar panels lie along Y-axis
C RADIOASTRON project adopts this convention
C VSOP project adopts +Z points towards source
C       and solar panels lie along Y-axis
C When using VSOP engineering drawings change Z(X)-axis to X(Z)-axis
C to use our conventions
        



	if(.not.NORAPCS) TELOPT=9


C TELOPT=9: RADIOASTRON telemetry option

	  if(TELOPT.eq.9) then

	   h(1)=-1.0d0*dcos(eps*dr)
	   h(2)=0.0
	   h(3)=dsin(eps*dr)

c	   numaz=1
c           azmin(1)=0.0d0
c           azmax(1)=360.d0
c           HoTlim(1) = HoTRA
	   numaz=6
c           azmin(1)=0.0d0
c           azmax(1)=12.5d0
c           azmin(2)=12.5d0
c           azmax(2)=175.5d0	   
c           azmin(3)=175.5d0
c           azmax(3)=180.0d0	   
c           azmin(4)=180.0d0
c           azmax(4)=184.5d0
c           azmin(5)=184.5d0
c           azmax(5)=347.5d0	   
c           azmin(6)=347.5d0
c           azmax(6)=360.d0	   
c           HoTlim(1) = HoTRA
           azmin(1)=0.0d0
           azmax(1)=12.5d0
           azmin(2)=12.5d0
           azmax(2)=150.5d0	   
           azmin(3)=150.5d0
           azmax(3)=180.d0	   
           azmin(4)=180.d0
           azmax(4)=209.5d0
           azmin(5)=209.5d0
           azmax(5)=347.5d0
           azmin(6)=347.5d0
           azmax(6)=360.5d0	              
           HoTlim(1) = HoTRA           
c          HoTlim(2) = (90.0d0-50.0d0)
	  else

	  h(1)= -1.0d0
	  h(2)=  0.0d0
	  h(3)=  0.0d0

	  end if


			do var=1,3
			 east(1)= 0.0d0
	    		 east(2)= 1.0d0
	                 east(3)= 0.0d0
			end do


			  call vecp(h,east,n1)
			  call norm(n1,north)
			
	
			 call dotp(h,n,dp1,ang1)
			 zenith=180.0d0-ang1
		
			 call dotp(n,east,dp1,ang1)
			 call dotp(n,north,dp2,ang2)

			az=DATAN2(DCOS(ang1*dr),DCOS(ang2*dr))/dr

	                if(az.lt.0.0) az=az+360.0d0
	                az=az+180.0d0	                
	                if(az.lt.0.0) az=az+360.0d0
	                
	                n3(1)=-n(1)*dcos(eps*dr)+n(3)*dsin(eps*dr)
	                n3(2)=n(2)
			n3(3)=-n(1)*dsin(eps*dr)-n(3)*dcos(eps*dr)
			arg1=-n3(3)/dsqrt(1.0d0-n3(2)*n3(2))
			arg2=n3(1)/dsqrt(1.0d0-n3(2)*n3(2))
			psi0=atan2(arg1,arg2)/dr
			arg1=dsin(del_u1*dr)/dsqrt(1.0d0-n3(2)*n3(2))
			dpsi=dasin(arg1)/dr
			psipr=psi0-dpsi
			arg1=n3(2)/dcos(del_u1*dr)
			fipr=dasin(arg1)/dr-del_u2
			
	if(TELOPT.eq.9) then		
		  do var=1,numaz
		    if(az.ge.azmin(var).and.az.lt.azmax(var)) then
c	if(var.eq.1)   	Hot=Hotlim(1)-12.5d0+1.0d0*az
c	if(var.eq.2.or.var.eq.5)      Hot=Hotlim(1)
c	if(var.eq.3)   	Hot=Hotlim(1)-1.0d0*(az-azmin(var))
c	if(var.eq.4)   	Hot=Hotlim(1)-4.5d0+1.0d0*(az-azmin(var))	
c	if(var.eq.6)   	Hot=Hotlim(1)-1.0d0*(az-azmin(var))	
	if(var.eq.1)   	then
	fim=dasin(az/12.5d0)
	Hot=Hotlim(1)+12.5*dcos(fim)
	endif
	if(var.eq.2.or.var.eq.5)      Hot=Hotlim(1)
	if(var.eq.3)   	then
	fim=dasin((180.0d0-az)/29.5d0)
	Hot=Hotlim(1)-29.5*dcos(fim)	
	endif
	if(var.eq.4)   	then
	fim=dasin((az-180.0d0)/29.5d0)
	Hot=Hotlim(1)-29.5*dcos(fim)	
	endif	
	if(var.eq.6) then
	fim=dasin((360.0d0-az)/12.5d0)
	Hot=Hotlim(1)+12.5*dcos(fim)	
	endif	
	 endif
c         hot=73
                  end do	
	else
	  do var=1,numaz
        if(az.ge.azmin(var).and.az.lt.azmax(var)) Hot=Hotlim(var)
                  end do
        endif

	   call DOTP(h,n,dp,ang1)
c		print*,'++++++++++++',angyz,az,ang1
	 
	if(VISIBLE(var3)) then
c	 if(ang1.le.Hot) flag=.false.
	 if(psipr.le.90.0d0.and.psipr.ge.-73.0d0.and.
     1	 fipr.le.90.0d0.and.fipr.ge.-90.0d0) flag=.false.	 
        end if

c	 if(ang1.le.Hot) flag1(var3)=.false.
	 if(psipr.le.90.0d0.and.psipr.ge.-73.0d0.and.
     1	 fipr.le.90.0d0.and.fipr.ge.-90.0d0) flag1(var3)=.false.	 	 
c	write(*,*) 'VISIBLE(var3),angyz,az,ang1,hot=',
c     1	VISIBLE(var3),angyz,az,ang1,hot 	


	 if(out2) then
	  write(20,*) ' '
	  write(20,*) '1.4 satellite is VISIBLE from telemetry station ',var3
	  write(20,*) '1.4 telemetry station vector X-frame'
	  write(20,*) tel(1,var3),tel(2,var3),tel(3,var3)
	  write(20,*) '1.4 telemetry station vector X1-frame'
	  write(20,*) (x1(var),var=1,3)
	  write(20,*) '1.4 telemetry station vector X2-frame'
	  write(20,*) (x2(var,var3),var=1,3)
	  write(20,*) '1.4 normalised telemetry station vector X2-frame'
	  write(20,*) (n(var),var=1,3)
C	  write(20,*) '1.4 epsilon ',eps
	  write(20,*) '1.4 telemetry antenna pointing vector X2-frame'
	  write(20,*) (h(var),var=1,3)
	  write(20,*) '1.4 angle between telemetry antenna pointing dir and'
	  write(20,*) '1.4 telemetry station ',ang1
	  write(20,*) 'az= ',az 
	  write(20,*) 'Hot= ',Hot 	  
	  write(20,*) 'psi= ',psipr,'fi=',fipr
	 end if



	 if(out2) then
	  if(flag) then
	    write(20,*) '1.4 High antenna constraint NOT met '
	  else
	    write(20,*) '1.4 High antenna constraint  met'
	  end if
	 end if

	 else
	  if(out2) then
	 write(20,*) '1.4 satellite NOT VISIBLE from telemetry station ',var3
	 write(20,*) '1.4 telemetry station vector X-frame'
	 write(20,*) tel(1,var3),tel(2,var3),tel(3,var3)
	  end if
	end if
c           	 write(20,*) 'angyz=',angyz
		 
	if(COMPLOT.and.IUT.ge.IUT1) then

c For RADIOASTRON elevation defined as (180 degrees -angle between
c tracking station and telemetry antenna axis)
c For VSOP        elevation defined as (180 degrees -angle between
c tracking station and source direction)
c Azimuth=0 defined when y component of tracking station vector is zero  
c if y-component is positive then azimuth lies between 0 and 180 degrees
C Two different definitions of elevations are required because skyline
c is easiest to determine for 2 satellites in different ways
c DWM 12-MAR-91

	                 if(IUT.eq.IUT1.and.var3.eq.1) then
	                   write(25,*) numaz
	                   do var=1,numaz
	                    write(25,*) azmin(var),azmax(var),Hotlim(var)
                           end do
	                 end if

	               
 
	
			 call dotp(h,na,dp1,ang1)
			 zenitha=180.0d0-ang1

			 call dotp(na,east,dp1,ang1)
			 call dotp(na,north,dp2,ang2)

			aza=DATAN2(DCOS(ang1*dr),DCOS(ang2*dr))/dr
	                if(aza.lt.0.0) aza=aza+360.0d0


			 call dotp(h,nb,dp1,ang1)
			 zenithb=180.0d0-ang1

			 call dotp(nb,east,dp1,ang1)
			 call dotp(nb,north,dp2,ang2)

			azb=DATAN2(DCOS(ang1*dr),DCOS(ang2*dr))/dr
	                if(azb.lt.0.0) azb=azb+360.0d0


	                azdot=azb-aza
	                if(abs(azb-aza+360.0d0).lt.abs(azdot)) azdot=azb-aza+360.0d0
	                if(abs(azb-aza-360.0d0).lt.abs(azdot)) azdot=azb-aza-360.0d0

		
			azdot=azdot/azeltime ! in units of deg/minute
			zenithdot=(zenithb-zenitha)/azeltime ! in units of deg/minute

 
			timehr=(IUT-dble(IUT1))/(60.0d0*60.0d0*60.0d0)

			if(VISIBLE(var3)) then
                             VISout=1.0
                        else
                             VISout=0.0
                        end if

	                  if(flag1(var3)) then
                            noflag=0.0
                          else
			   noflag=1.0
			  end if
		 
			 write(25,346) var3,az,azdot,zenith,zenithdot,VISout,noflag,timehr


346			FORMAT(2x,i3,2x,6(F8.3,2x),f10.5)

	    

	   end if

!	do var=1,nst
!	 write(*,*) 'ist,visible(ist),flag1(ist): ',var,visible(var),flag1(var)
!	end do

	end do

	if(.not.NORAPCS) then
	 if(out2) then
	  write(20,*) '1.4 angle between telemetry antenna pointing dir and'
	  write(20,*) '1.4 a telemetry station must be le ',HoT
	  write(20,*) '1.4 (provided telemetry station can see satellite)'
	 end if
	end if


	else     ! if apply(1) then

	if(VIS) flag=.false.

	end if   ! if apply(1) then

	if(flag) then
	 if(noout) goto 1000
	 c(1)=1
	end if 


	flag=flag.or.flage



C Power generating

	if(apply(2).or.apply(3)) then
	if(out2) write(20,*) '**1.2 power generating**'

C	Syz(1)=0.0d0
C	Syz(2)=nsun2(2)
C	Syz(3)=nsun2(3)

C	call DOTP(Syz,ke,dp,ang)
	
C	if(out2) then
C	write(20,*) '1.2a normalised sun vector projected onto yz-plane'
C	write(20,*) (Syz(var),var=1,3)
C	write(20,*) '1.2a angle between projected sun vector and +z axis'
C	write(20,*) ang
C	write(20,*) '1.2a constraint: 180-this angle le ',nZoSyz
C	end if

C	ang=180.0d0-ang



C	if(ang.ge.nZoSyz) then
C	 flag=.true.
C	 if(noout) goto 1000
C	 c(2)=1
C	end if

C 1.2a Discussion with Gurvits in Dwingeloo May-1990 lead to a change in this
C constraint

	if(nsun2(3).le.0.0d0) then
	 if(nsun2(2).gt.dsin(30.0d0*dr)) c(2)=1
	else
	 if(nsun2(1).gt.dcos(30.0d0*dr)) c(2)=1
	end if

	if(apply(2).and.(c(2).eq.1)) then
	    flag=.true.
	 if(noout) goto 1000
	end if

	  if(apply(2).and.out2) then
	   if(nsun2(3).le.0.0d0) then
	    write(20,*) '1.2a z-comp of sun vector less than 0.0'
	    write(20,*) '1.2a y-comp of sun vector is ',nsun2(2)
	    write(20,*) '1.2a constraint: this must be less than ',dsin(30.0d0*dr)
	   else
	    write(20,*) '1.2a z-comp of sun vector greater than 0.0'
	    write(20,*) '1.2a x-comp of sun vector is ',nsun2(1)
	    write(20,*) '1.2a constraint: this must be less than ',dcos(30.0d0*dr)
	   end if
	  end if
	  

C	Szx(1)=nsun2(1)
C	Szx(2)=0.0d0
C	Szx(3)=nsun2(3)
	
C	call DOTP(Szx,ke,dp,ang)

C	if(out2) then
C	write(20,*) '1.2b normalised sun vector projected onto zx-plane'
C	write(20,*) (Szx(var),var=1,3)
C	write(20,*) '1.2b angle between projected sun vector and +z axis'
C	write(20,*) ang
C	write(20,*) '1.2b constraint: 180-this angle le ',nZoSzx
C	end if

C	ang=180.0d0-ang

C	if(ang.ge.nZoSzx) then
C	 flag=.true.
C	 if(noout) goto 1000
C	 c(3)=1
C	end if

C 1.2b Discussion with Gurvits Dwingeloo May-1990 
C leads to a change in this constraint

	
	if(nsun2(3).gt.0.0d0) then
	  c(3)=1
	else
	 if(nsun2(1).gt.0.0d0) then
	   xlim= -1.0d0*nsun2(3)*dtan(30.0d0*dr)
          if(nsun2(1).gt.xlim) c(3)=1
	 end if
	end if


	if(apply(3).and.(c(3).eq.1)) then
	    flag=.true.
	 if(noout) goto 1000
	end if

	  if(apply(3).and.out2) then
	   if(nsun2(3).le.0.0d0) then
	    write(20,*) '1.2b z-comp of sun vector is',nsun2(3)
	    write(20,*) '1.2b x-comp of sun vector is ',nsun2(1)
	    write(20,*) '1.2b constraint: projected sun vector in xz-plane must ge'
	    write(20,*) '1.2b 60 deg from +x axis'
	   else
	    write(20,*) '1.2b z-comp of sun vector greater than 0.0'
	    write(20,*) '1.2b constraint: z-comp must be less than 0.0'
	   end if
	  end if

!	write(*,*) TYPSAT,nsun2(1),nsun2(2),nsun2(3),c(3)

	end if



C Passive cooling

	if(apply(4).or.apply(5)) then

	if(out2) write(20,*) '**2.1 passive cooling**'

	
	n(1)=dcos(PCS*dr)
        n(2)=0.0d0
	n(3)=dsin(PCS*dr)

	call DOTP(n,nsun2,dp,ang)

	if(apply(4).and.out2) then
	write(20,*) '2.1a radiator normal direction'
	write(20,*) (n(var),var=1,3)
	write(20,*) '2.1a Normalised sun vector X-2 frame'
	write(20,*) (nsun2(var),var=1,3)
	write(20,*) '2.1a angle between sun and radiator normal ',ang
	write(20,*) 'constraint: angle must be ge ',NoS
	end if

	if(apply(4).and.(ang.le.NoS)) then
	 flag=.true.
	 if(noout) goto 1000
	 c(4)=1
	end if



	Syz(1)=0.0d0
	Syz(2)=nsun2(2)
	Syz(3)=nsun2(3)

	call DOTP(Syz,ke,dp,ang)

	if(apply(5).and.out2) then
	write(20,*) '2.1b projection of normalised sun vector onto yz plane '
	write(20,*) (Syz(var),var=1,3)
	write(20,*) '2.1b angle between this projection and +Z direction'
	write(20,*) ang
c	write(20,*) '2.1b constraint:180-ang must be le ',Syzonz
	write(20,*) '2.1b constraint:ang must be le ',Syzonz	

	end if

c	ang=180.0d0-ang
	    ang=dabs(ang)	
	if(apply(5).and.(ang.ge.SyzonZ)) then
	 flag=.true.
	 if(noout) goto 1000
	 c(5)=1
	end if

	end if
        if(out2.and.c(1).ne.1.and.c(5).ne.1)
     1    	write(21,*) 'ang= ',ang,' psi=',psipr,' fi=',fipr

C Cooling and Thermal control

	if(apply(7)) then

c	call DOTP(ke,nsun2,dp,ang)
	call DOTP(ke,nsun2,dp,ang)	
c	if(ang.le.ZoS) then
	if(ang.ge.ZoS) then	
	 flag=.true.
	 if(noout) goto 1000
	 c(7)=1
	end if

	if(out2) then
	write(20,*) '**1.1 cooling and thermal control**'
	write(20,*) '1.1 angle between sun and +z axis ',ang
	write(20,*) '1.1 constraint: this angle must be ge ',ZoS
	end if

	end if

C Star sensors

c	if(apply(8).or.apply(9).or.apply(10)) then
	if(apply(8)) then	

	if(out2) write(20,*) '**1.3 star sensors**'


c	d1(1)=0.0d0
c	d1(2)=dcos(s1*dr)
c	d1(3)=-1.0d0*dsin(s1*dr)
	d1(1)=-dcos(su30)
	d1(2)=0.0d0
	d1(3)=-dsin(su30)


c	d2(1)=0.0d0
c	d2(2)=-1.0d0*dcos(s1*dr)
c	d2(3)=-1.0d0*dsin(s1*dr)
	d2(1)=-dsin(su15)*dsin(su45)
	d2(2)=-dcos(su45)
	d2(3)=-dcos(su15)*dsin(su45)


c	d3(1)=-1.0d0*dcos(s2*dr)
c	d3(2)=0.0d0
c	d3(3)=1.0d0*dsin(s2*dr)
	d3(1)=-dsin(su15)*dsin(su45)
	d3(2)=dcos(su45)
	d3(3)=-dcos(su15)*dsin(su45)

	if(out2) then
	write(20,*) '1.3 star sensor unit vectors'
	write(20,*) (D1(var),var=1,3)
	write(20,*) (D2(var),var=1,3)
	write(20,*) (D3(var),var=1,3)
	end if

c	count=0


c	call DOTP(d1,nsun2,dp,ang)
c	if(ang.le.SoD) count=count+1
c        if(apply(8).and.out2) then 
c         write(20,*) '1.3a angle between sensor-1 and sun ',ang
c	end if
c	call DOTP(d2,nsun2,dp,ang)
c	if(ang.le.SoD) count=count+1
c	if(apply(8).and.out2) write(20,*) '1.3a angle between sensor-2 and sun ',ang
c	call DOTP(d3,nsun2,dp,ang)
c	if(ang.le.SoD) count=count+1
c	if(apply(8).and.out2) then
c	 write(20,*) '1.3a angle between sensor-3 and sun ',ang
c	 write(20,*) '1.3a constraint: 2 out 3 angle must be ge ',SoD
c	end if
c
c	if(apply(8).and.(count.ge.2)) then
c	 flag=.true.
c	 if(noout) goto 1000
c	 C(8)=1
c	end if

	call DOTP(d1,nsun2,dp,angs1)
	call DOTP(d2,nsun2,dp,angs2)
	call DOTP(d3,nsun2,dp,angs3)
	if(apply(8).and.out2) then
	 write(20,*) ' angle between sensor-1 and sun ',angs1
	 write(20,*) ' angle between sensor-2 and sun ',angs2	 
	 write(20,*) ' angle between sensor-3 and sun ',angs3	 
	 write(20,*) ' constraint:  angle must be ge ',SoD
	end if
	if(angs1.gt.Sod) then
	fls1=.true.
	else
	fls1=.false.
	endif
	if(angs2.gt.Sod) then
	fls2=.true.
	else
	fls2=.false.
	endif
	if(angs3.gt.Sod) then
	fls3=.true.
	else
	fls3=.false.
	endif
	call DOTP(d1,nmoon2,dp,angm1)
	call DOTP(d2,nmoon2,dp,angm2)
	call DOTP(d3,nmoon2,dp,angm3)	
	if(apply(8).and.out2) then
	 write(20,*) ' angle between sensor-1 and moon ',angm1
	 write(20,*) ' angle between sensor-2 and moon ',angm2	 
	 write(20,*) ' angle between sensor-3 and moon ',angm3	 
	 write(20,*) ' constraint:  angle must be ge ',MoD
	end if
	if(angm1.gt.Mod) then
	flm1=.true.
	else
	flm1=.false.
	endif
	if(angm2.gt.Mod) then
	flm2=.true.
	else
	flm2=.false.
	endif
	if(angm3.gt.Mod) then
	flm3=.true.
	else
	flm3=.false.
	endif
	call DOTP(d1,nearth2,dp,ange1)
	call DOTP(d2,nearth2,dp,ange2)
	call DOTP(d3,nearth2,dp,ange3)	
	if(apply(8).and.out2) then
	 write(20,*) ' angle between sensor-1 and earth ',ange1
	 write(20,*) ' angle between sensor-2 and earth ',ange2	 
	 write(20,*) ' angle between sensor-3 and earth ',ange3	 
	 write(20,*) ' constraint:  angle must be ge ',EoD+ange
	end if
	if(ange1.gt.(Eod+ange)) then
	fle1=.true.
	else
	fle1=.false.
	endif
	if(ange2.gt.(Eod+ange)) then
	fle2=.true.
	else
	fle2=.false.
	endif
	if(ange3.gt.(Eod+ange)) then
	fle3=.true.
	else
	fle3=.false.
	endif
	fl12=fls1.and.fls2.and.flm1.and.flm2.and.fle1.and.fle2
	fl23=fls2.and.fls3.and.flm2.and.flm3.and.fle2.and.fle3
	fl13=fls1.and.fls3.and.flm1.and.flm3.and.fle1.and.fle3
	if(fl12.or.fl23.or.fl13) then
	else
	flag=.true.
	if(noout) goto 1000
	c(8)=1
	endif
c	count=0

c	call MINANG(rsun2,rmoon2,radm,d1,ang)
c	if(ang.le.MoD) count=count+1
c	if(apply(9).and.out2) then
c        write(20,*) '1.3b min angle between sensor-1 and moon limb ',ang
c	end if
c	call MINANG(rsun2,rmoon2,radm,d2,ang)
c	if(ang.le.MoD) count=count+1
c	if(apply(9).and.out2) then
c        write(20,*) '1.3b min angle between sensor-2 and moon limb ',ang
c        end if
c	call MINANG(rsun2,rmoon2,radm,d3,ang)
c	if(ang.le.MoD) count=count+1
c	if(apply(9).and.out2) then
c	write(20,*) '1.3b min angle between sensor-3 and moon limb ',ang
c	write(20,*) '1.3b 2 out of 3 min angles have to be ge ',MoD
c	end if
c
c	if(apply(9).and.(count.ge.2)) then
c	 flag=.true.
c	 if(noout) goto 1000
c	 c(9)=1
c	end if



c	count=0
c
c	call MINANG(rsun2,rearth2,rade,d1,ang)
c	if(ang.le.EoD) count=count+1
c	if(apply(10).and.out2) then
c        write(20,*)'1.3c min angle between sensor-1 and earth limb ',ang
c	end if
c	call MINANG(rsun2,rearth2,rade,d2,ang)
c	if(ang.le.EoD) count=count+1
c	if(apply(10).and.out2) then
c        write(20,*)'1.3c min angle between sensor-2 and earth limb ',ang
c        end if
!c Wrong star sensor used. change d2 to d3 DWM 7-Aug-95
!c	call MINANG(rsun2,rearth2,rade,d2,ang)
c	call MINANG(rsun2,rearth2,rade,d3,ang)
c	if(ang.le.EoD) count=count+1
c	if(apply(10).and.out2) then
c	 write(20,*) '1.3c min angle between sensor-3 and earth limb ',ang
c	 write(20,*) '1.3c 2 out of 3 min angles have to be ge ',EoD
c	end if
c
c
c	if(apply(10).and.(count.ge.2)) then
c	 flag=.true.
c	 if(noout) goto 1000
c	 c(10)=1
c	end if

	end if


C Active cooling system

	
	if(apply(11)) then

	call DOTP(nsun2,kem,dp,ang)

	if(ang.le.Soz) then
	 flag=.true.
	 if(noout) goto 1000
	 c(11)=1
	end if

	if(out2) then
	write(20,*) '**2.2 active cooling system**'
c	write(20,*) '2.2a angle between sun and +Z direction ',ang
	write(20,*) '2.2a angle between sun and -Z direction ',ang	
	write(20,*) '2.2a constraint: ang must be ge ',Soz
	write(20,*) '2.2b dist,rmin ',dist,rmin
	end if
	end if	

	if(apply(12)) then
	 if(dist.le.rmin) then

c	   call DOTP(nearth2,ke,dp,ang)
	   call DOTP(nearth2,kem,dp,ang)	   

	  if(out2) then
c	  write(20,*) '2.2b angle between earth and +Z direction ',ang
	  write(20,*) '2.2b angle between earth and -Z direction ',ang	  
	  write(20,*) '2.2b constraint: angle must be ge ZoR+ange=',ZoR+ange
	  end if

	   if(ang.le.ZoR+ange) then
	    flag=.true.
	    if(noout) goto 1000
	    C(12)=1
	   end if

	 end if

	end if




C Cold plate

	if(apply(13)) then

	call DOTP(nsun2,ie,dp,ang)

	if(out2) then
	write(20,*) '**2.3 cold plate**'
	write(20,*) '2.3 angle between sun and +X direction ',ang
	write(20,*) '2.3 180-angle must be le ',SonX
	end if

	ang=180.0d0-ang

	if(ang.ge.SonX) then
	 flag=.true.
	 if(noout) goto 1000
	 C(13)=1
	end if

	end if

1010	CONTINUE

C Radioastronomical receivers

	if(apply(14).or.apply(15).or.apply(16)) then

	call DOTP(nsun2,ie,dp,ang)

	if(apply(14).and.out2) then
	write(20,*) '**2.4 radioastronomical receivers'
	write(20,*) '2.4a angle between sun and +X axis ',ang
      write(20,*) '2.4a constraint: angle must be ge ',SUNANG,
     1  ' and le ',sunang1
	end if
	
!	
! 08-Aug-97 test for more limited range of sun angles
! 18-Jan-98 upgrade to use sunavoid array

          bad_sun_ang = .false.
         
         if(TYPSAT .eq. 1) then
                 
          do var = 1, int(nsunavoidmax/2)
          
          if((ang .ge. sunavoid(2*var-1)) .and. (ang .le. sunavoid(2*var))) then 
             bad_sun_ang = .true.           
          end if         
         
          end do
                  
          
          if(NOSUNANG) then
            bad_sun_ang = .false.
          end if
         
         else
c            print*,'ang,sunang,sunang1=',ang,sunang,sunang1
          if( ang.le.SUNANG.or.ang.ge.sunang1 ) then
           bad_sun_ang = .true.
          end if
          
         end if

	if(apply(14).and.(bad_sun_ang)) then
	 flag=.true.
	 if(noout) goto 1000
	 C(14)=1
	end if


	call DOTP(nmoon2,ie,dp,ang)

	if(apply(15).and.out2) then
	write(20,*) 'angle between moon and +X axis ',ang
	write(20,*) 'constraint: angle must be ge ',Rmox
	end if

	if(apply(15).and.(ang.le.RmoX)) then
	 flag=.true.
	 if(noout) goto 1000
	 c(15)=1
	end if

1015	continue

	call DOTP(nearth2,ie,dp,ang)

	if(apply(16).and.out2) then
	write(20,*) '2.4b angle between earth and +X axis ',ang
	write(20,*) '2.4b constraint: angle-ange must be ge ',RoX+ange 	
	end if


	if(apply(16).and.(ang.le.RoX+ange)) then
	 flag=.true.
	 if(noout) goto 1000
	 C(16)=1
	end if

	end if

C Monitoring star sensor

	if(apply(17).or.apply(18).or.apply(19)) then

	if(apply(17).and.out2) write(20,*) '**2.5 monitoring star sensor**'

	call DOTP(nsun2,ax0,dp,angxs)
	call DOTP(nmoon2,ax0,dp,angxm)
	call DOTP(nearth2,ax0,dp,angxe)
c	call DOTP(nsun2,ie,dp,ang)

	if(apply(17).and.out2) then	
c	write(20,*) '2.5a angle between sun and +X axis ',ang
c	write(20,*) '2.5a constraint: angle must be ge ',mSoX
	write(20,*) '2.5a angle between sun, moon, earth and axis '
	write(20,*) 'ax0 ',angxs,angxm,angxe
	write(20,*) '2.5a constraint: angle must be ge ',angxsm,
     1  angxmm,angxem+ange
	end if

c	if(apply(17).and.(ang.le.mSoX)) then
	if(apply(17).and.((angxs.le.angxsm).or.(angxm.le.angxmm).
     1	or.(angxe.le.angxem+ange))) then	
c	 flag=.true.
c	 if(noout) goto 1000
	 C(17)=1
	end if

c	if(consver.eq.1) then
c	 call MINANG(rsun2,rmoon2,radm,ie,ang)
c	else
c	 call DOTP(nmoon2,ie,dp,ang)
c	end if

	call DOTP(nsun2,ax1,dp,angxs)
	call DOTP(nmoon2,ax1,dp,angxm)
	call DOTP(nearth2,ax1,dp,angxe)
	if(apply(17).and.out2) then
c	write(20,*) '2.5b min angle between moon limb and +X axis ',ang
c	write(20,*) '2.5b constraint: angle must be ge ',mRmoX
	write(20,*) '2.5b angle between sun, moon, earth and axis '
	write(20,*) 'ax1 ',angxs,angxm,angxe
	write(20,*) '2.5b constraint: angle must be ge ',angxsm,
     1  angxmm,angxem+ange
	end if


c	if(apply(18).and.(ang.le.mRmoX)) then
c	if(apply(18).and.((angxs.le.angxsm).or.(angxm.le.angxmm).
	if(apply(17).and.((angxs.le.angxsm).or.(angxm.le.angxmm).	
     1	or.(angxe.le.angxem+ange))) then	
c	 flag=.true.
c	 if(noout) goto 1000
c	 C(18)=1
	 C(17)=c(17)+1	 
	end if

c	call MINANG(rsun2,rearth2,rade,ie,ang)
	call DOTP(nsun2,ax2,dp,angxs)
	call DOTP(nmoon2,ax2,dp,angxm)
	call DOTP(nearth2,ax2,dp,angxe)
	if(apply(17).and.out2) then
c	write(20,*) '2.5c min angle between earth limb and +X axis ',ang
c	write(20,*) '2.5c constraint: angle must be ge ',mRoX
	write(20,*) '2.5c angle between sun, moon, earth and axis '
	write(20,*) 'ax2 ',angxs,angxm,angxe
	write(20,*) '2.5c constraint: angle must be ge ',angxsm,
     1  angxmm,angxem+ange
	end if


c	if(apply(19).and.(ang.le.mRoX)) then
c	if(apply(18).and.((angxs.le.angxsm).or.(angxm.le.angxmm).
	if(apply(17).and.((angxs.le.angxsm).or.(angxm.le.angxmm).	
     1	or.(angxe.le.angxem+ange))) then	
c	 flag=.true.
c	 if(noout) goto 1000
c	 C(19)=1
	 C(17)=1+c(17)	 
	end if

        if(c(17).le.1) 	then
    	c(17)=0	
	else	
	 flag=.true.
	 if(noout) goto 1000	
	c(17)=1

	endif
	end if
         
	
	
1020	CONTINUE

	do var=1,nst
	 if(.not.VISIBLE(var)) then
	  c(20+var)=1
	 end if
	end do



	do var=1,5
	 c(21+nst)=c(21+nst)+c(var)
	end do

	do var=7,20
	 c(21+nst)=c(21+nst)+c(var)
	end do

	if(c(21+nst).ge.1) c(21+nst)=1

	 c(22+nst)=1

	do var=1,nst
	 c(22+nst)=c(22+nst)*c(20+var)
	end do

	if(c(22+nst).ge.1) c(22+nst)=1

	c(23+nst)=c(21+nst)+c(22+nst)

	if(c(23+nst).ge.1) c(23+nst)=1

    	ALTITUDE = (DIST-RPERIGEE) / (RAPOGEE-RPERIGEE)

1000	continue

	if(.NOT.POWERBUD) then
	IF (ESTART.NE.-1.D05) THEN
	if(RIG.and.(.NOT.EFLAG)) then

	 if(IUT.eq.(ESTOP+IUT3)) then
	  if(DUR.GE.0.0001) then
	    TREC=(DUR*(ECLIPMULT-1.0d0)) + ECLIPADD
	  else
	    TREC=0.0
	  end if
	 end if	
    
	    TPERIOD=1.88830E-5*((asemi)**1.5) !period in 1/60 s

	  if(FLAG) then
	     if(TREC.GT.0.0d0) then
	     TREC=TREC-IUT3
	     c(20)=1
	    end if
	  else
	    TLEFT=ESTART+TPERIOD-IUT
	   if(TLEFT.LE.TREC) then
	    FLAG=.true.
	    c(20)=1
	    c(21+nst)=1
	    c(23+nst)=1
	   end if
	  end if


!	write(*,*) 'EFLAG,FLAG,TREC,TLEFT,IUT-IUT1'
!        write(*,*) EFLAG,FLAG,TREC/3600,TLEFT/3600,(IUT-IUT1)/3600
	  
	end if
	end if
	end if

! VSOP power budget
!------------------

	if(typsat.eq.1.and.POWERBUD) then

! VSOP solar power generation:

	  call power1(yepoch,mepoch,depoch,jdtoday,
     1                     asemi,ecc,dist,powergen)

! VSOP intially set battery to maximum capacity (56.0 amp hr)

	 tperiod=86164.09d0*60.0d0*((asemi/42164160.0d0)**(1.5d0)) !in 1/60 s

	 if(IUT.le.(IUT1-PRIOR)) then
	  batcap=56.0
	  teclip=IUT1-prior
! this ensures that if we are intially in an eclipse then the batteries get
! re-charged immediately after this first eclipse
	 end if


! VSOP power consumption


	      pshunt=0.0d0

! VSOP operating modes:

! (i) VLBI systems ON

	if(gps.le.0.0d0) then
	  preq=599.1d0-73.0d0-50.8d0  ! GPS off and no cooler
	else
	  mancrit=(pi)*(gps*3600.0d0/tperiod)
!
!	 if(dabs(man-pi).le.mancrit) then
!
! Error GPS was turned on high around apogee !!! DWM 12-Mar-92
!
	 if(dabs(pi-man).ge.(pi-mancrit)) then
!  GPS high mode (receiving) and no cooler
	  preq=599.1d0-73.0d0    
	 else
!  GPS low mode (propagating) and no cooler
	  preq=599.1d0-73.0d0-(50.8-10.8d0)
	 end if
	end if

!	write(*,*) 'dt,man,mancrit,preq ',(iut-iut1)/216000,man,mancrit,preq


	if(cooler) then
	 preq=preq+73.0d0  ! cooler power
	end if

! VLBI systems OFF
	
	 preqoff = preq-166.6d0 ! power required if VLBI systems OFF

! to ensure that the battery is fully re-charged before the next eclipse
! we must calculate when we have to switch the VLBI systems OFF


	  preqoff2=preqoff
	  mancrit=(pi)*(gps*3600.0d0/tperiod)

! if GPS is used then we need to calculate if we need to switch 
! the VLBI system off, assuming that the GPS is in high mode

	if(gps.gt.0.0d0) then
	 if(dabs(man-pi).ge.mancrit) then
	  preqoff2=preqoff+(50.8-10.8d0)
	 end if
	end if



          CALL NORM(RSUN,NSUN)

!	write(*,*) srcup(sat,nsun),sat,nsun,rsun

         if (SRCUP(SAT,NSUN)) then         ! not in eclipse

	    if(eclip) then
	      eclip=.false.
	    end if


! if other constraints are broken then switch off VLBI systems off
! only do this if RIG is true (RIG = Re-charge In Gaps)


	     if(RIG) then
	      if(c(23+nst).eq.1) then	    
	       preq=preqoff
	      end if
	     end if

! decide if we need to turn VLBI systems off so that battery is fully re-charged
! before next eclipse

  
	     if(batcap.lt.56.0d0) then
	       pappltot2 = powergen - preqoff2 + 30.0d0
	      if(pappltot2.ge.213.0d0) then
	        pappltot2=213.0d0
	      end if
	       dt=(24.0*1.2)*(60.0d0*60.0d0*60.0d0)*(56.0d0-batcap)/(0.9d0*pappltot2)
	      if(IUT.ge.(teclip-dt)) then
	       preq=preqoff
	      c(20)=1
	      c(21+nst)=1
	      c(23+nst)=1
	      flag=.true.
	      end if
	     end if


	     pappltot = powergen - preq + 30.0d0
	     pappl    = powergen - preq 


!	    if(pappl.le.0.0) then
!	     if(batcap.lt.56.0d0) then
!	      write(*,*) 'NOT enough solar power generated to support this mode !!!'
!	      c(20)=1
!	      c(21+nst)=1
!	      c(23+nst)=1
!	      flag=.true.
!	    end if
!	   end if

! try turning off VLBI systems to get enough power to battery
	  
	    if(pappltot.le.75.0d0) then	
	     if(batcap.lt.56.0d0) then
               preq=preqoff
	       pappltot = powergen - preq + 30.0d0
	       pappl    = powergen - preq
	       c(20)     =1
	       c(21+nst) =1
	       c(23+nst) =1
	       flag=.true. 
	      if(pappltot.le.75.0d0) then
                write(*,'(1x,I4,1x,I3,3(1x,I2))') 
     1          YEAR,JDAY,IHR,IMIN,ISEC
	       if(pappltot.lt.0.0d0) then
	        write(*,*) 'Problem: less than 75W applied to battery !'
	       else
	        write(*,*) 'Problem: less than 0 W applied to battery !!!'
	       end if
	      end if
	     end if
            end if

	    if(pappltot.ge.213.0d0) then
	      pappltot=213.0d0
	      pappl=213.0d0-30.0d0
	    end if

	   if(batcap.ge.56.0.and.pappltot.ge.0.0d0) then
	     pappl = 0.0d0
	   else
	     batcap=batcap + 0.9*pappltot*(IUT3/216000.0d0)/(24.0d0*1.2d0)
	    if(batcap.ge.56.0) then
	      batcap=56.0d0	    
	    end if
	   end if

!	   if(powergen.ge.(pappl+preq)) then
!	    pshunt=powergen-(pappl+preq)
!	   end if

	  pvlbi=preq-preqoff

	   else   ! in eclipse

	      c(20)     =1
	      c(21+nst) =1
	      c(23+nst) =1
	      flag=.true.


	    if(.not.eclip) then
	      eclip=.true.
	      teclip=IUT+tperiod
	    end if

! VLBI systems OFF in eclipse and 30.0 W is not needed for battery as it is
! discharging

	    preq     = preqoff-30.0 
	    powergen = 0.0d0
            pappl    = -preq
	    pvlbi    = 0.0d0

	    batcap   =batcap - preq*(IUT3/216000.0d0)/19.0d0

!	    write(*,*) 'In eclipse: ',(IUT-IUT1)/216000.d0,(teclip-IUT)/216000.d0

	 end if      !    if (SRCUP(SAT,NSUN)) then 



	    if(batcap.le.28.0d0) then
	      c(20)     =1
	      c(21+nst) =1
	      c(23+nst) =1
	      flag=.true.
	      write(*,*) 'Problem: battery capacity < 50% of maximum capacity'
	    end if          



	   if(POWERPLT.and.(IUT.GE.IUT1)) then
	    write(26,'(f12.5,5(2x,f8.3))') sngl((IUT-IUT1)/216000.d0),sngl(batcap),
     1      sngl(powergen),sngl(preq),sngl(pappl),sngl(pvlbi)
	   end if


	  end if

	    

	 obs(add,1)=angyz

! This code is not used ***DWM 5-Aug-91 
!	do var=1,5
!	 c(21+nst)=c(21+nst)+c(var)
!	end do

C	obs(add,2)=1.0 if BOTH the radiator normal-earth 
C       and all other constraints are met
C	obs(add,3)=1.0 all other constraints are met
C	obs(add,4)=1.0 if radiator normal-earth is met	

	if(.not.flag.and..not.flagrad) then
	 obs(add,2)=1.0d0
	else
	 obs(add,2)=0.0d0
        end if

	if(.not.flag) then
	 obs(add,3)=1.0d0
	else
	 obs(add,3)=0.0d0
        end if

	if(.not.flagrad) then
	 obs(add,4)=1.0d0
	else
	 obs(add,4)=0.0d0
        end if

!	write(*,*) 'inside subroutine: numyz ',angyz
!	write(*,*) 'flag flagrad ',flag,flagrad
!	write(*,*) 'obs(add,i) i=1,4'
c	write(*,*) obs(add,1),obs(add,2),obs(add,3),obs(add,4)



C	 write(*,*) 'constraints can be met angyz= ',angyz
C	 if(out1) write(19,*) 'constraints can be met'

C	write(*,*) 'IUT,angyz,flag,flagrad' ,IUT,angyz,flag,flagrad




	   if(out1.and.(angyz.eq.yz(1))) then          
	    do var3=1,23+nst
              cout(var3)=c(var3)
	    end do
	   end if


	do var=1,NST

	 if((.NOT.flag).and.(.NOT.flag1(var))
     1     .and.(VISIBLE(var))) then

	   if(out1) then          
	    do var3=1,20
              cout(var3)=0
	    end do	    
	    do var3=21+nst,23+nst
              cout(var3)=0
	    end do
	   end if


           if(Nviscon.eq.0) then
	     dyz=yz(2)-yz(1)

! Required to introduce angyz1 so that code works on ISAS HP
! Need to check what impact this has on rest of code
! DWM 12-jan-94

! Found that angyz1 was NOT being intialised correctly
! DWM 20-apr-94

	    angyz1 = angyz

	    if(angyz.gt.360.0d0) angyz1=angyz-360.0d0
	     yz(1)=angyz1
	     yz(2)=yz(1)+dyz
!	     write(*,*) 'new yz(1),yz(2) ',yz(1),yz(2)
	   end if

          Nviscon=Nviscon+1


	  if(.NOT.viscon(var)) then
	     yz1(var)=angyz
	     if(yz1(var).gt.360.0d0) yz1(var)=yz1(var)-360.0
!	     write(*,*) 'tracking station, yz1',var,yz1(var)

	  if(plotsat) then
	   call dotp(h,x2(1,var),dp1,ang1)
	   angte(var) =  ang1
	  end if 

	  end if ! if(.NOT.viscon(var)) 

	  viscon(var)=.true.


!	  write(*,*) 'viscon true: time(hr),Telmetry station #,angyz'
!	  write(*,*)  (IUT-IUT1)/(216000.0), var,angyz
	 end if

!	  write(*,*) (IUT-IUT1)/(216000.0),var,angyz,viscon(var)

	  if((TYPSAT.eq.2).or.(TYPSAT.eq.4))  then
	  
! Jump out of angyz loop if for all the tracking stations from which
! the orbiter is VISIBLE the spacecraft constraints are also met for
! at least one angyz

! Do NOT jump out of loop if yzplot is true !!!!
! DWM 26-Jul-93

	  if(.not.yzplot) then
	    if(Nviscon.eq.NTVIS) goto 2000
	  end if

	  end if


	end do


	end do ! angyz=yz(1),yz(2),yz(3)

2000	continue



	if(out1.and.(IUT.GE.IUT1)) then
!	write(*,*) (yz1(var),var=1,nst)

	if(nst.eq.1) then
	write(19,'(1x,f8.2)') yz1(1)
	write(19,'(1x,20i2,1x,i2,1x,3i2,1x,f6.2)') 
     1  (cout(var),var=1,24),ALTITUDE
	end if

	if(nst.eq.2) then
	write(19,'(1x,2f8.2)') (yz1(var),var=1,nst)
	write(19,'(1x,20i2,1x,2i2,1x,3i2,1x,f6.2)') 
     1  (cout(var),var=1,25),ALTITUDE
	end if

	if(nst.eq.3) then
	write(19,'(1x,3f8.2)') (yz1(var),var=1,nst)
	write(19,'(1x,20i2,1x,3i2,1x,3i2,1x,f6.2)') 
     1  (cout(var),var=1,26),ALTITUDE
	end if

	if(nst.eq.4) then
	write(19,'(1x,4f8.2)') (yz1(var),var=1,nst)
	write(19,'(1x,20i2,1x,4i2,1x,3i2,1x,f6.2)') 
     1  (cout(var),var=1,27),ALTITUDE
	end if

	if(nst.eq.5) then
	write(19,'(1x,5f8.2)') (yz1(var),var=1,nst)
	write(19,'(1x,20i2,1x,5i2,1x,3i2,1x,f6.2)') 
     1  (cout(var),var=1,28),ALTITUDE
	end if

	if(nst.eq.6) then
	write(19,'(1x,6f8.2)') (yz1(var),var=1,nst)
	write(19,'(1x,20i2,1x,6i2,1x,3i2,1x,f6.2)') 
     1  (cout(var),var=1,29),ALTITUDE
	end if

	if(nst.eq.7) then
	write(19,'(1x,7f8.2)') (yz1(var),var=1,nst)
	write(19,'(1x,20i2,1x,7i2,1x,3i2,1x,f6.2)') 
     1  (cout(var),var=1,30),ALTITUDE
	end if

	if(nst.eq.8) then
	write(19,'(1x,8f8.2)') (yz1(var),var=1,nst)
	write(19,'(1x,20i2,1x,8i2,1x,3i2,1x,f6.2)') 
     1  (cout(var),var=1,31),ALTITUDE
	end if



	end if


	return

	end
