

	subroutine pgvport4(x1,x2,y1,y2,
     1  x1vp,x2vp,y1vp,y2vp,fracvp,
     2  ix,iy,in,frac,aspect)

! This subroutine takes a set of pgvport coordinates x1,x2,y1,y2
! and creates a new set of pgvport coordinates which occupy the
! same relative position in a  sub-division of the viewport specified by 
! x1vp,x2vp,y1vp,y2vp and fracvp. fracvp is the fraction of the
! sub-division that the sub-dvision viewport occupies.
! pgvport2 is then called with the new viewport coordinates.
! This subroutine is useful in converting graphics that orginally
! were designed to fill the whole viewport to be plotted in
! a specified subdivision

! This subroutine is a generalisation of pgvport4 and pgvport2

! DWM 5-May-94

	logical debug

	debug=.false.

	if(debug) then
	write(*,*) 'pgvport4: x1,x2,y1,y2: ',x1,x2,y1,y2
	write(*,*) 'pgvport4: x1vp,x2vp,y1vp,y2vp,fracvp: ',x1vp,x2vp,y1vp,y2vp,fracvp
	end if

	x1vp_new = 0.5*(x1vp+x2vp) - fracvp*0.5*(x2vp-x1vp)
	x2vp_new = 0.5*(x1vp+x2vp) + fracvp*0.5*(x2vp-x1vp)
	y1vp_new = 0.5*(y1vp+y2vp) - fracvp*0.5*(y2vp-y1vp)
	y2vp_new = 0.5*(y1vp+y2vp) + fracvp*0.5*(y2vp-y1vp)

        x1_new = x1vp_new + (x2vp_new-x1vp_new)*x1
        x2_new = x1vp_new + (x2vp_new-x1vp_new)*x2
        y1_new = y1vp_new + (y2vp_new-y1vp_new)*y1
        y2_new = y1vp_new + (y2vp_new-y1vp_new)*y2

	if(debug) then
	write(*,*) 'pgvport4: x1_new,x2_new,y1_new,y2_new: ',x1_new,x2_new,y1_new
     1  ,y2_new
	end if

	call pgvport2(x1_new,x2_new,y1_new,y2_new,ix,iy,in,frac,aspect)

	return

	end







