  	      subroutine plotcom(filename,plotf,LINEWD,NDOTSZ,
     1        x1vp,x2vp,y1vp,y2vp,frac)


! change from standalone program to a subroutine to be used with
! fakesat_menu   DWM 23JUL93                                    


C
C This programs works with the COMPLOT option in the program
C test3.f. With this option COMPLOT produces a file: complot.dat
C which lists for all the tracking stations at every
C observation time the azimuth and zenith angle of the tracking
C stations as seen from the satellite. zenith angle being defined
C from the source direction
C (1) azimuth (deg)
C (2) azimuth rate (deg/minute)
C (3) zenith angle (deg)
C (4) zenith angle rate (deg/minute)
C This program takes this file and plots the data out

      character  plotf*80,filename*20
      
      PARAMETER  (MAXT=500)    !max number of time steps
      PARAMETER  (MAXORB=2)    !max number of orbiters
      PARAMETER  (MAXNST=10)   !max number of tracking stations
      PARAMETER  (MAXST=40)    !max number of GRTs + orbiters
      PARAMETER  (MAXCONS=20)  !max number of spacecraft constraints

      PARAMETER  (MAXAZ=20)    !max number of horizon mask sections

C-gam real x1vp,x2vp,y1vp,y2vp,fracvp,x1vp,x2vp,y1vp,y2vp
      real x1vp,x2vp,y1vp,y2vp

      real data(7+MAXNST+MAXAZ+MAXNST*MAXT,7,MAXNST)
      real  t1,t2,t3,min(6),max(6)
      real xleft(6),xright(6),ybot(6),ytop(6),x(MAXT),y(MAXT)
      real xcircle(360),ycircle(360),x2(MAXT),tick
      real azmin(MAXAZ),azmax(MAXAZ),HoTlim(MAXAZ),Zalim(MAXAZ)
      character*80 title(6)*80,tname(6)*10,info(6)*30
      character*80 xlabel(6),ylabel(6),text
      integer nst,numaz,LINEWD,NDOTSZ
!     logical flag,vsop,tickplot
      logical vsop,tickplot

      character xlab1*4,xlab2*3,xlab3*2,xlab4*2,xlab5*2


!	write(*,*) 'in plotcom : '
!	write(*,*) 'filename:'
!	write(*,'(a)') filename
!	write(*,*) 'plotfile: '
!	write(*,'(a)') plotf

	dr=3.141592654/180.0

	info(1)=': azimuth vs time '
	info(2)=': azimuth rate vs time'
	info(3)=': zenith angle vs time'
	info(4)=': zenith angle rate vs time'

	xlabel(1)=' '
	xlabel(2)=' '
!	xlabel(3)='Time from start of observartion (hr)'
!	xlabel(4)='Time from start of observartion (hr)'


	ylabel(1)= 'azimuth (deg)'
	ylabel(2)= 'd(az)/dt (deg/min)'
	ylabel(3)= 'zenith angle (deg)'
	ylabel(4)= 'd(za)/dt (deg/min)'
 
!      write(*,*) 'Name of file that contains az/za data ?'
!      write(*,*) '(usually complot.dat)'
!      read(*,'(a)') filename  
    
      open(1, file=filename, status='old',err=999)

cvv 
c      read(1,'(2x,L2)') vsop
      read(1,*) vsop      

      read(1,*) nst

	do i=1,nst
	read(1,'(a)') tname(i)
	end do

	read(1,*) IYREF,IDREF,IHREF,IMREF,ISREF
!	write(*,*) IYREF,IDREF,IHREF,IMREF,ISREF

	write(xlab1,'(i4)') IYREF
	write(xlab2,'(i3)') IDREF
	write(xlab3,'(i2)') IHREF
	write(xlab4,'(i2)') IMREF
	write(xlab5,'(i2)') ISREF

!	xlabel(3)='TIME (hr) FROM REF EPOCH ('//xlab1//' day '//xlab2//
!     1  ' '//xlab3//':'//xlab4//':'//xlab5//')'

	xlabel(3)='Time (hours) from 0 UT on  day '//xlab2//
     1  ' of '//xlab1

	time1=float(IDREF)+float(IHREF)/24.0+float(IMREF)/1440.0
     1          +float(ISREF)/86400.0 

	time0=float(IDREF)

	dtime=24.0*(time1-time0)


	xlabel(4)=xlabel(3)

!	write(*,'(a)') xlabel(3)
!	write(*,'(a)') xlabel(4)


	read(1,*) t1
	read(1,*) t2
	read(1,*) t3

! need to re-set t1,t2 to get correct x-axis range

	t1=t1+dtime
	t2=t2+dtime


! plot tick dots every hour

	tick = 1.0
! due to rounding errors used to get 2 dots at each epoch
	t3=0.995*t3


	read(1,*) numaz

	do i=1,numaz
	 read(1,*) azmin(i),azmax(i),Hotlim(i)
         zalim(i)=180.0-hotlim(i)
        end do



C	do time=t1,t2,t3
C	  it=it+1
C	  x(it)=time
C	 do j=1,nst
C	  read(1,*)  itel,(data(it,k,j),k=1,6)
C	  write(*,*) x(it)
C	  write(*,*) itel,(data(it,k,j),k=1,6)
C	 end do
C	end do

	iostat=0

	it=0


	do while (iostat.eq.0)
	    it=it+1
	 do j=1,nst
	   read(1,*,iostat=iostat,end=25)  itel,(data(it,k,j),k=1,7)
	  if(j.eq.1) then
	    x(it)=data(it,7,j)
	    x(it)=x(it)+dtime
C	   write(*,*) x(it)
	  end if
C	  write(*,*) itel,(data(it,k,j),k=1,6)
	 end do
	end do

25	continue

	it=it-1


	if(it.gt.MAXT) goto 5000


C	min(1)=-180.0
C	max(1)=180.0

C	min(3)=-90.0
C	max(3)=90.0

	iopt=0

	t1plot=t1
	t2plot=t2

200	continue

	if(iopt.eq.2) then
	 write(*,*) 'Time from start of observation (hr)'
	 write(*,fmt='(''ranges from '',f10.5,'' to '',f10.5)') t1,t2
	 write(*,*) 'range to be plotted is now set'
	 write(*,fmt='(''from '',f10.5,'' to '',f10.5)') t1plot,t2plot
	 write(*,*) 'What range do you want ?'
	 write(*,*) 'Minimum time from start of observation (hr) = ?'
 	 read(*,*) t1plot
	 write(*,*) 'Maximum time from start of observation (hr) = ?'
	 read(*,*) t2plot
	end if

100	continue

	itmin=1
 	itmax=1

	 do j=1,it
	  if(x(j).le.t1plot) itmin=j
	  if(x(j).le.t2plot) itmax=j
C	  write(*,*) 'j,x(j),t1plot,itmin ',j,x(j),t1plot,itmin
	end do

C	write(*,*) 'itmin ',itmin
C	write(*,*) 't1plot,t2plot ',t1plot,t2plot	
C	write(*,*) 'it,itmin,itmax ',it,itmin,itmax

!      call pgbegin(20, plotf, 1, 1)

      CALL PGSLW(LINEWD)


	do i=1,nst

C	if(i.gt.1) then
! comment out 3-May-94
!	 flag=.true.
!	 call pgask(.true.)
!	 call pgadvance
C	end if

	 if(i.gt.1) call pgadvance

	 do k=1,6
	   title(k)=tname(i)//info(k)
	 end do

	 initial=0

	 do j=itmin,itmax
	  
	   if(initial.eq.0) then
	    min(1)=data(j,1,i)
	    max(1)=data(j,1,i)
	    min(2)=data(j,2,i)
	    max(2)=data(j,2,i)
	    min(3)=data(j,3,i)
	    max(3)=data(j,3,i)
	    min(4)=data(j,4,i)
	    max(4)=data(j,4,i)
	    initial=initial+1
	  else
	   if(data(j,1,i).lt.min(1)) min(1)=data(j,1,i) 	  
	   if(data(j,1,i).gt.max(1)) max(1)=data(j,1,i)	 
	   if(data(j,2,i).lt.min(2)) min(2)=data(j,2,i) 	  
	   if(data(j,2,i).gt.max(2)) max(2)=data(j,2,i)
	   if(data(j,3,i).lt.min(3)) min(3)=data(j,3,i) 	  
	   if(data(j,3,i).gt.max(3)) max(3)=data(j,3,i)	 	  
	   if(data(j,4,i).lt.min(4)) min(4)=data(j,4,i) 	  
	   if(data(j,4,i).gt.max(4)) max(4)=data(j,4,i) 
	 end if

	end do

	min(1)=0.0
        max(1)=360.0
	min(3)=0.0
        max(3)=180.0

	if((max(2)-min(2)).lt.0.00001) then
          min(2)=0.0
          max(2)=10.0
        end if

	if((max(4)-min(4)).lt.0.00001) then
          min(4)=0.0
          max(4)=10.0
        end if



c	alpha=0.35	
        alpha=0.5
	height=1.0/(4*alpha+3)
        space=height*alpha
        width=0.5*(1-3*space)

	xleft(1)=space
        ybot(1)=3*space+2*height
	xleft(2)=xleft(1)+width+space
        ybot(2)=ybot(1)

	xleft(3)=space
        ybot(3)=2*space+height
	xleft(4)=xleft(3)+width+space
        ybot(4)=ybot(3)


        

	do k=1,4
	  xright(k)=xleft(k)+width
	  ytop(k)=ybot(k)+height
	end do

	do i1=1,4
	 ybot(i1)=0.5+0.5*ybot(i1)
	 ytop(i1)=0.5+0.5*ytop(i1)
	end do


	do k=1,4

	call pgsch(0.5)
	call pgsls(1)
        call pgsci(1)

!	call pgvport(xleft(k),xright(k),ybot(k),ytop(k))
	call pgvport3(xleft(k),xright(k),ybot(k),ytop(k),x1vp,x2vp,y1vp,y2vp,frac)

	call pgwindow(t1plot,t2plot,min(k),max(k))
	call pgbox('bcnst',0,0,'bcnst',0,0)
        call pgsch(0.5)
        call pgsci(7)
	call pglabel(xlabel(k),ylabel(k),' ')
	call pgsch(1.0)

	do j=1,it
	 y(j)=data(j,k,i)
	end do

C	call pgline(it,x,y)

	do j=itmin,itmax

	  if(amod(x(j),tick).lt.t3) then
	   TICKPLOT=.true.
	  else
	   TICKPLOT=.false.
	  end if

	if(j.eq.itmin) then
	       call pgmove(x(j),y(j))
	else
	  if(data(j,5,i).gt.0.5) then
                call pgsls(1)
c                call pgsci(3)
               call pgsci(2)                
             if(data(j-1,6,i).lt.0.5) call pgsci(7)
           if(data(j,6,i).lt.0.5) then
               call pgsls(4)
c               call pgsci(2)
               call pgsci(3)               
            if(data(j-1,6,i).gt.0.5) call pgsci(7)
           end if
	      call pgdraw(x(j),y(j))
	    if(TICKPLOT) then
              CALL PGSLW(NDOTSZ)
	      call pgpoint(1,x(j),y(j),17)
	      CALL PGSLW(LINEWD)
	    end if
	  else
	    call pgmove(x(j),y(j))   
	  end if
	end if

	end do

	end do

	do j=1,it
	 x2(j)=data(j,3,i)*sin(data(j,1,i)*dr)
	 y(j)=data(j,3,i)*cos(data(j,1,i)*dr)
	end do

	call pgsch(0.5)
	call pgsls(1)
        call pgsci(7)

!	call pgvport(0.25,0.75,0.05,0.55)
	call pgvport3(0.25,0.75,0.05,0.55,x1vp,x2vp,y1vp,y2vp,frac)
!	call pgwindow(-180.0,180.0,-180.0,180.0)
	call pgwnad(-180.0,180.0,-180.0,180.0)
	call pgbox('ast',0,0,'ast',0,0)
        call pgsci(7)
  
	call pgsci(1)


	doj1=1,4
            rcircle=45.0*float(j1)
	 do j2=1,360
            rangle=float(j2)
            xcircle(j2)=rcircle*sin(rangle*dr)
            ycircle(j2)=rcircle*cos(rangle*dr)
	 end do
           call pgsls(4)
	   call pgline(360,xcircle,ycircle)
           call pgsls(1)
       end do

	 do j2=1,360
              az=float(j2)
	  do j3=1,numaz
	   if(az.ge.azmin(j3).and.az.lt.azmax(j3)) then
              rplot=zalim(j3)
           end if
          end do
              xcircle(j2)=rplot*sin(az*dr)
              ycircle(j2)=rplot*cos(az*dr)
	 end do
           call pgsls(1)
           call pgsci(7)
	   call pgline(360,xcircle,ycircle)
	   call pgsci(1)
    
	

	do j=itmin,itmax

	if(j.eq.itmin) then
	 call pgmove(x2(j),y(j))
	else
	  if(data(j,5,i).gt.0.5) then
                call pgsls(1)
c               call pgsci(3)
               call pgsci(2)               
           if(data(j-1,6,i).lt.0.5) call pgsci(7)
            if(data(j,6,i).lt.0.5) then
               call pgsls(4)
c	       call pgsci(2)
	       call pgsci(3)	       
          if(data(j-1,6,i).gt.0.5) call pgsci(7)
             end if
	   call pgdraw(x2(j),y(j))

	  if(amod(x(j),tick).lt.t3) then
	   TICKPLOT=.true.
	  else
	   TICKPLOT=.false.
	  end if

	   if(TICKPLOT) then
            CALL PGSLW(NDOTSZ)
	    call pgpoint(1,x2(j),y(j),17)
	    CALL PGSLW(LINEWD)
	   end if   
	  else
	    call pgmove(x2(j),y(j))
	  end if
	 end if
	end do

!	call pgvport(0.0,1.0,0.0,1.0)
	call pgvport3(0.0,1.0,0.0,1.0,x1vp,x2vp,y1vp,y2vp,frac)
	call pgwindow(0.0,1.0,0.0,1.0)

	call pgsci(7)
        call pgsch(1.0)
         text='Satellite AZ-ZA Plots for tracking station: '//
     1    tname(i)
         call pgtext(0.2,0.97,text)
	call pgsch(0.7)
        call pgtext
     1   (0.4,0.60,'Polar Plot: Zenith Angle vs Azimuth')
	call pgsch(0.5)


	 call pgtext(0.75,0.3,'  Az=90,Za=180 (+Y Solar Panel Axis)')
	 call pgtext(0.5,0.57,'Az=0,Za=180')






	end do

!	call pgend

!	write(*,*) 'options: '
!	write(*,*) '0 = end program'
!	write(*,*) '1 = another plotting device'
!	write(*,*) '2 = re-plot with different time range'
!	write(*,*) 'which option ?'
!	read(*,*) iopt

	iopt = 0

	if(iopt.eq.1) goto 100
	if(iopt.eq.2) goto 200

	return

  999 write(*,*) 'ERR I/O'
      return 

5000  continue

      write(*,*) ' '
      write(*,*) 'number of time steps in data set is: ',it
      write(*,*) 'this exceeds the maximum allowed   :'  ,MAXT
      write(*,*)  ' '
      write(*,*) 'ABORTING plotting of data set'
      write(*,*) ' '
      write(*,*) '(try using a smaller time range or '
      write(*,*) 'a larger integration period) '
      write(*,*) ' '

      return
     
      end








