/* CPUTIME [Convex]
 *
 * Fortran-callable micosecond cpu clock
 *
 * Called as:
 *	elapsed = cputime(start)
 * where 'elapsed' is total cputime - 'start';
 * all arguments are REAL*4
 */

#include <sys/time.h>
#include <sys/resource.h>
#include <math.h>
#ifndef sun
#define FLOATFUNCTIONTYPE float
#define RETURNFLOAT return
#endif

/* HP C does not have getrusage in libc.a
 therefore comment out code that works on 
 SUNs and replace with dummy code DWM 26-Jul-95 */

FLOATFUNCTIONTYPE cputime(start)
float *start;
{
    int who = 0;
    float r;

/* SUN code: start 

    struct rusage ourru;
    getrusage(who, &ourru);
    r =       (float)ourru.ru_utime.tv_sec
            + (float)ourru.ru_utime.tv_usec * 1.0e-6 
            - *start; 

   SUN code: stop */

/* Dummy code: start
    
    printf("*** warning: cputime not calculated ***");
    r = 0.0;

  Dummy code: stop */


    RETURNFLOAT (r);
}
