/* CPUTIME [Convex]
 *
 * Fortran-callable micosecond cpu clock
 *
 * Called as:
 *	elapsed = cputime(start)
 * where 'elapsed' is total cputime - 'start';
 * all arguments are REAL*4
 */

#include <sys/time.h>
#include <sys/resource.h>
#include <math.h>
#ifndef sun
#define FLOATFUNCTIONTYPE float
#define RETURNFLOAT return
#endif


FLOATFUNCTIONTYPE cputime_(start)
float *start;
{
    int who = 0;
    float r;
    struct rusage ourru;
    getrusage(who, &ourru);
    r =       (float)ourru.ru_utime.tv_sec
            + (float)ourru.ru_utime.tv_usec * 1.0e-6 
            - *start;
    RETURNFLOAT (r);
}
