
 	subroutine fakesat_menu1(def_file_in,init,screen,frac,color,
     1  plotf1,simple_menu)

! beta version: 1.0 
! Interactive menu to run fakesat
! adapted from fakesatcsh.f
! DWM 23-Jul-93

! beta version: 1.1 
! use DLM get_stat subroutine to read in station information
! 4 March 94

! beta version: 1.2
! DWM 1-June-94 


! convert program fakesat_menu.f to subroutine fakesat_menu1.f 

! bug fixes:
!
! 17-Mar-94 correct tracking station sub-menu so that correct
!           tracking stations are selected and de-selected

!       implicit none

!        character*(*)  prognm, versn
!        parameter  (prognm='fakesat_menu')
!        parameter  (versn='beta version: 1.1 4-oct-93')

        include 'svlbsched.inc'

        parameter  (nstmax=200)
        character*8 stname_in(nstmax),defarray(3)
	integer nst

! begin DLM variables needed for get_stat

!	character*(*) stafile
	character*80 stafile, modfile
        character*2 stband_name(nstbandmax)
        character*8 stname, starray_name(narraymax)
        character*8 sttapetype_name(nsttapetypemax)
        integer outunit, sttype, yearorb, mnthorb, dayorb, stnarray
        integer ier
        double precision stlat, stlong, stx, sty, stz, stzalim1, stzalim2 
        double precision sthalim, stdiam, stslew1, stslew2 
        double precision stband_tsys(nstbandmax) 
        double precision stband_effic(nstbandmax) 
        double precision stband_tsys_jy(nstbandmax) 
        double precision aeiowmorb(6), utorb, teledir(3), telangle 
        double precision sunavoid(nsunavoidmax), antisunavoid, moonavoid
        double precision eclipmult, eclipadd

! end DLM variables  needed for get_stat

        character*8 starray_name_def(15)


	logical uvplot,ground,uvplotg,plotsat,plotsat2,xtraplots
	logical constra,exist,uvplott,ignore,ignore2

C-gam	logical usevalue,select(100),onlyone,inter,toggle,use
	logical usevalue,            onlyone,inter,toggle   ! select is 2D array!!

	logical output,cursor,found,plot,run,keep(20),buffer
	logical gronly,space,array(20),changearray(20)
	logical plotazel,plotcons,plotgrt,consplot,complot,plotgrtmenu
	logical yzplot,ecliplot,screen,init,pscolor,psnocolor
	logical data, dirty_beam,clean_map, visplot, modplot
	logical plotmenu,one_bit,color,grtmap, st_init
	logical plotgrt_old,grtmap_old,initstationsmenu,plotnum

	integer ntrack(20),nrows

	real xc,yc
	real x1vp,x2vp,y1vp,y2vp,frac

	character ans*1,idaystopc*5,sline2*80,ra_source*13, dec_source*13
	character line(200)*80,title*20,plotf1*60
	character plotf*60,linewidth*15,dotsiz*15,orbitn*15
	character tracklist*80,c1*1,out*40,ans2*1
	character defname*60,default*60,temp*60,end*1

C-gam	character c3*3,c1*1,header*48,sline*132,default2*69
	character header*48,sline*132

	character xyint_string*9,def_file*80,header_top*48,str15*15
	character*80 def_file_in


	character integ*10,band*1,bandold*1,nup*4,bandupper*1
	character typsat*1,typsatold*1,temp1*7,typsatold2*1
	character orbit*8,umax*7,vmax*7,ngrdil*8,bandw*10
	character*10 ramin,ramax,rastep,decmin,decmax,decstep
	character*10 angmax,west,nx,ny,nplots,dtuvd,dtuvh,ians
C   VP add ians to character defenition
	character ra*11,dec*11,track(20)*8
	character start*11,stop*11,year*4,day*3,source*8,day60*60

	real bandwidth

! Program allows 50 menus with at most 100 items on each menu

	logical defselect(100,50),select(100,50),initial,initmenu(50)
!	logical vlba(100),evn(100),sheve(100),lgrt(100),evnc(100),apt(100)
	logical change_station, vsop, rastron, found_source, found_num(8)
	logical sh(50),menu_s(50),menu_c(50)

	character defvalue(100,50)*15,value(100,50)*15
	character name(100)*15,plotfname*20,tex_file(50)*31
	character ovalue(100)*15,grt(100)*8,string_num*10

	integer inum_in(50,3),icol_in(50,3),irow_in(50,3),imenunum_in(50)
	integer imenusum,inum_max(50),numstarray(100),debug3
	logical usevalue_in(50),onlyone_in(50),toggle_in(50), debug2
	logical defselect_in(100,50,3,2),arrayval(100,15), debug
	logical new_source,simple_menu,input_cursor
	character*15 defname_in(100,50,3),defvalue_in(100,50,3,2)
	character*15 info_in(100,50)
	character*113 line_in,line_tmp,separator,cshname
	character*48 header_in(50)
        real  tsys_jy(100),sigma_mjy(100)

	character*5 tsys_5

	real*8 asemi
	character*8 sname
	real eccen,t1,t2,incl,t3,t4,aop,t5,ran,man,uth,utm,uts

C-gam	integer	iy,im,id,sttype,colors(50)
	integer	iy,im,id,       colors(50)

        double precision jd0

!	write(*,*) '*** fakesat_menu1.f called ***'

3060	continue


! ignore is used to get rid of code that is either redundant
! or does not work yet !

	ignore=.true.

!  debug is used to get rid of code that writes out info
!  when program is begining be-bugged

	debug=.false.
	debug2=.false.

! debug3 is used to debug the initialisation of the menu_defaults file
! after the stations.cat file has been changed.

	debug3=.false.


! check to see if stations.cat has changed since last time fakesat_menu was run

	   init = .false.
	   st_init = .false.

	   call stations_init(init)

! set input_cursor to false

	input_cursor = .false.
	xc = 0.14
	yc = 0.94


3050	continue

	 def_file=def_file_in

! re-set line style

	call pgsls(1)

	plot = .false.

!
! determine correct aspect ratio for plot.
!

	 aspect = 0.762

	 r0 = 0.762 ! y/x aspect ratio required
	 f0 = frac


	 call pgvport(0.0,1.0,0.0,1.0)
!	 call pgwindow(0.0,1.0,0.0,1.0)

	 call pgqvp(2,rx1,rx2,ry1,ry2)

!	 write(*,*) 'viewport size in mm: '
!	 write(*,*) 'x1: ',rx1
!	 write(*,*) 'x2: ',rx2
!	 write(*,*) 'y1: ',ry1
!	 write(*,*) 'y2: ',ry2


	   r1 = (ry2-ry1)/(rx2-rx1)


	 if(r1.gt.r0) then
	   fx = 1.0
	   fy = fx*r0/r1
	 else
	  fy = 1.0
	  fx = fy*r1/r0
	 end if

	  fx = f0*fx
	  fy = f0*fy

	x1vp = 0.5 - 0.5*fx
	x2vp = 0.5 + 0.5*fx
	y1vp = 0.5 - 0.5*fy
	y2vp = 0.5 + 0.5*fy


!info------------------------------------------------------------------------
!info--initialization:

!        call system('fakesat_system date')
!        open(1,file='.date',status='old')
!	 read(1,'(a)') date
!	 close(1)

	nrows=35

!	iname=50

	initial=.true.

	do i=1,50
	 do j=1,100
	  defselect(j,i)=.false.
	 end do
	end do

	do i=1,50
	 initmenu(i)=.true.
	end do



!	write(*,*) ' '
!	write(*,*) 'JPL interactive Space VLBI simulation program'
!	write(*,*) ' '
!!      write(*,'(a)') versn
!	write(*,*) ' '


	inter=.true.


! turn off non-interactive mode as this no longer works
! DWM 22-APR-93

	if(.not.inter) then

	write(*,*) 'use menus to select options ? (default=use menus)'
	read(*,'(a)') ans

C-gam	if(ans.eq.'') then
	if(ans.eq.' ') then

	  inter=.true.
	else
	 inter=.false.
	end if

	end if


	if(inter) then


	open(13,file='menu_colors',status='old',err=2010)


	do i=1,23
 	 read(13,*) i1,i2
	 if(color) then
	   colors(i) = i1
	 else
	   colors(i) = i2
	 end if
	end do

	close(13)


! if we want a hardcopy of the screen need to swap black for white
! and vice versa this occurs when screen is true

	if(screen.and.color) then

	do i=1,50
	 if(colors(i).eq.0) then
	  colors(i) = 1
	 else
	  if(colors(i).eq.1) then
	  colors(i) = 0
	  end if
	 end if
	end do

	end if

	



        iselect       =colors(1)
	itextselect   =colors(2)
	ibox          =colors(3)
 	itext         =colors(4)
	iexit         =colors(5)
	ichange       =colors(6)
	ichangetext   =colors(7)
	iheader       =colors(8)
	iback_usevalue=colors(9)
	iback         =colors(10)
        iscreen       =colors(11)
        itopbox       =colors(12)
        itoptext      =colors(13)
	itextchange   =colors(14)
	itextchange2  =colors(15)
	itextchange3  =colors(16)
	iboxblack     =colors(17)
	iboxwhite     =colors(18)
        igrey_16      =colors(19)
        igrey_17      =colors(20)
        icr_18        =colors(21)
        icg_18        =colors(22)
        icb_18        =colors(23)

	c16= float(igrey_16)/100.0
	c17= float(igrey_17)/100.0

	call pgscr(16,c16,c16,c16)
	call pgscr(17,c17,c17,c17)

	cr_18= float(icr_18)/100.0
	cg_18= float(icg_18)/100.0
	cb_18= float(icb_18)/100.0

	call pgscr(18,cr_18,cg_18,cb_18)



	    ytop_start = 0.95
 	    header_top='FAKERAD v.10: Interac.  Menu'

	   if(.not.init) then

	   call pgvport(x1vp,x2vp,y1vp,y2vp)
	   call pgwindow(0.0,1.0,0.0,1.0)
	   call pgsci(iscreen)
	   call pgrect(0.0,1.0,0.0,1.0)

	    cursor = .false.

	   call headbox(x1vp,x2vp,y1vp,y2vp, ytop_start,xc,yc,
     1     header_top,itopbox,itoptext,iboxblack,iboxwhite,
     2     iselect,cursor)


	 call pgvport(x1vp,x2vp,y1vp,y2vp)
	 call pgwindow(0.0,1.0,0.0,1.0)

	 call pgbbuf
	 buffer=.true.

	end if

! intialize variables that are used to re-set certain menus

	typsatold='9'
	typsatold2='9'
	bandold='9'
	band='l'

	grtmap_old=.false.
	plotgrt_old=.false.


	cursor=.false.
	output=.false.
	found=.false.
!	plot=.false.
	iout=0

	do i=1,10
	 keep(i)=.false.
	end do

	end if


! read in defaults file : def_file 

	if(inter) then

	call system('/bin/rm menu_defaults.1')
	call system('/bin/cp menu_defaults menu_defaults.1')

!	write(*,*) 'open for reading:'
!	write(*,'(a)') def_file

	open(2,file=def_file,status='unknown')

	 iostat=0
	 imenusum=0


	 read(2,'(a)',iostat=iostat,end=25) separator
	 read(2,'(a)',iostat=iostat,end=25) line_in
	 read(line_in(18:20),'(i3)') isat
!	 read(line_in(34:34),'(l1)')  simple_menu

!	 write(*,*) 'simple_menu is: ', simple_menu


	 read(2,'(a)',iostat=iostat,end=25) separator

	do while(iostat.eq.0)

	 read(2,'(a)',iostat=iostat,end=25) line_tmp
	 read(2,'(a)',iostat=iostat,end=25) line_in

!	 write(*,'(a)')  line_tmp
!	 write(*,'(a)')  line_in





	 imenusum=imenusum+1

	 read(line_in(18:20),'(i3)') imenu
         imenunum_in(imenusum)=imenu

!	 write(*,*) 'imenu: ',imenu

	 header_in(imenu)=line_tmp(1:48)
	 tex_file(imenu)=line_tmp(82:112)

!	 read(line_tmp(66:66),'(l1)') sh(imenu)

	 read(line_tmp(66:66),'(l1)') menu_s(imenu)
	 read(line_tmp(67:67),'(l1)') menu_c(imenu)

	 if(simple_menu) then
	   sh(imenu)=menu_s(imenu)	 
	 else
	   sh(imenu)=menu_c(imenu)	 
	 end if

!	 write(*,*) 'read: imenu, sh(imenu)',imenu, sh(imenu)

!	 write(*,'(a)') line_tmp
!	 write(*,*) 'read: imenu, sh,simple,complex ',imenu, sh(imenu),
!     1   menu_s(imenu),menu_c(imenu)




	 read(2,'(a)',iostat=iostat,end=25) line_in
!	 write(*,'(a)')  line_in
	 read(line_in(18:20),'(i3)') inum_in(imenu,1)
	 read(line_in(34:36),'(i3)') inum_in(imenu,2)
	 read(line_in(50:52),'(i3)') inum_in(imenu,3)
	 read(2,'(a)',iostat=iostat,end=25) line_in
!        write(*,'(a)')  line_in
	 read(line_in(18:20),'(i3)') icol_in(imenu,1)
	 read(line_in(34:36),'(i3)') icol_in(imenu,2)
	 read(line_in(50:52),'(i3)') icol_in(imenu,3)
	 read(2,'(a)',iostat=iostat,end=25) line_in
!	 write(*,'(a)')  line_in
	 read(line_in(18:20),'(i3)') irow_in(imenu,1)
	 read(line_in(34:36),'(i3)') irow_in(imenu,2)
	 read(line_in(50:52),'(i3)') irow_in(imenu,3)

	 inum_max(imenu)=inum_in(imenu,1)

	 if(inum_in(imenu,2).gt.inum_max(imenu)) then
 		inum_max(imenu)=inum_in(imenu,2)
	 end if

	 if(inum_in(imenu,3).gt.inum_max(imenu)) then
		inum_max(imenu)=inum_in(imenu,3)
	 end if

	 read(2,'(a)',iostat=iostat,end=25) line_in
!	 write(*,'(a)')  line_in
	 read(line_in(18:18),'(l1)') usevalue_in(imenu)
	 read(2,'(a)',iostat=iostat,end=25) line_in
!	 write(*,'(a)')  line_in
	 read(line_in(18:18),'(l1)') onlyone_in(imenu)
	 read(2,'(a)',iostat=iostat,end=25) line_in
!	 write(*,'(a)')  line_in


	 read(line_in(18:18),'(l1)') toggle_in(imenu)

	 if(usevalue_in(imenu)) then

	   do i=1,inum_max(imenu)

	    read(2,'(a)',iostat=iostat,end=25) line_in
!	    write(*,'(a)')  line_in
  

	    read(line_in(1:15),'(a)') defname_in(i,imenu,1)
	    read(line_in(1:15),'(a)') defname_in(i,imenu,2)
	    read(line_in(1:15),'(a)') defname_in(i,imenu,3)

	    read(line_in(18:32),'(a)')  defvalue_in(i,imenu,1,1)
	    read(line_in(34:48),'(a)')  defvalue_in(i,imenu,2,1)
	    read(line_in(50:64),'(a)')  defvalue_in(i,imenu,3,1)
	    read(line_in(66:80),'(a)')  defvalue_in(i,imenu,1,2)
	    read(line_in(82:96),'(a)')  defvalue_in(i,imenu,2,2)
	    read(line_in(98:112),'(a)') defvalue_in(i,imenu,3,2)

	   end do


	 else if(toggle_in(imenu)) then 


	    read(2,'(a)',iostat=iostat,end=25) line_in
!	    write(*,'(a)')  line_in

	    read(line_in(18:32),'(a)') defname_in(1,imenu,1)
	    read(line_in(34:48),'(a)') defname_in(1,imenu,2)
	    read(line_in(50:64),'(a)') defname_in(1,imenu,3)

	    read(line_in(66:66),'(l1)')  defselect_in(1,imenu,1,1)
	    read(line_in(67:67),'(l1)')  defselect_in(1,imenu,2,1)
	    read(line_in(68:68),'(l1)')  defselect_in(1,imenu,3,1)
	    read(line_in(82:82),'(l1)')  defselect_in(1,imenu,1,2)
	    read(line_in(83:83),'(l1)')  defselect_in(1,imenu,2,2)
	    read(line_in(84:84),'(l1)')  defselect_in(1,imenu,3,2)


	    read(2,'(a)',iostat=iostat,end=25) line_in
!	    write(*,'(a)')  line_in


	    read(line_in(18:32),'(a)') defvalue_in(1,imenu,1,1)
	    read(line_in(34:48),'(a)') defvalue_in(1,imenu,2,1)
	    read(line_in(50:64),'(a)') defvalue_in(1,imenu,3,1)

	    read(line_in(18:32),'(a)') defvalue_in(1,imenu,1,2)
	    read(line_in(34:48),'(a)') defvalue_in(1,imenu,2,2)
	    read(line_in(50:64),'(a)') defvalue_in(1,imenu,3,2)


	 else

! this deals with the onlyone = T  
! and when usevalue = onlyone = toggle = F that is, select many
! items from a list

	   do i=1,inum_max(imenu)

	    read(2,'(a)',iostat=iostat,end=25) line_in
!	    write(*,'(a)')  line_in
	    
	    read(line_in(18:32),'(a)') defname_in(i,imenu,1)
	    read(line_in(34:48),'(a)') defname_in(i,imenu,2)
	    read(line_in(50:64),'(a)') defname_in(i,imenu,3)


	    read(line_in(66:66),'(l1)')  defselect_in(i,imenu,1,1)
	    read(line_in(67:67),'(l1)')  defselect_in(i,imenu,2,1)
	    read(line_in(68:68),'(l1)')  defselect_in(i,imenu,3,1)
	    read(line_in(82:82),'(l1)')  defselect_in(i,imenu,1,2)
	    read(line_in(83:83),'(l1)')  defselect_in(i,imenu,2,2)
	    read(line_in(84:84),'(l1)')  defselect_in(i,imenu,3,2)

	    info_in(i,imenu)(1:15)=line_in(1:15)

	  end do


	 end if


	 read(2,'(a)',iostat=iostat,end=25) separator



	end do

25	continue
	close(2)

	end if



! initialization of fakesat_menu-defaults done here


	 if(init) then

!!!  changing imenu = 13 (GRT menu)

	  imenu_s = 13  ! GRT menu
	  imenu_t = 6   ! tracking station menu
	  imenu_o = 4   ! orbital elements menu
          imenu_a = 28  ! array menu


	  ier_get_stat = 0

          stafile='stations.cat'


	  if(debug3) write(*,*) 'GRT info : '

! replace getting station names from imenu = imenustations with
! those listed in stations.cat having sttype = 1

! note: force re-reading of stations.cat file with init

        call get_stat( outunit, stafile, stname, sttype, stlat, 
     1  stlong, stx, sty, stz, stzalim1, stzalim2,  sthalim, 
     2  stdiam, stslew1, stslew2, stband_name, stband_tsys, 
     3  stband_effic, stband_tsys_jy, aeiowmorb, yearorb, mnthorb, 
     4  dayorb, utorb, teledir, telangle, sunavoid, antisunavoid, 
     5  moonavoid, eclipmult, eclipadd, stnarray, starray_name, 
     6  sttapetype_name, ier, nst, stname_in,init)

	if(debug3) write(*,*) 'finding station names: '
	if(debug3) write(*,*) 'nst: ', nst


	do i=1,100	 
          defname_in(i,imenu_t,1) = ' '
	end do

	 do i=1,3

	 icol_in(imenu_t,i) = 0
	 irow_in(imenu_t,i) = 1
	 inum_in(imenu_t,i) = 0

	end do

	
	inum_max(imenu_s) = 0
	
	do i=1,nst

	 stname = stname_in(i)

        call get_stat( outunit, stafile, stname, sttype, stlat, 
     1  stlong, stx, sty, stz, stzalim1, stzalim2,  sthalim, 
     2  stdiam, stslew1, stslew2, stband_name, stband_tsys, 
     3  stband_effic, stband_tsys_jy, aeiowmorb, yearorb, mnthorb, 
     4  dayorb, utorb, teledir, telangle, sunavoid, antisunavoid, 
     5  moonavoid, eclipmult, eclipadd, stnarray, starray_name, 
     6  sttapetype_name, ier, nst, stname_in, st_init)

	if(debug3) write(*,*) 'found station: ',stname,sttype,'array: ',stnarray, starray_name
!	write(*,*) 'found station: ',stname,sttype

	if(stname.eq.'ARRAY') then

	    j = 0

!	 do i1=1,narraymax

	 do i1=1,stnarray


!	   if( starray_name(i1).ne.' ') then

	     if(debug) write(*,*) 'found array: ', starray_name(i1)

	     j = j + 1
	     info_in(j,imenu_a) =  starray_name(i1)

	     defname_in(j,imenu_a,1) = starray_name(i1)
	     defname_in(j,imenu_a,2) = starray_name(i1)
	     defname_in(j,imenu_a,3) = starray_name(i1)

             defselect_in(j,imenu_a,1,1)=.false.
             defselect_in(j,imenu_a,2,1)=.false.
             defselect_in(j,imenu_a,3,1)=.false.

             defselect_in(j,imenu_a,1,2)=.false.
             defselect_in(j,imenu_a,2,2)=.false.
             defselect_in(j,imenu_a,3,2)=.false.

	     do k =1 , 3

	       defarray(k)= sttapetype_name(k)

	      if(sttapetype_name(k).eq.starray_name(i1)) then
                defselect_in(j,imenu_a,k,1)=.true.
                defselect_in(j,imenu_a,k,2)=.true.
	      end if
!             write(*,*) 'def_menu=',defarray(k)

	     end do  

 
!          end if

	 end do

	 inum_max(imenu_a) = j

	 do i1=1,3
	  icol_in(imenu_a,i1) = j
	  irow_in(imenu_a,i1) = 1
	  inum_in(imenu_a,i1) = j
	 end do	

	end if

	if(stname.eq.'VSOP'.or.stname.eq.'RASTRON') then

	 if(stname.eq.'VSOP') then
	   if(debug3) write(*,*) 'VSOP orbital elements: '
	   icol = 1
	 else
	   if(debug3) write(*,*) 'RADIOASTRON orbital elements: '
	   icol = 2
	 end if

	   aeiowmorb(1) = aeiowmorb(1)/1000.0


	  do j =1,2

	   write(defvalue_in(1,imenu_o,icol,j),'(f12.4)') aeiowmorb(1)
	   write(defvalue_in(2,imenu_o,icol,j),'(f6.4)') aeiowmorb(2)
	   write(defvalue_in(3,imenu_o,icol,j),'(f7.3)') aeiowmorb(3)
	   write(defvalue_in(4,imenu_o,icol,j),'(f7.3)') aeiowmorb(4)
	   write(defvalue_in(5,imenu_o,icol,j),'(f7.3)') aeiowmorb(5)
	   write(defvalue_in(6,imenu_o,icol,j),'(f7.3)') aeiowmorb(6)

	   write(defvalue_in(7,imenu_o,icol,j),'(i4)') yearorb
	   write(defvalue_in(8,imenu_o,icol,j),'(i2)') mnthorb
	   write(defvalue_in(9,imenu_o,icol,j),'(i3)') dayorb

	  end do

	  if(debug3) then
	  do j=1,9
	   write(*,*) defvalue_in(j,imenu_o,1,1)
	  end do
	  end if

	end if



	if(sttype.eq.10) then

	 inum_max(imenu_s) = inum_max(imenu_s) + 1
	 defname_in(inum_max(imenu_s),imenu_s,1) = stname

	 info_in(inum_max(imenu_s),imenu_s) = ' '

	end if

	if(debug3) write(*,*) 'VSOP tracking stations: '

	if(sttype.eq.21.or.sttype.eq.23) then
	 if(debug3) write(*,'(a)') stname
	 icol_in(imenu_t,1) =  icol_in(imenu_t,1) + 1
         inum_in(imenu_t,1) =  icol_in(imenu_t,1)
         defname_in(icol_in(imenu_t,1),imenu_t,1) = stname
         defselect_in(icol_in(imenu_t,1),imenu_t,1,1)=.true.
         defselect_in(icol_in(imenu_t,1),imenu_t,1,2)=.true.

	 info_in(icol_in(imenu_t,1),imenu_t) = ' '
         defname_in(icol_in(imenu_t,1),imenu_t,3) = ' '

	end if

	if(debug3) write(*,*) 'Radioastron tracking stations: '

	if(sttype.eq.22.or.sttype.eq.23) then
	 if(debug) write(*,'(a)') stname
	 icol_in(imenu_t,2) =  icol_in(imenu_t,2) + 1
         inum_in(imenu_t,2) =  icol_in(imenu_t,2)
!        defname_in(icol_in(imenu_t,1),imenu_t,2) = stname
!        defselect_in(icol_in(imenu_t,1),imenu_t,2,1)=.true.
!        defselect_in(icol_in(imenu_t,1),imenu_t,2,2)=.true.
         defname_in(icol_in(imenu_t,2),imenu_t,2) = stname
         defselect_in(icol_in(imenu_t,2),imenu_t,2,1)=.true.
         defselect_in(icol_in(imenu_t,2),imenu_t,2,2)=.true.

	 info_in(icol_in(imenu_t,2),imenu_t) = ' '
         defname_in(icol_in(imenu_t,2),imenu_t,3) = ' '

	end if


	end do

	 inum_max(imenu_t) = inum_in(imenu_t,1)
	if(inum_in(imenu_t,2).gt.inum_in(imenu_t,1)) 
     1   inum_max(imenu_t) = inum_in(imenu_t,2)
	if(inum_in(imenu_t,3).gt.inum_in(imenu_t,2)) 
     1   inum_max(imenu_t) = inum_in(imenu_t,3)


! temporary fix here. menu blows up when inum_max = 0 !

	inum_in(imenu_t,3) = inum_max(imenu_t)


! sort stations in alphabetical order

	iswop = 1

	do while(iswop.gt.0)
	   iswop = 0
	 do i=2,inum_max(imenu_s)
	   if(defname_in(i,imenu_s,1).le.defname_in(i-1,imenu_s,1)) then
	    iswop = iswop + 1

	   if(debug3) then
	    write(*,*) 'i,iswop: ',i,iswop
	    write(*,*) 'swopping: ', defname_in(i,imenu_s,1), defname_in(i-1,imenu_s,1)
	   end if

	    stname = defname_in(i,imenu_s,1)
	    defname_in(i,imenu_s,1)   = defname_in(i-1,imenu_s,1)
	    defname_in(i-1,imenu_s,1) = stname

	   end if
	 end do
	end do

	  if(debug3) write(*,*) 'ordered stations list: '

	 do i=1,inum_max(imenu_s)

	   if(debug3) write(*,'(a)') defname_in(i,imenu_s,1)

	   stname = defname_in(i,imenu_s,1)

	  defname_in(i,imenu_s,2) = stname
	  defname_in(i,imenu_s,3) = stname

! after we have re-ordered check to see if station is member of
! the default array:

        call get_stat( outunit, stafile, stname, sttype, stlat, 
     1  stlong, stx, sty, stz, stzalim1, stzalim2,  sthalim, 
     2  stdiam, stslew1, stslew2, stband_name, stband_tsys, 
     3  stband_effic, stband_tsys_jy, aeiowmorb, yearorb, mnthorb, 
     4  dayorb, utorb, teledir, telangle, sunavoid, antisunavoid, 
     5  moonavoid, eclipmult, eclipadd, stnarray, starray_name, 
     6  sttapetype_name, ier, nst, stname_in, st_init)

	 do j=1,3

              defselect_in(i,imenu_s,j,1)=.false.
              defselect_in(i,imenu_s,j,2)=.false.

	  do k=1,narraymax

	      if(debug) write(*,*) stname,j,k,defarray(j),starray_name(k)

	     if(defarray(j).eq.starray_name(k)) then
              defselect_in(i,imenu_s,j,1)=.true.
              defselect_in(i,imenu_s,j,2)=.true.

	     if(debug) write(*,*) '************',stname, starray_name(k)	     
	
	     end if

	  end do	
	 end do

	end do



	inum = inum_max(imenu_s)
	icol = 6 
	irow = (inum/icol) + 1

	if(debug3) write(*,*) 'icol, inum, irow : ', icol, inum, irow

	do i =1,3
	 icol_in(imenu_s,1) = icol
	 icol_in(imenu_s,2) = icol
	 icol_in(imenu_s,3) = icol
	 irow_in(imenu_s,1) = irow
	 irow_in(imenu_s,2) = irow
	 irow_in(imenu_s,3) = irow
	 inum_in(imenu_s,1) = inum
	 inum_in(imenu_s,2) = inum
	 inum_in(imenu_s,3) = inum
	end do



! write out defaults file : menu_defaults 

! only write out defaults file if plot is produced

!	if(.not.ignore) then
!        if(plot) then

	call system('/bin/rm menu_defaults.1')
	call system('/bin/cp menu_defaults menu_defaults.1')

	write(*,*) 'open for writing:'
	write(*,*) 'menu_defaults'
	open(2,file='menu_defaults',status='unknown')

!	write(*,*) ' '
!	write(*,*) 'init: writing defaults file menu_defaults'
!	write(*,'(a)') def_file
!	write(*,*) ' '


!	open(2,file=def_file,status='unknown')

	 iostat=0
!	 imenusum=0

	 line_tmp=' '
	 line_tmp(17:17)=separator(17:17)
	 line_tmp(33:33)=separator(17:17)
	 line_tmp(49:49)=separator(17:17)
	 line_tmp(65:65)=separator(17:17)
	 line_tmp(81:81)=separator(17:17)
	 line_tmp(97:97)=separator(17:17)
	 line_tmp(113:113)=separator(17:17)


	 write(2,'(a)') separator


	 line_in=line_tmp
	 line_in(1:4)='isat'
	 write(line_in(18:20),'(i3)') isat
!	 write(line_in(34:34),'(l1)')  simple_menu

	 write(2,'(a)') line_in

!	 write(*,'(a)') line_in



	 write(2,'(a)') separator

	do j=1,imenusum

	  imenu= imenunum_in(j)

	 line_in=line_tmp
	 line_in(17:17)=' '
	 line_in(33:33)=' '
	 line_in(1:48)=header_in(imenu)
	 line_in(82:112)=tex_file(imenu)

!	 write(line_in(66:66),'(l1)') sh(imenu)

	 write(line_in(66:66),'(l1)') menu_s(imenu)
	 write(line_in(67:67),'(l1)') menu_c(imenu)


!	 write(*,'(a)') tex_file(imenu)
!	 write(*,*) 'write2: imenu, sh(imenu)',imenu, sh(imenu)


	 write(2,'(a)') line_in

!	 write(*,'(a)') line_in

!	 imenusum=imenusum+1

	 line_in=line_tmp
	 line_in(1:5)='imenu'
	 write(line_in(18:20),'(i3)') imenu
	 write(2,'(a)') line_in


	 line_in=line_tmp
	 line_in(1:4)='inum'
	 write(line_in(18:20),'(i3)') inum_in(imenu,1)
	 write(line_in(34:36),'(i3)') inum_in(imenu,2)
	 write(line_in(50:52),'(i3)') inum_in(imenu,3)
	 write(2,'(a)') line_in

	 line_in=line_tmp
	 line_in(1:4)='icol'
	 write(line_in(18:20),'(i3)') icol_in(imenu,1)
	 write(line_in(34:36),'(i3)') icol_in(imenu,2)
	 write(line_in(50:52),'(i3)') icol_in(imenu,3)
	 write(2,'(a)') line_in


	 line_in=line_tmp
	 line_in(1:4)='irow'
	 write(line_in(18:20),'(i3)') irow_in(imenu,1)
	 write(line_in(34:36),'(i3)') irow_in(imenu,2)
	 write(line_in(50:52),'(i3)') irow_in(imenu,3)
	 write(2,'(a)') line_in

	 line_in=line_tmp
	 line_in(1:8)='usevalue'
	 write(line_in(18:18),'(l1)') usevalue_in(imenu)
	 write(2,'(a)') line_in

	 line_in=line_tmp
	 line_in(1:7)='onlyone'
	 write(line_in(18:18),'(l1)') onlyone_in(imenu)
	 write(2,'(a)') line_in

	 line_in=line_tmp
	 line_in(1:6)='toggle'
	 write(line_in(18:18),'(l1)') toggle_in(imenu)
	 write(2,'(a)') line_in


	 if(usevalue_in(imenu)) then

	   do i=1,inum_max(imenu)


	    line_in=line_tmp

	    write(line_in(1:15),'(a)') defname_in(i,imenu,1)
	    write(line_in(1:15),'(a)') defname_in(i,imenu,2)
	    write(line_in(1:15),'(a)') defname_in(i,imenu,3)

	    write(line_in(18:32),'(a)')  defvalue_in(i,imenu,1,1)
	    write(line_in(34:48),'(a)')  defvalue_in(i,imenu,2,1)
	    write(line_in(50:64),'(a)')  defvalue_in(i,imenu,3,1)
	    write(line_in(66:80),'(a)')  defvalue_in(i,imenu,1,2)
	    write(line_in(82:96),'(a)')  defvalue_in(i,imenu,2,2)
	    write(line_in(98:112),'(a)') defvalue_in(i,imenu,3,2)

	    write(2,'(a)') line_in

	   end do


	 else if(toggle_in(imenu)) then 

	    line_in=line_tmp

	    write(line_in(18:32),'(a)') defname_in(1,imenu,1)
	    write(line_in(34:48),'(a)') defname_in(1,imenu,2)
	    write(line_in(50:64),'(a)') defname_in(1,imenu,3)

	    write(line_in(66:66),'(l1)')  defselect_in(1,imenu,1,1)
	    write(line_in(67:67),'(l1)')  defselect_in(1,imenu,2,1)
	    write(line_in(68:68),'(l1)')  defselect_in(1,imenu,3,1)
	    write(line_in(82:82),'(l1)')  defselect_in(1,imenu,1,2)
	    write(line_in(83:83),'(l1)')  defselect_in(1,imenu,2,2)
	    write(line_in(84:84),'(l1)')  defselect_in(1,imenu,3,2)

	    write(2,'(a)') line_in

	    line_in=line_tmp

	    write(line_in(18:32),'(a)') defvalue_in(1,imenu,1,1)
	    write(line_in(34:48),'(a)') defvalue_in(1,imenu,2,1)
	    write(line_in(50:64),'(a)') defvalue_in(1,imenu,3,1)

	    write(line_in(18:32),'(a)') defvalue_in(1,imenu,1,2)
	    write(line_in(34:48),'(a)') defvalue_in(1,imenu,2,2)
	    write(line_in(50:64),'(a)') defvalue_in(1,imenu,3,2)

	    write(2,'(a)') line_in



	 else

! this deals with the onlyone = T  
! and when usevalue = onlyone = toggle = F that is, select many
! items from a list

	   do i=1,inum_max(imenu)

	    line_in=line_tmp

	    line_in(1:15)=info_in(i,imenu)(1:15)

	    write(line_in(18:32),'(a)') defname_in(i,imenu,1)
	    write(line_in(34:48),'(a)') defname_in(i,imenu,2)
	    write(line_in(50:64),'(a)') defname_in(i,imenu,3)

! for imenu=1 the mode menu always write out read defaults to
! write defaults

	    if(imenu.eq.1) then
	    write(line_in(66:66),'(l1)')  defselect_in(i,imenu,1,2)
	    write(line_in(67:67),'(l1)')  defselect_in(i,imenu,2,2)
	    write(line_in(68:68),'(l1)')  defselect_in(i,imenu,3,2)
	    else
	    write(line_in(66:66),'(l1)')  defselect_in(i,imenu,1,1)
	    write(line_in(67:67),'(l1)')  defselect_in(i,imenu,2,1)
	    write(line_in(68:68),'(l1)')  defselect_in(i,imenu,3,1)
	    end if


	    write(line_in(82:82),'(l1)')  defselect_in(i,imenu,1,2)
	    write(line_in(83:83),'(l1)')  defselect_in(i,imenu,2,2)
	    write(line_in(84:84),'(l1)')  defselect_in(i,imenu,3,2)

	    write(2,'(a)') line_in


	  end do


	 end if


	 write(2,'(a)') separator



	end do !do j=2,imenusum


27	continue
	close(2)

!	end if !if(plot) then

!	end if !if(.not.ignore) then


	 end if !if(init)

!	 if(init) goto 5000

!	 if(init) goto 2020

	 if(init) then
	  init=.false.
	  goto 3050
	 end if


! use get_stat to set up GRTs etc

	  imenustations=13
	  imenutrack   =6

          outunit = 6

          imenu  = imenustations

	  
	 if(.not.ignore) then


	  ier_get_stat = 0

          stafile='stations.cat'


	  write(*,*) 'GRT info : '

! replace getting station names from imenu = imenustations with
! those listed in stations.cat having sttype = 1

        call get_stat( outunit, stafile, stname, sttype, stlat, 
     1  stlong, stx, sty, stz, stzalim1, stzalim2,  sthalim, 
     2  stdiam, stslew1, stslew2, stband_name, stband_tsys, 
     3  stband_effic, stband_tsys_jy, aeiowmorb, yearorb, mnthorb, 
     4  dayorb, utorb, teledir, telangle, sunavoid, antisunavoid, 
     5  moonavoid, eclipmult, eclipadd, stnarray, starray_name, 
     6  sttapetype_name, ier, nst, stname_in, st_init)

	write(*,*) 'finding station names: '
	write(*,*) 'nst: ', nst

	inum_max(imenu) = 0
	
	do i=1,nst

	 stname = stname_in(i)

        call get_stat( outunit, stafile, stname, sttype, stlat, 
     1  stlong, stx, sty, stz, stzalim1, stzalim2,  sthalim, 
     2  stdiam, stslew1, stslew2, stband_name, stband_tsys, 
     3  stband_effic, stband_tsys_jy, aeiowmorb, yearorb, mnthorb, 
     4  dayorb, utorb, teledir, telangle, sunavoid, antisunavoid, 
     5  moonavoid, eclipmult, eclipadd, stnarray, starray_name, 
     6  sttapetype_name, ier, nst, stname_in, st_init)

	write(*,*) 'found station: ',stname,sttype


	if(sttype.eq.1) then
	inum_max(imenu) = inum_max(imenu) + 1

	defname_in(inum_max(imenu),imenu,1) = stname
	defname_in(inum_max(imenu),imenu,2) = stname
	defname_in(inum_max(imenu),imenu,3) = stname

	write(*,*) 'select station: '
     1  ,defname_in(inum_max(imenu),imenu,1),inum_max(imenu)

	end if


	end do

	inum = inum_max(imenu)
	icol = 6 
	irow = (inum/icol) + 1

	write(*,*) 'icol, inum, irow : ', icol, inum, irow

	do i =1,3
	 icol_in(imenu,1) = icol
	 irow_in(imenu,2) = irow
	 inum_in(imenu,3) = inum
	end do


	else


	do i=1,inum_max(imenu)

          stname=defname_in(i,imenu,1)(1:8)

	  if(debug) write(*,'(a)') stname

         call get_stat( outunit, stafile, stname, sttype, stlat, 
     1  stlong, stx, sty, stz, stzalim1, stzalim2,  sthalim, 
     2  stdiam, stslew1, stslew2, stband_name, stband_tsys, 
     3  stband_effic, stband_tsys_jy, aeiowmorb, yearorb, mnthorb, 
     4  dayorb, utorb, teledir, telangle, sunavoid, antisunavoid, 
     5  moonavoid, eclipmult, eclipadd, stnarray, starray_name, 
     6  sttapetype_name, ier, nst, stname_in, st_init)


	 if(ier.eq.0) then
	  write(*,'(a)') defname_in(i,imenu,1)//'does not EXIST in '//stafile(1:16)
	  ier_get_stat = ier_get_stat + 1
	 else
!	  write(*,'(a)') defname_in(i,imenu,1)//'does EXIST'
	 end if

	end do

	end if  !if(.not.ignore)

          imenu = imenutrack


!          outc = 6

	  if(debug) write(*,*) 'tracking station info : '

	do j=1,2
	 do i=1,inum_in(imenu,j)

          stname=defname_in(i,imenu,j)(1:8)

	  if(debug) write(*,'(a)') stname

        call get_stat( outunit, stafile, stname, sttype, stlat, 
     1  stlong, stx, sty, stz, stzalim1, stzalim2,  sthalim, 
     2  stdiam, stslew1, stslew2, stband_name, stband_tsys, 
     3  stband_effic, stband_tsys_jy, aeiowmorb, yearorb, mnthorb, 
     4  dayorb, utorb, teledir, telangle, sunavoid, antisunavoid, 
     5  moonavoid, eclipmult, eclipadd, stnarray, starray_name, 
     6  sttapetype_name, ier , nst, stname_in, st_init)

	 if(ier.eq.0) then
	  write(*,'(a)') defname_in(i,imenu,j)//'does NOT EXIST in '//stafile(1:16)
	  ier_get_stat = ier_get_stat + 1
	 else
!	  write(*,'(a)') defname_in(i,imenu,j)//'does EXIST'
	 end if

	 end do
	end do


	  if(debug) write(*,*) 'SRT info : '

	do j=1,2

          if(j.eq.1) then
	    stname='VSOP'
	  else
	   stname='RASTRON'
	  end if

	 if(debug) then
	  write(*,'(a)') stname
	 end if

        call get_stat( outunit, stafile, stname, sttype, stlat, 
     1  stlong, stx, sty, stz, stzalim1, stzalim2,  sthalim, 
     2  stdiam, stslew1, stslew2, stband_name, stband_tsys, 
     3  stband_effic, stband_tsys_jy, aeiowmorb, yearorb, mnthorb, 
     4  dayorb, utorb, teledir, telangle, sunavoid, antisunavoid, 
     5  moonavoid, eclipmult, eclipadd, stnarray, starray_name, 
     6  sttapetype_name, ier, nst, stname_in, st_init)


	 if(ier.eq.0) then

	  write(*,'(a)') defname_in(i,imenu,j)//'does NOT EXIST in '//stafile(1:16)
	  ier_get_stat = ier_get_stat + 1

	 else

!	  write(*,'(a)') defname_in(i,imenu,j)//'does EXIST'

	  do i=1,nstbandmax
	   if(stband_name(i).ne.'  ') then

	    if(debug) then
	    write(*,'(a)') 'has band  ->'//stband_name(i)(1:2)//'<-'
	    end if

	   end if
	  end do

	 end if !if(ier.eq.0)

	end do


	if(ier_get_stat.ge.1) goto 2015





1000	continue

	run=.false.
	buffer=.false.

	ytop=ytop_start

	if(inter) then

	imenu=1  ! header='mode:'
	header='mode:'

	imenumode=imenu

	icol=6
	irow=1
	inum=6
	dx=15
!	dy=6

	usevalue=.false.
	onlyone=.true.
	toggle=.false.

	name(1)='input'
	name(2)='run'
	name(3)='system info'
	name(4)='write defs'
	name(5)='restore defs'
	name(6)='exit'

	defselect(1,imenu)=.true.
	defselect(2,imenu)=.false.
	defselect(3,imenu)=.false.
	defselect(4,imenu)=.false.
	defselect(5,imenu)=.false.
	defselect(6,imenu)=.false.


!	 dx=15
	 dx=14
 	 imenu=1  ! header='mode: '

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	initmenu(imenu)=.true.

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,2)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do

! note: use of cursor=.false. in subroutine call

	dx=12 !2-Aug-95

	call menu(icol,irow,inum,name,dx,nrows, x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  .false.,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	end if


	if(cursor) then

! 	 call pgvport(0.0,1.0,0.0,1.0)
	 call pgvport(x1vp,x2vp,y1vp,y2vp)
	 call pgwindow(0.0,1.0,0.0,1.0)


	 if(input_cursor) then
	  input_cursor=.false.
! value of xc puts cursor in input box
	  xc = 0.14
	 end if


	 call pgcurse(xc,yc,c1)



! create help.dvi file if cursor in headbox

	   call headbox(x1vp,x2vp,y1vp,y2vp, ytop_start,xc,yc,
     1     header_top,itopbox,itoptext,iboxblack,iboxwhite,
     2     iselect,cursor)

! change iuse = 1 if you want to check if stations.cat has
! changed after each call to pgcurse. If iuse = o then the
! updated stations.cat file is read in only when fakesat_init is
! first run

	  iuse = 0

	  if(iuse.eq.1) then

	  call stations_init(init)

	  if(init) then
	   write(*,*) ' '
           write(*,*) '*** stations.cat file has been changed ***'
	   write(*,*) '*** re-initalizing menu                ***'
           write(*,*) ' '
	   goto 3050
	  end if

	  end if

	end if

!	write(*,*) 'at 1000: cursor, output:',cursor, output
!	write(*,*) 'at 1000: xc,yc,c1: ',xc,yc,c1



	if(inter) then

! note two calls to imenu=1 before and after pgcurse

	imenu=1  ! header='mode:'
	header='mode:'

	imenumode=imenu


	found=.false.
	ytop=ytop_start


	icol=6
	irow=1
	inum=6
	dx=15
!	dy=6

	usevalue=.false.
	onlyone=.true.
	toggle=.false.


	name(1)='input'
	name(2)='run'
	name(3)='system info'
	name(4)='write defs'
	name(5)='restore defs'
	name(6)='exit'

	defselect(1,imenu)=.true.
	defselect(2,imenu)=.false.
	defselect(3,imenu)=.false.
	defselect(4,imenu)=.false.
	defselect(5,imenu)=.false.
	defselect(6,imenu)=.false.


!	 dx=15
	 dx=14
 	 imenu=1  ! header='mode: '

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do

	dx=12 !2-Aug-95

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	call pgebuf
	if(buffer) call pgbbuf

	if(.not.select(1,imenu)) then
	  input_cursor=.true.
	end if
		
	if(select(2,imenu)) then
	  run=.true.

! if run is selected write-out defaults file 
!	  select(5,imenu) = .true.

	  ifound=0
	  
	  do i=1,10
	   if(keep(i)) ifound=ifound+1
	  end do

	  if(ifound.gt.10) then
	   write(*,*) 'Exiting program: you have 10 Postscript files'
	   goto 2000
	  else
	   do j=1,10
	    iout=mod(iout+1,10)
	    if(.not.keep(j)) goto 5
	   end do
	 end if

5	continue


	  output=.true.
	  cursor=.false.
	  found=.false.


	end if

	if(select(4,imenu)) then

	 write(*,*) '______________________________________________________________ '
!	 write(*,*) ' '
	 write(*,*) 'System Information :'
!	 write(*,*) ' '



	 write(*,*) '______________________________________________________________ '
	 write(*,*) ' '
	 write(*,*) 'Fakesat_plot files created and their size in kilobytes :'
	 write(*,*) ' '
	 call system('fakesat_system ls_plot')
	 write(*,*) ' '

	 write(*,*) '______________________________________________________________ '
	 write(*,*) ' '
	 write(*,*) 'Fakesat_def files created and their size in kilobytes :'
	 write(*,*) ' '
	 call system('fakesat_system ls_def')

	 write(*,*) '______________________________________________________________ '
	 write(*,*) ' '
	 write(*,*) 'model files in model subdirectory :'
	 write(*,*) ' '
	 call system('fakesat_system ls_model')

	 write(*,*) '______________________________________________________________ '
	 write(*,*) ' '
	 write(*,*) 'Total number of fakesat_plot files created :'
	 write(*,*) ' '
	 call system('fakesat_system ls_plot_num ')
	 write(*,*) ' '

	 write(*,*) '______________________________________________________________ ' 
	 write(*,*) ' '
	 write(*,*) 'Total number of def files created :'
	 write(*,*) ' '
	 call system('fakesat_system ls_def_num')


	 write(*,*) '______________________________________________________________ '
	 write(*,*) ' '
	 write(*,*) 'Fakesat processes running :'
	 write(*,*) ' '
	 call system('fakesat_system proc')


	 write(*,*) ' '
	 write(*,*) '______________________________________________________________ '


	  output=.false.
 	  found=.false.

	end if

	if(select(1,imenu)) then
	  output=.false.
 	  found=.false.
	 if(initial) then
	  cursor=.false.
	 else
	  cursor=.true.
	 end if
	end if


	if(select(3,imenu)) then

!	call system('/bin/rm def*')
!	call system('/bin/rm fakesat_plot*')

! convert removing files to stopping last job

	call system('fakesat_system kill')


!	  output=.false.
!	  found=.false.
	end if


	if(select(8,imenu)) then
	  goto 2000
	end if

! IF write defaults the write out:
! def_file and menu_defaults
!
! IF run and plot write out:
! def_file only

	iw = 0
	if(select(5,imenu)) iw = 2
	if(run.and.plot)    iw = 1

!	write(*,*) 'iw, plot, def_file: ',iw,plot,def_file


!	if(select(5,imenu)) then

	if(iw.gt.0) then

	do iwrite=1,iw


! write out defaults file : menu_defaults  


!	call system('/bin/rm menu_defaults.1')
!	call system('/bin/cp menu_defaults menu_defaults.1')

!	open(2,file='menu_defaults',status='unknown')


!	if(run) then
!	 open(2,file=def_file,status='unknown')
!	else
! 	 open(2,file='menu_defaults',status='unknown')
!	end if

	if(iwrite.eq.1) then
	 write(*,*) 'open for writing:'
	 write(*,'(a)') def_file
	 open(2,file=def_file,status='unknown')
	else
	 write(*,*) 'open for writing:'
	 write(*,*) 'menu_defaults'
         open(2,file='menu_defaults',status='unknown')
	end if

	 write(*,*) '______________________________________________________________'
	 write(*,*) ' '
	 write(*,*) '*** writing out defaults file: ***'
	 write(*,*) ' '
	 if(iwrite.eq.1) write(*,'(a)') def_file
	 if(iwrite.eq.2) write(*,'(a)') 'menu_defaults'
	 write(*,*) ' '
	 write(*,*) '______________________________________________________________'
	 write(*,*) ' '
	 write(*,*) ' '

	 iostat=0
!	 imenusum=0

	 line_tmp=' '
	 line_tmp(17:17)=separator(17:17)
	 line_tmp(33:33)=separator(17:17)
	 line_tmp(49:49)=separator(17:17)
	 line_tmp(65:65)=separator(17:17)
	 line_tmp(81:81)=separator(17:17)
	 line_tmp(97:97)=separator(17:17)
	 line_tmp(113:113)=separator(17:17)


	 write(2,'(a)') separator


	 line_in=line_tmp
	 line_in(1:4)='isat'
	 write(line_in(18:20),'(i3)') isat
!	 write(line_in(34:34),'(l1)')  simple_menu


	 write(2,'(a)') line_in

!	 write(*,'(a)') line_in



	 write(2,'(a)') separator

	do j=1,imenusum

! bug here replace imenu with imenu1

	 imenu1= imenunum_in(j)

	 line_in=line_tmp
	 line_in(17:17)=' '
	 line_in(33:33)=' '
	 line_in(1:48)=header_in(imenu1)
         line_in(82:112)=tex_file(imenu1)

!	 write(line_in(66:66),'(l1)') sh(imenu1)

	 write(line_in(66:66),'(l1)') menu_s(imenu1)
	 write(line_in(67:67),'(l1)') menu_c(imenu1)


!	 write(*,'(a)') tex_file(imenu1)
!	 write(*,*) 'write1: imenu1, sh(imenu1)',imenu1, sh(imenu1)

	 write(2,'(a)') line_in

!	 write(*,'(a)') line_in

!	 imenusum=imenusum+1

	 line_in=line_tmp
	 line_in(1:5)='imenu'
	 write(line_in(18:20),'(i3)') imenu1
	 write(2,'(a)') line_in


	 line_in=line_tmp
	 line_in(1:4)='inum'
	 write(line_in(18:20),'(i3)') inum_in(imenu1,1)
	 write(line_in(34:36),'(i3)') inum_in(imenu1,2)
	 write(line_in(50:52),'(i3)') inum_in(imenu1,3)
	 write(2,'(a)') line_in

	 line_in=line_tmp
	 line_in(1:4)='icol'
	 write(line_in(18:20),'(i3)') icol_in(imenu1,1)
	 write(line_in(34:36),'(i3)') icol_in(imenu1,2)
	 write(line_in(50:52),'(i3)') icol_in(imenu1,3)
	 write(2,'(a)') line_in


	 line_in=line_tmp
	 line_in(1:4)='irow'
	 write(line_in(18:20),'(i3)') irow_in(imenu1,1)
	 write(line_in(34:36),'(i3)') irow_in(imenu1,2)
	 write(line_in(50:52),'(i3)') irow_in(imenu1,3)
	 write(2,'(a)') line_in

	 line_in=line_tmp
	 line_in(1:8)='usevalue'
	 write(line_in(18:18),'(l1)') usevalue_in(imenu1)
	 write(2,'(a)') line_in

	 line_in=line_tmp
	 line_in(1:7)='onlyone'
	 write(line_in(18:18),'(l1)') onlyone_in(imenu1)
	 write(2,'(a)') line_in

	 line_in=line_tmp
	 line_in(1:6)='toggle'
	 write(line_in(18:18),'(l1)') toggle_in(imenu1)
	 write(2,'(a)') line_in


	 if(usevalue_in(imenu1)) then

	   do i=1,inum_max(imenu1)


	    line_in=line_tmp

	    write(line_in(1:15),'(a)') defname_in(i,imenu1,1)
	    write(line_in(1:15),'(a)') defname_in(i,imenu1,2)
	    write(line_in(1:15),'(a)') defname_in(i,imenu1,3)

	    write(line_in(18:32),'(a)')  defvalue_in(i,imenu1,1,1)
	    write(line_in(34:48),'(a)')  defvalue_in(i,imenu1,2,1)
	    write(line_in(50:64),'(a)')  defvalue_in(i,imenu1,3,1)
	    write(line_in(66:80),'(a)')  defvalue_in(i,imenu1,1,2)
	    write(line_in(82:96),'(a)')  defvalue_in(i,imenu1,2,2)
	    write(line_in(98:112),'(a)') defvalue_in(i,imenu1,3,2)

	    write(2,'(a)') line_in

	   end do


	 else if(toggle_in(imenu1)) then 

	    line_in=line_tmp

	    write(line_in(18:32),'(a)') defname_in(1,imenu1,1)
	    write(line_in(34:48),'(a)') defname_in(1,imenu1,2)
	    write(line_in(50:64),'(a)') defname_in(1,imenu1,3)

	    write(line_in(66:66),'(l1)')  defselect_in(1,imenu1,1,1)
	    write(line_in(67:67),'(l1)')  defselect_in(1,imenu1,2,1)
	    write(line_in(68:68),'(l1)')  defselect_in(1,imenu1,3,1)
	    write(line_in(82:82),'(l1)')  defselect_in(1,imenu1,1,2)
	    write(line_in(83:83),'(l1)')  defselect_in(1,imenu1,2,2)
	    write(line_in(84:84),'(l1)')  defselect_in(1,imenu1,3,2)

	    write(2,'(a)') line_in

	    line_in=line_tmp

	    write(line_in(18:32),'(a)') defvalue_in(1,imenu1,1,1)
	    write(line_in(34:48),'(a)') defvalue_in(1,imenu1,2,1)
	    write(line_in(50:64),'(a)') defvalue_in(1,imenu1,3,1)

	    write(line_in(18:32),'(a)') defvalue_in(1,imenu1,1,2)
	    write(line_in(34:48),'(a)') defvalue_in(1,imenu1,2,2)
	    write(line_in(50:64),'(a)') defvalue_in(1,imenu1,3,2)

	    write(2,'(a)') line_in



	 else

! this deals with the onlyone = T  
! and when usevalue = onlyone = toggle = F that is, select many
! items from a list

	   do i=1,inum_max(imenu1)

	    line_in=line_tmp

	    line_in(1:15)=info_in(i,imenu1)(1:15)

	    write(line_in(18:32),'(a)') defname_in(i,imenu1,1)
	    write(line_in(34:48),'(a)') defname_in(i,imenu1,2)
	    write(line_in(50:64),'(a)') defname_in(i,imenu1,3)

! for imenu1=1 the mode menu always write out read defaults to
! write defaults

	    if(imenu1.eq.1) then
	    write(line_in(66:66),'(l1)')  defselect_in(i,imenu1,1,2)
	    write(line_in(67:67),'(l1)')  defselect_in(i,imenu1,2,2)
	    write(line_in(68:68),'(l1)')  defselect_in(i,imenu1,3,2)
	    else
	    write(line_in(66:66),'(l1)')  defselect_in(i,imenu1,1,1)
	    write(line_in(67:67),'(l1)')  defselect_in(i,imenu1,2,1)
	    write(line_in(68:68),'(l1)')  defselect_in(i,imenu1,3,1)
	    end if


	    write(line_in(82:82),'(l1)')  defselect_in(i,imenu1,1,2)
	    write(line_in(83:83),'(l1)')  defselect_in(i,imenu1,2,2)
	    write(line_in(84:84),'(l1)')  defselect_in(i,imenu1,3,2)

	    write(2,'(a)') line_in


	  end do


	 end if


	 write(2,'(a)') separator



	end do !do j=2,imenusum


26	continue
	close(2)

	end do !do iwrite=1,iw
	end if !if(iw.gt.0) then

	if(select(6,imenu)) then


! restore defaults

	 do j=2,imenusum

	  imenu1=imenunum_in(j)

	   do i=1,inum_max(imenu1)

! keep same option on screen  imenu = 3
! or imenu = 32 

	    if(imenu1.ne.3.and.imenu1.ne.32) then
	    do k=1,3
	    defselect_in(i,imenu1,k,1)=defselect_in(i,imenu1,k,2)
	    defvalue_in(i,imenu1,k,1)=defvalue_in(i,imenu1,k,2)
	    end do
	    end if
	   end do

	 end do

	  initial=.true.

! clear the screen

	   call pgbbuf

!	   call pgvport(0.0,1.0,0.0,ytop)
	   y2 = y1vp + ( y2vp-y1vp)*ytop
	   call pgvport(x1vp,x2vp,y1vp,y2)
	   call pgwindow(0.0,1.0,0.0,1.0)
	   call pgsci(iscreen)
	   call pgrect(0.0,1.0,0.0,1.0)

	 do imenu1=1,50
	  initmenu(imenu1)=.true.
	 end do




!	  initmenu(imenumode)=.false.
!	  initmenu(imenu)=.false.

	end if !if(select(6,imenu))







	if(select(7,imenu)) then

          goto 3060

	end if !if(select(7,imenu))



	end if !if(inter)






!info------------------------------------------------------------------------
!info--spacecraft:

	if(.not.inter) then
	 write(*,*) 'simulate VSOP or RADIOASTRON ? '
	end if

	if(inter) then

	imenu=2  ! header='spacecraft: '
	header='spacecraft:  '



	 icol=3
	 irow=1
	 inum=3
	 usevalue=.false.
	 onlyone=.true.
	 toggle=.false.
	 
	 name(1)='VSOP'
	 name(2)='RADIOASTRON'
	 name(3)='ground only'

	 defselect(1,imenu)=.true.


	 dx=15
 	 imenu=2  ! header='spacecraft: '

	 imenuspaceraft=imenu

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do


	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

! bug fix: set isat BEFORE defselect_in is set
! DWM 27-Apr-94


	  vsop=.false.
	  rastron=.false.

	 if(select(1,imenu)) then
	   typsat='1'
	   isat=1
	   vsop=.true.
	 end if

	 if(select(2,imenu)) then
	   typsat='2'
	   isat=2
	   rastron=.true.
	 end if

	 if(select(3,imenu)) then
	   typsat='3'
	   isat=3
	 end if

	 if(select(4,imenu)) then
	   typsat='4'
	   isat=4
	 end if

!	 write(*,*) 'isat now set to: ', isat

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
!	  write(*,*) 'i,imenu,isat,defselect_in(i,imenu,isat,1) :'
!	  write(*,*)  i,imenu,isat,defselect_in(i,imenu,isat,1)
	 end do


	 if(found) then
	   call pgbbuf
	   buffer=.true.
	   found=.false.
	   cursor=.false.
!	   call pgvport(0.0,1.0,0.0,ytop)
	   y2 = y1vp + ( y2vp-y1vp)*ytop
	   call pgvport(x1vp,x2vp,y1vp,y2)
	   call pgwindow(0.0,1.0,0.0,1.0)
	   call pgsci(iscreen)
	   call pgrect(0.0,1.0,0.0,1.0)
	 end if


	if(select(3,imenu).or.select(4,imenu)) then
	   gronly=.true.
	   space=.false.
	else
	  gronly=.false.
	  space=.true.
	end if


!	 if(select(1,imenu)) typsat='2'
!	 if(select(2,imenu)) typsat='2'
!	 if(select(3,imenu)) typsat='3'
!	 if(select(4,imenu)) typsat='4'

	if(typsat.ne.typsatold) then

	  initial=.true.

	 do i=1,50
	  do j=1,100
	   defselect(j,i)=.false.
	  end do
	 end do

	 do i=1,50
	  initmenu(i)=.true.
	 end do


!	  initmenu(2)=.false.

	  initmenu(imenumode)=.false.
	  initmenu(imenu)=.false.

	end if


	else

	write(*,*) '(1= VSOP 2 = RADIOASTRON)'
	write(*,*) '(default is VSOP)'
	read(*,'(a)') typsat

C-gam	if(typsat.eq.'') typsat='1'
	if(typsat.eq.' ') typsat='1'



	end if  !if(inter)







!info------------------------------------------------------------------------
!info--options:


	if(.not.inter) then
 	 write(*,*) 'available options are: '
	 write(*,*) ' '
	 write(*,*) '1 = ground   -plot spacecraft groundtrack '
	 write(*,*) '2 = uvplot   -plot uvplot of a source '
	 write(*,*) '3 = uvplotg  -plot an all-sky uvplot '
	 write(*,*) '4 = plotsat  -movie of earth as seen from source '
	 write(*,*) '5 = plotsat2 -movie of earth as seen from spacecraft '
	 write(*,*) '6 = uvplott  -uvplot of a source as a function of time'
	end if


!	write(*,*) ' '

	if(inter) then

 	imenu=3  ! header='options:'
	header='options:'

	imenuoptions = imenu



!	 icol=6
!	 irow=1

	 dx=15
!	 dy=6


	 usevalue=.false.
	 onlyone=.true.
	 toggle=.false.

	if(space) then

	 icol=6
	 irow=1
	 inum=6

         name(1)='ground track'
	 name(2)='uvplot'
	 name(3)='all-sky uvplot'
	 name(4)='time-uvplot'
	 name(5)='source view'
	 name(6)='sat view'

	 defselect(1,imenu)=.true.

	else

	 icol=2
	 irow=1
	 inum=2

	 name(1)='uvplot'
	 name(2)='source view'

	defselect(1,imenu)=.true.

	end if


	 dx=13
 	 imenu=3  ! header='options:'

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do
c	print*,'>  before call menu'
c	print*,'imenu=',imenu
c	print*,'icol,irow,inum=',icol,irow,inum
c	print*,'dx,nrows=',dx,nrows
c	print*,'x1vp,x2vp,y1vp,y2vp=',x1vp,x2vp,y1vp,y2vp
c	print*,'usevalue=',usevalue
c	print*,'onlyone,toggle,cursor=',onlyone,toggle,cursor
c	print*,'xc,yc,c1,found,header=',xc,yc,c1,found,header
c	print*,'ytop,sh(imenu)=',ytop,sh(imenu)
	

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

         


	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do




	
	do i=1,inum
	 if(select(i,imenu)) write(ans,'(i1)') i
	end do


	 if(found) then
	   call pgbbuf
	   buffer=.true.
	   found=.false.
	   cursor=.false.
!	   write(*,*) 'pgvport: ytop is : ',ytop

!	   call pgvport(0.0,1.0,0.0,ytop)
	   y2 = y1vp + ( y2vp-y1vp)*ytop
	   call pgvport(x1vp,x2vp,y1vp,y2)

	   call pgwindow(0.0,1.0,0.0,1.0)
	   call pgsci(iscreen)
	   call pgrect(0.0,1.0,0.0,1.0)
	 end if



	else


	write(*,*) 'which option number do you want ? (default=1 =>ground)'
	write(*,*) ' '
	read(*,'(a)') ans

C-gam	if(ans.eq.'') ans='1'
	if(ans.eq.' ') ans='1'

	end if

! reset plot logicals to false

!	 plotsat2=.false.
!	 ground  =.false.

	 data =.false.
	 uvplot  =.false.
	 plotgrtmenu =.false.
         plotcons=.false.
	 uvplotg =.false.
	 uvplott =.false.
	 xtraplots=.false.


	 if(gronly) then
	  plotsat=.false.
	 end if

	 

	if(space) then

!	 if(ans.eq.'2') ground   =.true.
!	 if(ans.eq.'7') plotsat2 =.true.

	 if(ans.eq.'1') uvplotg  =.true.
	 if(ans.eq.'2') uvplott  =.true.
	 if(ans.eq.'3') uvplot   =.true.
	 if(ans.eq.'4') plotcons   =.true.
	 if(ans.eq.'5') plotgrtmenu   =.true.
	 if(ans.eq.'6') data =.true.
	 if(ans.eq.'7') xtraplots =.true.


	else

	 if(ans.eq.'1') plotsat =.true.
	 if(ans.eq.'2') uvplot  =.true.
	 if(ans.eq.'3') data    =.true.

	end if


	 if(output) then

	 iline=1

	 do i=1,200
	  line(i)=' '
	 end do

!	 if(pscolor) then
!	  line(iline)='csh '
!	  iline=iline+1
!	  line(iline)='setenv PGPLOT_PS_COLOR 1 '
!	  iline=iline+1
!	 end if

!	 if(psnocolor) then
!	  line(iline)='csh '
!	  iline=iline+1
!	  line(iline)='unsetenv PGPLOT_PS_COLOR '
!	  iline=iline+1
!	 end if


	  line(iline)='fakesat <<EOD '
	  iline=iline+1

!	 if(xtraplots) then
!	  line(iline)='CONSPLOT  '
!	  iline=iline+1
!	 end if


	if(space) then

	 if(uvplot)       line(iline)='UVPLOT'
!	 if(plotgrtmenu)  line(iline)='PLOTGRT'
	 if(plotcons) line(iline)='PLOTCONS'
	 if(uvplotg)  line(iline)='UVPLOTG'
	 if(uvplott)  line(iline)='UVPLOTT'
!	 if(data)     line(iline)='UVDIST'
	 iline=iline+1

!	 if(xtraplots)line(iline)='PLOTS'
!	 if(ground)   line(iline)='GROUND'
!	 if(plotsat2) line(iline)='PLOTSAT2'

	 if(.not.data) then
	  line(iline)='NODATA        '
	  iline=iline+1
	 end if

	else

	 if(uvplot)  line(iline)='UVPLOT'
	 if(plotsat) line(iline)='PLOTSAT'
	 iline=iline+1

	 if(.not.data) then
	  line(iline)='NODATA        '
	  iline=iline+1
	 end if

	end if


	end if !if(output)

	
	 plotnum = .false.
	 initstationsmenu = .false.
	 grtmap=.false.
	 plotgrt=.false.

	 if(plotgrtmenu) then

	 imenu=39

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do
	

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)


	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	if(select(1,imenu).or.select(2,imenu).or.select(3,imenu)) then
	   plotgrt=.true.
	   grtmap=.false.
	 else
	   plotgrt=.false.
	   grtmap=.true.
	 end if

	if(.not.initial) then

!	 write(*,*) '1:plotgrt,plotgrt_old,grtmap,grtmap_old: ',
!     1   plotgrt,plotgrt_old,grtmap,grtmap_old

	 if((plotgrt.ne.plotgrt_old).or.(grtmap.ne.grtmap_old)) then

	 call pgbbuf
	 buffer=.true.

! clear the screen

	   y2 = y1vp + ( y2vp-y1vp)*ytop
	   call pgvport(x1vp,x2vp,y1vp,y2)
	   call pgwindow(0.0,1.0,0.0,1.0)
	   call pgsci(iscreen)
	   call pgrect(0.0,1.0,0.0,1.0)

	   do i=1,50
	    initmenu(i)=.true.
	   end do

	  initmenu(imenumode)=.false.
	  initmenu(imenuoptions)=.false.
	  initmenu(imenuspacecraft)=.false.
	  initmenu(imenu)=.false.

	  initstationsmenu = .true.

	 end if
	end if

	  plotgrt_old=plotgrt
	  grtmap_old=grtmap

!	 write(*,*) '2:plotgrt,plotgrt_old,grtmap,grtmap_old: ',
!     1   plotgrt,plotgrt_old,grtmap,grtmap_old


	if(output) then
	 if(select(1,imenu)) then
	   line(iline)='PLOTGRT'
	   iline=iline+1
	 end if
	 if(select(2,imenu)) then
	   line(iline)='PLOTGRT'
	   iline=iline+1
	   line(iline)='PLOTNUM '
	   iline=iline+1
	 end if
	 if(select(3,imenu)) then
	   line(iline)='PLOTGRT'
	   iline=iline+1
	   line(iline)='PLOTPROB '
	   iline=iline+1
	 end if
	 if(select(4,imenu)) then
	   line(iline)='GRTMAP '
	   iline=iline+1
	 end if
	end if

	end if



	if(.not.ignore) then

	if(ground.or.uvplot.or.plotsat) then

	 write(*,*) 'Do you want a consplot.dat file to be used with'
	 write(*,*) 'program consplot to examine how constraints are met'
	 write(*,*) 'as a function of time ? (y=yes)'
	 write(*,*) '(default is NOT to produce a consplot.dat file)'
	 read(*,'(a)') ans

	 if(output.and.ans.eq.'y') then
	  line(iline)='CONSPLOT        '
	  iline=iline+1
	 end if

	end if

	end if

! reset 'extra plot' logicals to false outside if statement

!        plotcons=.false.
!	 plotgrt =.false.

	 ground=.false.
	 plotsat2=.false.
	 plotazel=.false.
         consplot=.false.
         complot =.false.
	 yzplot  =.false.
	 ecliplot  =.false.

	 if(.not.gronly) then
	  plotsat  =.false.
	 end if


	if(inter.and.xtraplots) then


!	 if(ground)   line(iline)='GROUND'
!	 if(plotsat2) line(iline)='PLOTSAT2'

	 dx=15

	 if(simple_menu) then
 	  imenu=43  ! header='plots:'
	 else
 	  imenu=32  ! header='plots:'
	 end if

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 dx = 13

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do

	 
	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	 if(found) then
	   call pgbbuf
	   buffer=.true.
	   found=.false.
	   cursor=.false.
!	   write(*,*) 'pgvport: ytop is : ',ytop

!	   call pgvport(0.0,1.0,0.0,ytop)
	   y2 = y1vp + ( y2vp-y1vp)*ytop
	   call pgvport(x1vp,x2vp,y1vp,y2)

	   call pgwindow(0.0,1.0,0.0,1.0)
	   call pgsci(iscreen)
	   call pgrect(0.0,1.0,0.0,1.0)
	 end if

	  if(select(1,imenu)) plotsat=.true.
	  if(select(2,imenu)) plotsat2=.true.
	  if(select(3,imenu)) ground=.true.
	  if(select(4,imenu)) plotazel=.true.
	  if(select(5,imenu)) complot=.true.
	  if(select(6,imenu)) yzplot=.true.
	  if(select(7,imenu)) ecliplot=.true.


	 if(output) then
	  if(ground)  then
	   line(iline)='GROUND '
	   iline=iline+1
	  end if
	  if(plotsat2)  then
	   line(iline)='PLOTSAT2 '
	   iline=iline+1
!
! CONSTRA needs to now be set to get plot to be erased
! after each time-step - need to investigate this further
!
!
	   line(iline)='CONSTRA '
	   iline=iline+1
	  end if
	  if(plotazel)  then
	   line(iline)='PLOTAZEL '
	   iline=iline+1
	  end if
	  if(complot)  then
	   line(iline)='COMPLOT '
	   iline=iline+1
	   line(iline)='CONSTRA  '
	   iline=iline+1
	  end if
	  if(yzplot)  then
	   line(iline)='YZPLOT '
	   iline=iline+1
	   line(iline)='CONSTRA  '
	   iline=iline+1
	  end if
	  if(ecliplot)  then
	   line(iline)='ECLIPLOT '
	   iline=iline+1
	  end if
	  if(plotsat)  then
	   line(iline)='PLOTSAT '
	   iline=iline+1
	  end if


	 end if


	end if !if(inter.and.xtraplots) 

	    dirty_beam = .false.
	    clean_map  = .false.
	    visplot    = .false.
	    modplot    = .false.

	if(data) then

	if(simple_menu) then
	 imenu=44
	else
	 imenu=38
	end if


	 icol=3
	 irow=1
	 inum=3

	 dx=15
!	 dy=6

	 usevalue=.true.
	 onlyone=.false.
	 toggle=.false.

	 dx = 13


	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do

	 
	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	 if(output) then

	   if(select(1,imenu)) then
	    line(iline)='UVDIST   '
	    iline=iline+1
	   end if

	   if(select(2,imenu)) then
	    line(iline)='SNRPLOT   '
	    iline=iline+1
	   end if


	   if(select(3,imenu)) then
	    line(iline)='MODELFIT   '
	    iline=iline+1
	   end if

	   if(select(4,imenu)) then
	     modplot   =.true.
	   end if


	   if(select(5,imenu)) then
	     visplot   =.true.
	    line(iline)='PHASE 0.0   '
	    iline=iline+1
	   end if


	   if(select(6,imenu)) then
	     dirty_beam=.true.
	   end if

	   if(select(7,imenu)) then
	     clean_map=.true.
	    line(iline)='PHASE 0.0   '
	    iline=iline+1
	   end if


	  if(.not.dirty_beam.and..not.clean_map.and..not.visplot
     1    .and..not.modplot)  then 
            line(iline)='UVDIST'
	    iline=iline+1
	  end if

	end if
       end if

! plotfile info:

	pscolor = .false.
	psnocolor = .false.

	if(inter) then

	imenu=22 ! header='output device: '
	header='output device: '



!	icol=1
!	irow=2

	icol=3
	irow=1

	inum=3
	dx=15
!	dy=6

	usevalue=.false.
	onlyone=.true.
	toggle=.false.

	name(1)='Xwindows'
	name(2)='pgdisp'
	name(3)='printer'

	defselect(1,imenu)=.true.



	 plot=.false.

	 if(plotsat.or.plotsat2) then

	 dx=15
 	 imenu=31

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do
	

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	  plotf = ' '


	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)

	  if(select(i,imenu)) then

!	   if(name(i)(5:5).eq.')') then
!            plotf(1:3)=name(i)(2:4)
!	   else
!            plotf(1:4)=name(i)(2:5)
!	   end if

	   plotf = plotf1

	  end if


	 
	 
	 end do

	
!	if(select(1,imenu)) plotf='/xserv'
!	if(select(2,imenu)) plotf='/xd'

	 else

	 dx=16
 	 imenu=22

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do
	

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	  plotf= ' '

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	
!	if(select(1,imenu)) plotf='/xserv'
!	if(select(2,imenu)) plotf='/xd'

	if(output) then

	if(.not.ignore) then

	do i=1,inum_max(imenu)
	if(select(i,imenu)) then
	 if(select(3,imenu).or.select(4,imenu)) then

	   plot=.true.

	  if(name(i)(5:5).eq.')') then
	   plotfname='.'//name(i)(3:4)
	   plotf='.'//name(i)(3:4)//'/'//name(i)(3:4)
	  else
	   plotfname='.'//name(i)(3:5)
	   plotf='.'//name(i)(3:5)//'/'//name(i)(3:5)
	  end if
  
	 else

	   if(name(i)(5:5).eq.')') then
             plotf(1:3)=name(i)(2:4)
	   else
             plotf(1:4)=name(i)(2:5)
	  end if

	  end if
	 end if
	end do

	end if !if(ignore)

	end if 

	plot=.false.
	if(.not.select(1,imenu)) plot=.true.

!	write(*,*) 'plot is: ', plot

	if(select(2,imenu)) then
	 plotmenu=.true.
	else
	 plotmenu=.false.
	end if


!	if(select(1,imenu)) plotf='/xserv'
	if(select(1,imenu)) plotf=plotf1

	if(select(2,imenu)) plotf='.vps/vps'
	if(select(3,imenu)) plotf='.ps/ps'
	if(select(4,imenu)) plotf='.cps/cps'

!	if(select(1,imenu)) plotfname='/xserv'
	if(select(1,imenu)) plotf=plotf1
	if(select(2,imenu)) plotfname='.vps'
	if(select(3,imenu)) plotfname='.ps'
	if(select(4,imenu)) plotfname='.cps'

! if these options selected generate color instead
! of b+w plot. Required to get `grey-scale' to come out
! correctly

	if(plotcons.or.plotgrt) then
	 if(select(2,imenu)) plotf='.vcps/vcps'
	 if(select(2,imenu)) plotfname='.vcps'
	 if(select(3,imenu)) plotf='.cps/cps'
	 if(select(3,imenu)) plotfname='.cps'
	end if

	if(grtmap) then
	 if(select(2,imenu)) plotf='.vps/vps'
	 if(select(2,imenu)) plotfname='.vps'
	 if(select(3,imenu)) plotf='.ps/ps'
	 if(select(3,imenu)) plotfname='.ps'
	end if



!	if(select(2,imenu).or.select(3,imenu)) pscolor=.true.
!	if(select(4,imenu).or.select(5,imenu)) psnocolor=.true.


	 end if !if(plotsat.or.plotsat2)


	else 



	   write(*,*) ' '
	   write(*,*) 'input of plotfile information :'
	   write(*,*) ' '
	   write(*,*)'default plotfile is /xserv (i.e. xwindows) '
	   write(*,*) 'change default ? (y=yes)'
	   read(*,'(a)') ans

	 if(ans.eq.'y') then
	   write(*,*) 'what plotfile do you want? '
	   write(*,*) '(possible other options are:                   ) '
	   write(*,*) '( /xd                 pgdisp                   ) '
	   write(*,*) '(plotfilename.ps/ps   Portrait Postscript file )'
	   write(*,*) '(plotfilename.vps/vps Landscape Postscript file)'
	   read(*,'(a)') plotf

C-gam	   if(plotf.eq.'') plotf='/xserv'
	   if(plotf(1:1).eq.' ') plotf='/xserv'

	 else
	   plotf='/xserv'
	 end if

	end if !if(inter)


	if(space.and..not.grtmap) then 
	if(inter) then

	imenu=4  ! header='orbit:
	header='orbit:'



!	 icol=1
!	 irow=1

	 icol=3
	 irow=3


	 inum=9
	 dx=15
!	 dy=6
	 usevalue=.true.
	 onlyone=.false.
	 toggle=.false.

	 name(1) = 'a (km)'
	 name(2) = 'e'
	 name(3) = 'i (\uo\d)'
	 name(4) = '\gW (\uo\d) '
	 name(5) = '\gw (\uo\d) '
	 name(6) = 'M (at 0 UT)'
	 name(7) = 'epoch-year'
	 name(8) = 'epoch-month'
	 name(9) = 'epoch-day'


	if(typsat.eq.'1') then
	  defvalue(1,imenu)='16878.138'
	  defvalue(2,imenu)='0.563'
	  defvalue(3,imenu)='31.0'
	  defvalue(4,imenu)='116.1'
	  defvalue(5,imenu)='134.2'
	  defvalue(6,imenu)='0.0'
	  defvalue(7,imenu)='1995'
	  defvalue(8,imenu)='9'
	  defvalue(9,imenu)='22'

! changed orbital elements on 5-MAY-93

	  defvalue(1,imenu)='16878.138'
	  defvalue(2,imenu)='0.563'
	  defvalue(3,imenu)='31.0'
	  defvalue(4,imenu)='116.1'
	  defvalue(5,imenu)='134.2'
	  defvalue(6,imenu)='0.0'
	  defvalue(7,imenu)='1995'
	  defvalue(8,imenu)='8'
	  defvalue(9,imenu)='1'


	  sname='VSOP'
	 if(output) then
	  line(iline)='TYPSAT = 1       '
	  iline=iline+1
	 end if
	else

	  defvalue(1,imenu)='46868.000'
	  defvalue(2,imenu)='0.8426'
	  defvalue(3,imenu)='51.6'
	  defvalue(4,imenu)='200.0'
	  defvalue(5,imenu)='300.0'
	  defvalue(6,imenu)='0.0'
	  defvalue(7,imenu)='1995'
	  defvalue(8,imenu)='9'
	  defvalue(9,imenu)='22'

! changed orbital elements on 5-MAY-93

	  defvalue(1,imenu)='171561.000'
	  defvalue(2,imenu)='0.778'
	  defvalue(3,imenu)='51.5'
	  defvalue(4,imenu)='345.0'
	  defvalue(5,imenu)='300.0'
	  defvalue(6,imenu)='0.0'
	  defvalue(7,imenu)='1996'
	  defvalue(8,imenu)='1'
	  defvalue(9,imenu)='1'


	  sname='RASTRON'
	 if(output) then
	  line(iline)='TYPSAT = 2       '
	  iline=iline+1
	 end if
	end if


	 dx=15
 	 imenu=4

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),     
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do



	if(run) then

	 if(.not.ignore) then

	 open(12,file='.orbit-tmp',status='unknown')
	 write(12,'(a)') value(1,imenu)
	 write(12,'(a)') value(2,imenu)
	 write(12,'(a)') value(3,imenu)
	 write(12,'(a)') value(4,imenu)
	 write(12,'(a)') value(5,imenu)
	 write(12,'(a)') value(6,imenu)
	 write(12,'(a)') value(7,imenu)
	 write(12,'(a)') value(8,imenu)
	 write(12,'(a)') value(9,imenu)
	 close(12)

	 open(12,file='.orbit-tmp',status='unknown')
	 read(12,*) asemi
	 read(12,*) eccen
	 read(12,*) incl
	 read(12,*) ran
	 read(12,*) aop
	 read(12,*) man
	 read(12,*) iys
	 read(12,*) ims
	 read(12,*) ids

         read(value(1,imenu),'(f12.4)') asemi

	 close(12)

	 asemi=asemi*1000.0

	end if


!	read(12,'(i5)') iys
!	read(12,'(i5)') ims
!	read(12,'(i5)') ids




	 do i=1,9
	  ovalue(i)=value(i,imenu)
	 end do

	 read(ovalue(1),'(f15.2)') asemi
	 read(ovalue(2),'(f6.4)') ecc

	  asemi=asemi*1000.0d0

	 write(ovalue(10),'(f15.2)') asemi


	

	end if

	
	orbit=sname


	else

	if(output) then
	if(typsat.eq.'1') then
	 write(*,*) 'what VSOP orbit to use ? '
	 write(*,*) '(default = V31_8_95) '
	 line(iline)='TYPSAT = 1        '
	 iline=iline+1
	else
	 write(*,*) 'what RADIOASTRON orbit to use ? '
	 write(*,*) '(default = R51-1_95) '
	 line(iline)='TYPSAT = 2       '
	 iline=iline+1
	end if
	end if

	 read(*,'(a)') orbit



	end if !if(inter)


	 if(typsat.eq.'1') then

C-gam	  if(orbit.eq.'') orbit='V31_8_95'
	  if(orbit(1:1).eq.' ') orbit='V31_8_95'

	 else

C-gam	  if(orbit.eq.'') orbit='R51-1_95'
	  if(orbit(1:1).eq.' ') orbit='R51-1_95'

	 end if






	if(uvplot.or.uvplotg.or.plotsat.or.uvplott
     1  .or.plotgrt.or.plotcons.or.data) then


	if(inter) then

	imenu=5  ! header='s/c constraints:'
	header='s/c constraints:'


	 icol=1
	 irow=1
	 inum=1
	 dx=15
!	 dy=6
	 usevalue=.false.
	 onlyone=.false.
	 toggle=.true.

	 name(1) = 'constraints'
	 defvalue(1,imenu) = 'no constraints'
	 defselect(1,imenu)=.true.

	 if(vsop) then

	 dx=17
 	 imenu=35

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do

	 
	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	
	if(select(3,imenu)) then
	  ans='n'
	  constra=.false.
	else
	 ans='y'
	 constra=.true.
	end if

	 if(output) then
	  if(select(1,imenu)) then
	   line(iline)='ANGYZ = 0.0        '
	   iline=iline+1
	  end if
	  if(select(2,imenu)) then
	   line(iline)='ANGYZ = 180.0        '    
	   iline=iline+1
	  end if
	 end if


	else

	 dx=15
 	 imenu=5

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do


	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	
	if(select(1,imenu)) then
	  ans='y'
	  constra=.true.
	else
	 ans='n'
	 constra=.false.
	end if




	end if 

	else

	  write(*,*) 'Apply spacecraft constraints ? (y=yes)'
	  write(*,*) '(default is to apply constraints)'
	  read(*,'(a)') ans

C-gam    if(ans.eq.'') ans='y'
      	 if(ans.eq.' ') ans='y'

	 if(ans.eq.'y') then
	  constra=.true.
	 else
	  constra=.false.
	 end if
	

	end if !if(inter)


	 if(output.and.ans.eq.'y') then
	  line(iline)='CONSTRA        '
	  iline=iline+1
	 end if


	end if

	 if(output.and.consplot) then
	   line(iline)='CONSTRA        '
	   iline=iline+1
	 end if

	end if !if(space) then 


	if(data.or.uvplot) then

	imenu=37  ! header='model_1:'


	 icol=3
	 irow=1
	 inum=3

	 dx=15
!	 dy=6

	 usevalue=.true.
	 onlyone=.false.
	 toggle=.false.


	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do

	 
	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	 if(output) then

	   write(modfile,'(a)') 'model/'//value(1,imenu)

	   line(iline)='MODEL  model/'//value(1,imenu)
	   iline=iline+1

	   line(iline)='SNRFLAG   '//value(2,imenu)
	   iline=iline+1



	   line(iline)='USEFWHM'
	   iline=iline+1

	   read(value(3,imenu),*)  tmp
	   write(str15,'(f15.8)')  alog10(tmp)


!	   line(iline)='LOGT1    '//value(3,imenu)
	   line(iline)='LOGFWHM1 '//str15
	   iline=iline+1
!	   line(iline)='LOGT2      '//value(3,imenu)
	   line(iline)='LOGFWHM2   '//str15
	   iline=iline+1
!	   line(iline)='LOGT3      '//' 1.0'
	   line(iline)='LOGFWHM3   '//' 1.0'
	   iline=iline+1

	   read(value(4,imenu),*)  tmp
	   write(str15,'(f15.8)')  alog10(tmp)

	   line(iline)='LOGS1   '//str15
	   iline=iline+1
	   line(iline)='LOGS2   '//str15
	   iline=iline+1
	   line(iline)='LOGS3   '//' 1.0'
	   iline=iline+1

	   line(iline)='RATIO   '//value(5,imenu)
	   iline=iline+1

	   line(iline)='PA        '//value(6,imenu)
	   iline=iline+1


	  end if

	end if


	if(space.and..not.grtmap) then


! tracking station info

	if(.not.inter) then
	 write(*,*) 'what tracking stations to use ?' 
	end if

	track(1)='GOLD-10'
	track(2)='TIDB-10'
	track(3)='MADR-10'
	track(4)='GBANK-10'

	if(typsat.eq.'1') then
	track(5)='USUDA-10'
	else
	track(5)='USSURISK'
	end if




	if(inter) then


	 dx=15
 	 imenu=imenutrack

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do


	
	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
	  track(i)=name(i)(1:8)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	  itrack=0

	do i=1,inum

	  if(select(i,imenu)) then
	   itrack=itrack+1
	   ntrack(itrack)=i
	  end if

	end do


	else

	write(*,*) 'There are 5 tracking stations available:'
	do i=1,5
	 write(*,*) i,' = '//track(i)
	end do

	
	 write(*,*) 'default is to use all of them '
	 write(*,*) 'change default ? (Y=yes)'
	 read(*,'(a)') ans

	if(ans.ne.'y') then

	 itrack=5

	do i=1,itrack
	 ntrack(i)=i
	end do

	else
	  itrack=0
	 do i=1,5
	   out='                            '
           out='use '//track(i)//' ? (n=no, default=yes)' 
	   write(*,'(a)') out
	   read(*,'(a)') ans2
	  if(ans2.ne.'n') then
	   itrack=itrack+1
	   ntrack(itrack)=i
	  end if
	 end do
	end if


	
	end if !if(inter)




	tracklist=track(ntrack(itrack))

	if(itrack.ge.2) then

	do i=2,itrack
	 tracklist=track(ntrack(1+itrack-i))//','//tracklist
	end do

	end if

	if(output) then
        line(iline)='TELEM      = '
	iline=iline+1
        line(iline)= tracklist	
        iline=iline+1
	end if


	end if  !if(space) 

! time info:

	if(.not.grtmap) then

	 dx=15
 	 imenu=7

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do

	
	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	year=value(1,imenu)

! New Sun compiler was interpreting '1999 ' as 19990
! with the i5 read statement. Old versions of compiler
! ignored trailing blank spaces. Now they are interpreted as zero 
! dwm 30-Jul-98
!	read(value(1,imenu),'(i5)') iy
!	read(value(2,imenu),'(i5)') im
!	read(value(3,imenu),'(i5)') id

 	read(value(1,imenu),'(i4)') iy

         ispace = index(value(2,imenu),' ')

        if(ispace.eq.2) then
    	 read(value(2,imenu),'(i1)') im
        else
  	 read(value(2,imenu),'(i2)') im
        end if

         ispace = index(value(3,imenu),' ')

        if (ispace.eq.4) then
    	 read(value(3,imenu),'(i3)') id
        else if (ispace.eq.3) then
  	 read(value(3,imenu),'(i2)') id
        else
	 read(value(3,imenu),'(i1)') id
        end if

        call DOW(id,im,iy,idw,day60,jd0,idnum)

	day=' '
	write(day,'(i3)') idnum


	if(output) then


!	write(*,*) 'iy,im,id,idnum',iy,im,id,idnum

!	day=value(2,imenu)

	end if

	 dx=15

	 if(.not.ecliplot) then
 	  imenu=8
	 else
	  imenu=36
	 end if

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do

	
	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do


	if(output) then

	 if(ecliplot) then

	 start='00:00:00'
	 stop='24:00:00'

	 read(value(1,imenu),'(i5)') idaystop
	 idaystop=idnum+idaystop-1
	 write(idaystopc,'(i5)') idaystop


	 else

	 start=value(1,imenu)
	 stop=value(2,imenu)

	 end if

	end if
	

	if(output) then
	  line(iline)='YEAR       = '//year
	  iline=iline+1
 1	  line(iline)='DAY        = '//day
	  iline=iline+1
	  line(iline)='START      = '//start
	  iline=iline+1
	  line(iline)='STOP       = '//stop
	  iline=iline+1
	 if(ecliplot) then
	  line(iline)='DAYSTOP       = '//idaystopc
	  iline=iline+1
	 end if
	end if

	else

	if(output) then
	  line(iline)='YEAR       =  1996'
	  iline=iline+1
	  line(iline)='DAY        =  1'
	  iline=iline+1
	  line(iline)='START      = 00:00:00'
	  iline=iline+1
	  line(iline)='STOP       = 00:10:00'
	  iline=iline+1
	end if

	end if



! frequency info

	if(.not.plotsat2.
     1  and..not.ground.and..not.plotazel.
     2  and..not.complot.and..not.yzplot.
     3  and..not.ecliplot) then

	if(inter) then

	imenu=9  ! header='band:'
	header='band:'


	 dx=15
!	 dy=6
	 usevalue=.false.
	 onlyone=.true.
	 toggle=.false.


	if(typsat.eq.'1') then

!	 icol=1
!	 irow=3


	 icol=3
	 irow=1

	 inum=3

	 name(1)='L-band'
	 name(2)='C-band'
	 name(3)='K-band'

	 defselect(1,imenu)=.false.
	 defselect(2,imenu)=.true.
	 defselect(3,imenu)=.false.

	else

!	 icol=1
!	 irow=4

	 icol=4
	 irow=1

	 inum=4

	 name(1)='P-band'
	 name(2)='L-band'
	 name(3)='C-band'
	 name(4)='K-band'

	 defselect(1,imenu)=.false.
	 defselect(2,imenu)=.false.
	 defselect(3,imenu)=.true.
	 defselect(4,imenu)=.false.


	end if


	if(.not.cursor.or..not.found)  then

	 dx=15
 	 imenu=9

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do

	
	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	 if(found) then
	   call pgbbuf
	   buffer=.true.
	   found=.false.
	   cursor=.false.
!	   write(*,*) 'pgvport: ytop is : ',ytop

!	   call pgvport(0.0,1.0,0.0,ytop)
	   y2 = y1vp + ( y2vp-y1vp)*ytop
	   call pgvport(x1vp,x2vp,y1vp,y2)

	   call pgwindow(0.0,1.0,0.0,1.0)
	   call pgsci(iscreen)
	   call pgrect(0.0,1.0,0.0,1.0)
	 end if

	end if

	

	if(typsat.eq.'1') then

	 do i=1,3
	  if(select(1,imenu)) band='l'
	  if(select(2,imenu)) band='c'
	  if(select(3,imenu)) band='k'
	 end do

	else

	 do i=1,4
	  if(select(1,imenu)) band='p'
	  if(select(2,imenu)) band='l'
	  if(select(3,imenu)) band='c'
	  if(select(4,imenu)) band='k'
	 end do

	end if

!	write(*,*) 'band is :'
!	write(*,'(a)') band


	else

	if(typsat.eq.'1') then
	 write(*,*) ' L, C and K-band are availble for VSOP' 
	else
	 write(*,*) 'P, L, C and K-band are availble for RADIOASTRON' 
	end if

	 write(*,*) 'which band do you want ? (default is C-band)'
	 read(*,'(a)') band

C-gam	if(band.eq.'') band='c'
	if(band.eq.' ') band='c'



	
	end if !if(inter)


	if(output) then
	if(band.eq.'p') line(iline)='FREQ       = '//'327'
	if(band.eq.'l') line(iline)='FREQ       = '//'1666'
	if(band.eq.'c') line(iline)='FREQ       = '//'5000'
	if(band.eq.'k') line(iline)='FREQ       = '//'22000'
	iline=iline+1
	end if

	else

!       fake needs a frequency

	if(output) then
	 line(iline)='FREQ       = '//'5000'
	 iline=iline+1
	end if

	end if


	if(inter) then

	if(.not.plotsat2.
     1  and..not.ground.and..not.plotazel.
     2  and..not.complot.and..not.yzplot.
     3  and..not.ecliplot) then

!	  if(select(1,imenu)) plotsat=.true.
!	  if(select(2,imenu)) plotsat2=.true.
!	  if(select(3,imenu)) ground=.true.
!	  if(select(4,imenu)) plotazel=.true.
!	  if(select(5,imenu)) complot=.true.
!	  if(select(6,imenu)) yzplot=.true.
!	  if(select(7,imenu)) ecliplot=.true.


	imenu=10 ! int period
	header=' '

	 icol = 1
	 irow = 1
	 inum = 1
	 dx=15
!	 dy=6

	 usevalue=.true.
	 onlyone=.false.
	 toggle=.false.


	 defvalue(1,imenu)='300'

	name(1)='int period (s)'

	 dx=15
	if(uvplott.or.uvplotg.or.plotsat) then
 	 imenu=40
	else
 	 imenu=10
	 if(vsop.and.band.eq.'c') imenu = 46
	 if(vsop.and.band.eq.'k') imenu = 47
	end if
	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)
	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do


	if(band.ne.bandold) initmenu(10)=.true.
	if(band.ne.bandold) initmenu(46)=.true.
	if(band.ne.bandold) initmenu(47)=.true.

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
          defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

! change bandwidth and sampling values for that all 3 VSOP sub-menus
! are the same 

	 if(imenu.eq.10.or.imenu.eq.46.or.imenu.eq.47) then

	 do i=2,inum_max(imenu)
          defvalue_in(i,10,isat,1) =value(i,imenu)
          defvalue_in(i,46,isat,1) =value(i,imenu)
          defvalue_in(i,47,isat,1) =value(i,imenu)
	 end do

	end if

	integ=value(1,imenu)
!	read(value(1,imenu),'(f15.5)') t_int 
	read(value(1,imenu),*) t_int 

!	bandw = '64.0'

        bandw=value(2,imenu)
!	read(bandw,'(f10.3)') bandwidth
	read(bandw,*) bandwidth

	read(value(3,imenu),'(i1)') isampling

	if(isampling.eq.1) then
	  one_bit=.true.
	else
	  one_bit=.false.
	end if


!	write(*,*) 't_int,t_int_old',t_int,t_int_old
!	write(*,*) 'bandwidth,bandwidth_old',bandwidth,bandwidth_old
!	write(*,*) 'isampling,isampling_old',isampling,isampling_old


	if(initial) initstationsmenu=.true.

	if(initstationsmenu) then
         initmenu(imenustations)=.true.
	else
         initmenu(imenustations)=.false.
	end if

	if(t_int.ne.t_int_old)         initmenu(imenustations)=.true.
	if(bandwidth.ne.bandwidth_old) initmenu(imenustations)=.true.
	if(isampling.ne.isampling_old) initmenu(imenustations)=.true.


	if(debug) then
	 write(*,'(a)') 'integ: ', integ
	 write(*,*) 'bandwith (MHz): ',bandwidth
	 write(*,*) 't_int: ', t_int
	 write(*,*) 'one_bit: ', one_bit
	 write(*,*) 'initmenu(imenustations): ', initmenu(imenustations)
	end if

	if(output) then
	line(iline)='BAND      = '//bandw	
        iline=iline+1
	end if

	if(output) then
	 if(.not.one_bit) then
	  line(iline)='ONE_BIT   =  -1'	
          iline=iline+1
	 end if
	end if

	else

	imenu=11 ! int period
	header=' '

	 icol = 1
	 irow = 1
	 inum = 1
	 dx=15
!	 dy=6

	 usevalue=.true.
	 onlyone=.false.
	 toggle=.false.


	 defvalue(1,imenu)='900'

	name(1)='int period (s)'

	 dx=15

	 if(ground) then
 	  imenu=41
	 else
 	  imenu=11
	 end if

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	integ=value(1,imenu)
!	read(value(1,imenu),'(f15.5)') t_int
	read(value(1,imenu),*) t_int


	end if




	if(uvplot.or.plotsat.or.uvplott.or
     1   .consplot.or.complot.or.yzplot.or
     2   .plotgrt.or.plotcons.or.data) then



	imenu=12 ! source:
	header='source: '

	 icol = 6
	 irow = 1
	 inum = 6
	 dx=15
!	 dy=6

	 usevalue=.false.
	 onlyone=.true.
	 toggle=.false.

	name(1)='1934-638'
	name(2)='Cen-A'
	name(3)='3C273' 
	name(4)='3C345'
	name(5)= '1928+738' 
	name(6)='other'  



! change default source from 3C273 to 3C345
! DWM 7JUL93

!	defselect(3,imenu)=.true.
	defselect(4,imenu)=.true.

	 dx=15
 	 imenu=12

	 imenusource=imenu

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
! note defname_in(i,imenu,1) NOT defname_in(i,imenu,isat)
	  name(i)=defname_in(i,imenu,1)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do	

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)


	    new_source = .false.
	    source=value(1,imenu)

	 if(value(1,imenu).ne.defvalue(1,imenu)) then
	  new_source = .true.
!	  write(*,*) '** new source  ***'
	 end if

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	 if(new_source) then

! Note: sources.cat files HAS to be in a certain format for this to work

	  open(14,file='sources.cat',status='old',err=2016)

	  iostat=0

	  found_source = .false.

	  do while (iostat.eq.0)
	   read(14,'(a)',iostat=iostat,end=251) sline2
!	   write(*,'(a)') sline2

	   if(sline2(9:16).eq.value(1,imenu)(1:8)) then
	     found_source = .true.
	     ra_source = ' '
	     dec_source = ' '
	     ra_source  = sline2(22:34)
	     dec_source = sline2(40:52)
!	     write(*,*) 'ra and dec of source are: '
!	     write(*,'(a)') ra_source
!	     write(*,'(a)') dec_source     
	   end if
	
	  end do

251	 continue

	  close(14)

	   if(.not.found_source) then
	    ra_source = '00:00:00.00 '
	    dec_source = '00:00:00.00 '
	    sline2 = ' '
	    sline2=  '*** WARNING: '//source//' not in sources.cat file'
	    write(*,*) ' '
	    write(*,'(a)') sline2
	    write(*,*) ' '
	   end if

	   if(.not.found_source) then

	     do i=1,8
	      found_num(i)=.false.
	     end do

	      string_num='0123456789'

	    do i=1,4
	     do j=1,10
	      if(source(i:i).eq.string_num(j:j))  then
	       found_num(i)=.true.
	      end if
	     end do
	    end do

	     do j=1,10
	      if(source(5:5).eq.'+')  then
	       found_num(5)=.true.
	      end if
	     end do

	     do j=1,10
	      if(source(5:5).eq.'-')  then
	       found_num(5)=.true.
	      end if
	     end do

	    do i=6,8
	     do j=1,10
	      if(source(i:i).eq.string_num(j:j))  then
	       found_num(i)=.true.
	      end if
	     end do
	    end do

	   if(found_num(1)) then
	   if(found_num(2)) then
	   if(found_num(3)) then
	   if(found_num(4)) then
	   if(found_num(5)) then
	   if(found_num(6)) then
	   if(found_num(7)) then
	   if(found_num(8)) then

	    ra_source = '   '
	    dec_source = '   '

	    ra_source(1:2) = source(1:2)
	    ra_source(3:3) = ':'
	    ra_source(4:5) = source(3:5)
	    ra_source(6:8) = ':00'

	    if(source(5:5).eq.'-') then
	     dec_source(1:1) = '-'
	    else
	     dec_source(1:1) = ' '
	    end if

	    dec_source(2:3) = source(6:7)
	    dec_source(4:4) = ':'

	    read(source(8:8),'(i1)') i1
	    write(dec_source(5:6),'(i2)') i1*6

	    if(dec_source(5:5).eq.' ') then
	      dec_source(5:5) = '0'
	    end if

	    dec_source(7:9) = ':00'
	     	  
	   end if
	   end if
	   end if
	   end if
	   end if
	   end if
	   end if
	   end if

	     
	  end if !if(.not.found_source)

	
	 end if !if(new_source)



	  imenuradec=29



	imenu=29 ! RA, Dec
	header=' '

	 icol = 2
	 irow = 1
	 inum = 2
	 dx=15
!	 dy=6

	 usevalue=.true.
	 onlyone=.false.
	 toggle=.false.

	name(1)='RA'
	name(2)='Dec'  


	 dx=17
 	 imenu=29

! change source co-ordinates if new source

	 if(new_source) then
	   defvalue_in(1,imenu,isat,1) = ra_source
	   defvalue_in(2,imenu,isat,1) = dec_source
	   if(.not.initmenu(imenu)) initmenu(imenu)=.true.
	 end if


	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do

	 do i=1,inum_max(imenusource)
	  if(select(i,imenusource)) then
	   if(i.eq.1) then
	    defvalue(1,imenu)=defvalue_in(1,imenu,isat,1)
	    defvalue(2,imenu)=defvalue_in(2,imenu,isat,1)
	   else
	    defvalue(1,imenu)=defname_in(i,imenusource,2)
	    defvalue(2,imenu)=defname_in(i,imenusource,3)
	  end if
	 end if
	end do



	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)


	 do i=1,inum_max(imenu)
           defselect_in(i,imenu,isat,1)=select(i,imenu)

! only write out RA, Dec if source is other 
!	  if(select(1,imenusource)) then

	   defvalue_in(i,imenu,isat,1) =value(i,imenu)

!	  end if

	 end do
	

	 RA=value(1,imenu)
	 DEC=value(2,imenu)


	else

	if(output) then
	 line(iline)='RA         = 00:00:00 !dummy variable'
	 iline=iline+1
	 line(iline)='DEC        = 00:00:00 !dummy variable'
	 iline=iline+1
	end if

	end if


	if(output) then
	line(iline)='INTEG      = '//integ	
        iline=iline+1
	end if


	if(output) then
	line(iline)='BNAME      = '//bandupper	
        iline=iline+1
	end if


	if(uvplot.or.plotsat.or.uvplott.
     1  or.consplot.or.complot.or.yzplot.
     2  or.plotgrt.or.plotcons.or.data) then

	if(output) then
	line(iline)='SOURCE     = '//source
	iline=iline+1
	line(iline)='RA         = '//RA
	iline=iline+1
	line(iline)='DEC        = '//DEC
	iline=iline+1
	end if

	else 

	if(output) then
	line(iline)='RA         = 00:00:00 !dummy variable'
	iline=iline+1
	line(iline)='DEC        = 00:00:00 !dummy variable'
	iline=iline+1
	end if

	end if


	else

! integration period

	write(*,*) 'Integration period of data in seconds ?'

	if(ground.or.uvplot.or.uvplotg.or.uvplott.or.xtraplots) then
	 default='300.0'
	else
	 default='900.0'
	end if

	out='(default is '//default(1:6)//')'

	write(*,'(a)') out

	read(*,'(a)') integ

C-gam	if(integ.eq.'') integ=default(1:6)
	if(integ.eq.'      ') integ=default(1:6)

	if(output) then
	line(iline)='INTEG      = '//integ	
        iline=iline+1
	end if

! source info


	if(uvplot.or.plotsat.or.uvplott.or.
     1  consplot.or.complot.or.yzplot.or.
     2  plotgrt.or.plotcons.or.data) then


	write(*,*) 'source name (<8 characters)'
	write(*,*) '(default= 3C345)'
	read(*,'(a)') source

C-gam	if(source.eq.'') source='3C345'
	if(source.eq.'        ') source='3C345'

	write(*,*) 'RA in hh:mm:ss.ss ?'
	write(*,*) '(default 16:41:18.4)'
	read(*,'(a)') RA

C-gam	if(RA.eq.'') RA='16:41:18.4'
	if(RA.eq.'           ') RA='16:41:18.4'

	write(*,*) 'Dec in dd:mm:ss.ss ?'
	write(*,*) '(default 39:54:10)'
	read(*,'(a)') DEC

C-gam	if(DEC.eq.'') DEC='39:54:10'
	if(DEC.eq.'           ') DEC='39:54:10'

	if(output) then
	line(iline)='SOURCE     = '//source
	iline=iline+1
	line(iline)='RA         = '//RA
	iline=iline+1
	line(iline)='DEC        = '//DEC
	iline=iline+1
	end if
	

	else

	if(output) then
	line(iline)='RA         = 00:00:00 !dummy variable'
	iline=iline+1
	line(iline)='DEC        = 00:00:00 !dummy variable'
	iline=iline+1
	end if


	end if


	
	end if !if(inter)



!info------------------------------------------------------------------------
!info--array:

	if(uvplot.or.uvplotg.or.plotsat.or.uvplott.or.consplot
     1   .or.plotcons.or.plotgrt.or.data.or.grtmap) then


	if(.not.inter) then
	 write(*,*) 'simulate VSOP or RADIOASTRON ? '
	end if

	if(inter) then

	imenu=28  ! header='array: '
	header='array: '


!	 icol=1
!	 irow=1

	 icol=6
	 irow=1
	 inum=6
	 dx=15
!	 dy=6
	 usevalue=.false.
	 onlyone=.false.
	 toggle=.false.
	 
	 name(1)='VLBA'
	 name(2)='EVN'
	 name(3)='EVN+CHINA'
	 name(4)='SHEVE'
	 name(5)='APT'
	 name(6)='Large GRTs'

	if(typsat.eq.'2') then
	 defselect(6,imenu)=.true.
	else
	 defselect(1,imenu)=.true.
	end if

	 dx=15
 	 imenu=28

! read in arrays names !

	   inum_array=inum_max(imenu)

	  do i=1,inum_array
	    starray_name_def(i) = info_in(i,imenu)
	    if(debug) then
	     write(*,'(a)') starray_name_def(i)
	    end if
	  end do

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do


	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do



	 if(found) then
	   call pgbbuf
	   buffer=.true.
	   found=.false.
	   cursor=.false.

!	   call pgvport(0.0,1.0,0.0,ytop)
	   y2 = y1vp + ( y2vp-y1vp)*ytop
	   call pgvport(x1vp,x2vp,y1vp,y2)

	   call pgwindow(0.0,1.0,0.0,1.0)
	   call pgsci(iscreen)
	   call pgrect(0.0,1.0,0.0,1.0)
	 end if


!	if(.not.initmenu(imenu)) then

	 do i=1,inum
	  if(array(i).ne.select(i,imenu)) then
	   initmenu(imenustations)=.true.
	   changearray(i)=.true.
	  else
	   changearray(i)=.false.
	  end if
	 end do

!	end if

! introduce typsatold2. needed so that GRTs menu is correctly
! re-initialized after changing typsats DWM 22-APR-93


	do i=1,inum
	 array(i)=select(i,imenu)
	if(typsat.ne.typsatold2) changearray(i)=array(i)
	end do



	else

	write(*,*) '(1= VSOP 2 = RADIOASTRON)'
	write(*,*) '(default is VSOP)'
	read(*,'(a)') typsat

C-gam	if(typsat.eq.'') typsat='1'
	if(typsat.eq.' ') typsat='1'



	end if  !if(inter)



	end if


! Ground Radio Telescope info

	if(uvplot.or.uvplotg.or.plotsat.or.uvplott.or.consplot
     1  .or.plotgrt.or.plotcons.or.data.or.grtmap) then

	if(inter) then

	 dx=15

	 imenu=imenustations

! re-define arrays with new logic !

	 do i=1,inum_max(imenu)
	  do j=1,inum_array
	   arrayval(i,j)=.false.
	  end do
	 end do

	 do i=1,inum_max(imenu)

!	   char=info_in(i,imenu)(j:j)
!	   read(char,'(l1)') arrayval(i,j)

	stname = defname_in(i,imenu,isat)(1:8)

        call get_stat( outunit, stafile, stname, sttype, stlat, 
     1  stlong, stx, sty, stz, stzalim1, stzalim2,  sthalim, 
     2  stdiam, stslew1, stslew2, stband_name, stband_tsys, 
     3  stband_effic, stband_tsys_jy, aeiowmorb, yearorb, mnthorb, 
     4  dayorb, utorb, teledir, telangle, sunavoid, antisunavoid, 
     5  moonavoid, eclipmult, eclipadd, stnarray, starray_name, 
     6  sttapetype_name, ier, nst, stname_in, st_init)


	 if(ier.eq.0) then
	     write(*,'(a)') defname_in(i,imenu,1)//'does not EXIST in '//stafile(1:16)
	     ier_get_stat = ier_get_stat + 1
	   else
!	     write(*,'(a)') defname_in(i,imenu,1)//'does EXIST'
	  do j=1,inum_array
	   do j2=1,narraymax
	   if(starray_name(j2).eq.starray_name_def(j)) then
	     arrayval(i,j)=.true.
	   end if
	  end do
	  end do
	 end if

	 end do


	  do j=1,inum_array
	 do i=1,inum_max(imenu)
	    if(arrayval(i,j)) then
	     if(debug) then
	     write(*,'(a)') starray_name_def(j)//':'//defname_in(i,imenu,isat)
	     end if
	    end if	    
	 end do
	  end do

	if(debug) then
	 write(*,*) 'deselected : '
	end if

	do i=1,inum_max(imenu)
	 do j=1,inum_array
	  if(.not.array(j).and.changearray(j)) then
	   if(arrayval(i,j)) then

! only de-select if station is not a member of any other selected array

	            change_station = .true.

	      do k=1,inum_array
	        if(k.ne.j) then
	          if(array(k).and.arrayval(i,k)) then
	            change_station = .false.	             
	          end if
		end if
	      end do

	      if(change_station) then		      
   	        defselect_in(i,imenu,isat,1)=.false.
	     end if

	     if(debug) then
	     write(*,'(a)') starray_name_def(j)//':'//defname_in(i,imenu,isat)
	     end if
     
	   end if
	  end if
	 end do
	end do

	if(debug) then
	 write(*,*) 'selected: '
	end if

	do i=1,inum_max(imenu)
	 do j=1,inum_array
	  if(array(j).and.changearray(j)) then
            if(arrayval(i,j)) then
	      defselect_in(i,imenu,isat,1)=.true.

	     if(debug) then
	      write(*,'(a)') starray_name_def(j)//':'//defname_in(i,imenu,isat)
	     end if
	     
	   end if
	  end if
	 end do
	 end do



	 bandupper=band
	 call upcase(bandupper)

	if(debug) then
	 write(*,'(a)') 'band is '//band
	 write(*,'(a)') 'bandupper is '//bandupper
	end if  

! get space radio telescope tsys information

	
	if(vsop.or.rastron) then

	 if(vsop) then
	  stname='vsop'
	 else
	  stname='rastron'
	 end if

        call get_stat( outunit, stafile, stname, sttype, stlat, 
     1  stlong, stx, sty, stz, stzalim1, stzalim2,  sthalim, 
     2  stdiam, stslew1, stslew2, stband_name, stband_tsys, 
     3  stband_effic, stband_tsys_jy, aeiowmorb, yearorb, mnthorb, 
     4  dayorb, utorb, teledir, telangle, sunavoid, antisunavoid, 
     5  moonavoid, eclipmult, eclipadd, stnarray, starray_name, 
     6  sttapetype_name, ier, nst, stname_in, st_init)

	  do j=1,nstbandmax

	   if(stband_name(j)(1:1).eq.bandupper) then

! use DLM code to calculate tsys_jy 

	   if(debug2) then
	    write(*,*) j, stband_tsys_jy(j)
	   end if

         if (stband_tsys_jy(j) .gt. 1d10) then
             stband_tsys_jy(j) = 
     1       3515.4d0*stband_tsys(j)/
     2       (stband_effic(j)*stdiam*stdiam)
	end if

	   if(debug2) then
	    write(*,*) j, stband_tsys_jy(j)
	   end if

	    tsys_jy_srt= sngl(stband_tsys_jy(j)) 

	   if(debug2) then
	    write(*,*) 'spacecraft tsys(jy): ', tsys_jy_srt
	   end if

 	    end if

	   end do !  do j=1,nstbandmax

	end if ! if(vsop.or.rastron)

	 inum = 0

	do i=1,inum_max(imenu)

          stname=defname_in(i,imenu,1)(1:8)

	 if(debug) then
	  write(*,'(a)') stname
	 end if

        call get_stat( outunit, stafile, stname, sttype, stlat, 
     1  stlong, stx, sty, stz, stzalim1, stzalim2,  sthalim, 
     2  stdiam, stslew1, stslew2, stband_name, stband_tsys, 
     3  stband_effic, stband_tsys_jy, aeiowmorb, yearorb, mnthorb, 
     4  dayorb, utorb, teledir, telangle, sunavoid, antisunavoid, 
     5  moonavoid, eclipmult, eclipadd, stnarray, starray_name, 
     6  sttapetype_name, ier, nst, stname_in, st_init)
	 if(ier.eq.0) then

	  write(*,'(a)') defname_in(i,imenu,1)//'does not EXIST in '//stafile(1:16)
	  ier_get_stat = ier_get_stat + 1
	 else

!	  write(*,'(a)') defname_in(i,imenu,1)//'does EXIST'

	  do j=1,nstbandmax

	   if(stband_name(j)(1:1).eq.bandupper) then

	    inum = inum + 1
	    numstarray(inum) = i 

! use DLM code to calculate tsys_jy 

	   if(debug) then
	    write(*,*) stband_tsys_jy(j)
	   end if

         if (stband_tsys_jy(j) .gt. 1d10) then
             stband_tsys_jy(j) = 
     1       3515.4d0*stband_tsys(j)/
     2       (stband_effic(j)*stdiam*stdiam)
	end if

	   if(debug) then
	    write(*,*) stband_tsys_jy(j)
	   end if

	    tsys_jy(i)= sngl(stband_tsys_jy(j))


! calculation of sigma (mJy):
! if VSOP or Radioastron calculate 1 sigma noise level
! if ground only experiment for each telescope 
! calculate tsys(jy)/factor_q (2*b*t)**(1/2) 
! where factor_q = quantisation loss

	    factor = sqrt(2.0*bandwidth*t_int)

! include quantisation losses pg 293 Thompson, Moran and Swenson
! one_bit = .true. is one_bit (2-level) quantisation at Nyquist rate
!       = .false.is 2-bit (4-level) quantisation at Nyquist rate

	   if(one_bit) then	     
            factor =  0.637 * factor	     
	   else
            factor =  0.881 * factor	     
	   end if

	    if(gronly) then
!	     sigma_mjy(i)= sqrt(tsys_jy(i)/(factor))
	     sigma_mjy(i)=  tsys_jy(i)/(factor)
	    else
	     sigma_mjy(i)=sqrt(tsys_jy(i)*tsys_jy_srt)/factor
	    end if

	if(debug) then
	write(*,*) 't_int, tsys_jy, tsys_jy_srt: ',
     1  t_int, tsys_jy(i), tsys_jy_srt
	write(*,*) 'i, factor, sigma_mjy(i)" ',i, factor, sigma_mjy(i)
	end if

!	 write(*,*) 'stname, tsys(jy), factor, 1-sigma: '
!     1  ,tsys_jy(i),' ',factor,' ',stname,sigma_mjy(i)

	     	 
	    end if
	   end do !  do j=1,nstbandmax

	  end if
	 end do 


	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)

!	 irow    =irow_in(imenu,isat)
!	 inum    =inum_in(imenu,isat)

	 irow = 1 + int(inum/icol)

	if(debug) then
	 write(*,*) 'inum, irow, icol ',inum, irow, icol
	end if


	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 if(debug) then
	  write(*,*) 'before :'
	 end if

	 do i=1,inum


! replace tsys_jy with sigma_mjy

!	  write(tsys_5,'(f5.2)') alog10(tsys_jy(numstarray(i)))

	  if(gronly) then
!	   write(tsys_5,'(f5.2)') 0.5*alog10(sigma_mjy(numstarray(i)))
	   write(tsys_5,'(f5.2)') sigma_mjy(numstarray(i))
	  else
!	   write(tsys_5,'(f5.2)') alog10(sigma_mjy(numstarray(i)))
	   write(tsys_5,'(I5)') int(sigma_mjy(numstarray(i))+0.5)
	  end if

	  name(i)=defname_in(numstarray(i),imenu,isat)(1:8)//tsys_5


	  defselect(i,imenu)=defselect_in(numstarray(i),imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(numstarray(i),imenu,isat,1)
	  select(i,imenu)=defselect(i,imenu)
	  value(i,imenu)= defvalue(i,imenu)

	 if(debug) then
	  write(*,'(a,l1)') name(i),defselect(i,imenu)
	 end if

	  end do

	  typsatold2=typsat

	if(debug) then
	 write(*,*) 'imenu,icol,irow,inum, dx, nrows: '
	 write(*,*)  imenu,icol,irow,inum, dx, nrows

	 write(*,*) 'usevalue, onlyone,toggle: '
	 write(*,*)  usevalue, onlyone,toggle 

	 write(*,*) 'cursor,xc,yc,c1,found,header,ytop: '
	 write(*,*)  cursor,xc,yc,c1,found,header,ytop 

	 do i=1,inum
	   write(*,*) 'before: ',name(i), defselect(i,imenu), select(i,imenu)
	 end do
	end if
c          write(*,*) '======================',icol,irow,inum,name
	
	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)



	 do i=1,inum
	  name(i)=defname_in(numstarray(i),imenu,isat)
          defselect_in(numstarray(i),imenu,isat,1)=select(i,imenu)
	  defvalue_in(numstarray(i),imenu,isat,1) =value(i,imenu)
	 end do



	if(output) then

	if(space.and..not.grtmap) then 
	line(iline)='STATIONS   = '//orbit//' ,'
	else
	line(iline)='STATIONS   =  '
	end if


	iline=iline+1


	igrt=0

	do i=1,inum
	 if(select(i,imenu)) then
	  igrt=igrt+1
	  grt(igrt)=name(i)(1:8)
	 end if
	end do


	irem=mod(igrt,5)
	irow=(igrt-irem)/5

!	write(*,*) 'irem, irow ',irem,irow

	ic=0


	do i=1,irow

	end=','

	if(i.eq.irow.and.irem.eq.0) end=' '

        line(iline)=grt(ic+1)//','//grt(ic+2)//','
     1  //grt(ic+3)//','//grt(ic+4)//','//grt(ic+5)//end

	iline=iline+1

	ic=ic+5

	end do

	if(irem.eq.1) then
        line(iline)=grt(igrt)
	iline=iline+1
	end if

	if(irem.eq.2) then
        line(iline)=grt(igrt-1)//','//grt(igrt)
	iline=iline+1
	end if

	if(irem.eq.3) then
        line(iline)=grt(igrt-2)//','//grt(igrt-1)//','//grt(igrt)
	iline=iline+1
	end if

	if(irem.eq.4) then
        line(iline)=grt(igrt-3)//','//grt(igrt-2)//','//grt(igrt-1)//
     1  ','//grt(igrt)
	iline=iline+1
	end if

	end if !if(output)

	
	else

	if(output) then

	line(iline)='STATIONS   = '//orbit//' ,'
	iline=iline+1


	   write(*,*) 'What Ground Radio Telescopes do you want to use ?'
	   write(*,*) 'Options are :'
	   write(*,*) ' 1= VLBA '
	   write(*,*) ' 2= Large Ground Radio Telescopes '

	 if(typsat.eq.'1') then
	  write(*,*) '(default is VLBA) '
	 else
	  write(*,*) '(default is Large Ground Radio Telescopes)'
	 end if
	  write(*,*) 'Which option ?'
	  read(*,'(a)') ans

	 if(typsat.eq.'1') then

C-gam	  if(ans.eq.'') ans='1'
	  if(ans.eq.' ') ans='1'

	 else

C-gam	  if(ans.eq.'') ans='2'
          if(ans.eq.' ') ans='2'

	 end if

	 if(ans.eq.'1') then
        line(iline)='"VLBA_BR","VLBA_FD","VLBA_HN","VLBA_KP","VLBA_LA",'
	  iline=iline+1
        line(iline)='"VLBA_MK","VLBA_NL","VLBA_OV","VLBA_PT","VLBA_SC"'
	  iline=iline+1
	 end if

	 if(ans.eq.'2') then
          line(iline)='"JODRELL","BONN","VLA","GBT","EVPATORIA",'
	  iline=iline+1
          line(iline)=' "USSURI70","SUFFA","NARRABRI","PARKES"'
	  iline=iline+1
	 end if

	end if !if(output)

	end if !if(inter)
	

	else

!	line(iline)='STATIONS   = '//orbit//' ,'
!	iline=iline+1
!	line(iline)='              '//'BONN'
!	iline=iline+1

	if(output) then
C-gam	line(iline)='STATIONS   = '//orbit//' , '//'BONN'
	line(iline)='STATIONS   = '//orbit//' , '//'EFFELSBRG'
	iline=iline+1
	end if !if(output)


	end if





! ground info

	if(ground.or.uvplotg) then

	 temp =orbit//';'//year//';d'//day

! remove blanks from default name

	icount=0

	title=' '

	do i=1,20

C-gam	 if(temp(i:i).ne.'') then
	 if(temp(i:i).ne.' ') then

	  icount=icount+1
	   title(icount:icount)=temp(i:i)
	 end if
	end do

	end if

	if(grtmap) then

	 dx=15
 	 imenu=45

	 header  =header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do
	   

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	if(output.and.select(1,imenu)) then
	  line(iline)='GRTNAMES  '
	  iline=iline+1
	end if

	end if



	if(ground.or.grtmap) then
	

	if(inter) then

	imenu=14 ! header='E long of LH of plot:'
	header='E long of LH of plot:'



	 icol=1
	 irow=1
	 inum=1
	 dx=15
!	 dy=6

	 usevalue=.true.
	 onlyone=.false.
	 toggle=.false.
	 
	 select(1,imenu)=.true.

	name(1)='E. Long (\uo\d) '
	defvalue(1,imenu)='100'

	 dx=15
 	 imenu=14

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do
	

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	west=value(1,imenu)

	if(ground) then

	imenu=15 ! plot red
	header=' '

	 usevalue=.false.
	 onlyone=.false.
	 toggle=.true.

	name(1)='plot red'
	defvalue(1,imenu)='no red'

	defselect(1,imenu)=.true.

	 dx=15
 	 imenu=15

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do


	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do


	if(select(1,imenu)) then
	  ans='n'
	else
	  ans='y'
	end if

	end if !if(ground)


	else

	write(*,'(a)') 'default title for plot : '//title

	write(*,*) 'change default title ? (y=yes)'
	read(*,'(a)') ians

	if(ians.eq.'y') then
	 write(*,*) 'title for plot ?'
	 do i=1,20

C-gam	  title(i:i)=''
	  title(i:i)=' '

	 end do
	 read(*,'(a)') title
	end if


	write(*,*) 'Eastern Longitude for Left-Hand of plot ?'
	write(*,*) '(default = 100.0 degrees)'
	read(*,'(a)') west

C-gam	if(west.eq.'') then
	if(west.eq.'          ') then
	 west='100.0'
	end if

	write(*,*) 'default is to plot data in red when spacecraft not visible'
	write(*,*) 'change default ? (y=yes)'
	read(*,'(a)') ans

	if(output.and.ans.eq.'y') then
	line(iline)='NORED       '
	iline=iline+1
	end if


	end if

	end if !inter


	if(output) then

	 if(ground.or.uvplotg) then
	  line(iline)='TITLE      = '//title
	  iline=iline+1
	 end if

	 if(ground.or.grtmap) then
	   line(iline)='WEST       = '//west
	   iline=iline+1
	 end if

	 if(ground) then
	  if(ans.eq.'y') then
	   line(iline)='NORED       '
	   iline=iline+1
	  end if
	 end if

	end if !if(output)



	if(uvplotg) then

	if(inter) then

	imenu=16 ! header='RA and Dec ranges: '
	header='RA and Dec ranges: '


!	 icol=1
!	 irow=6

	 icol=2
	 irow=3



	 inum=6
	 dx=15
!	 dy=6
	 usevalue=.true.
	 onlyone=.false.
	 toggle=.false.



	 name(1)='RA-min (h)'
	 name(3)='RA-max (h)'
	 name(5)='RA-step(h)'
	 name(2)='Dec-min  '
	 name(4)='Dec-max  '
	 name(6)='Dec-step '


	 defvalue(1,imenu)='24.00'
	 defvalue(3,imenu)='00.00'
	 defvalue(5,imenu)='-2.00'
	 defvalue(2,imenu)='-80.00'
	 defvalue(4,imenu)='80.00'
	 defvalue(6,imenu)='20.00'

	 dx=15
 	 imenu=16

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do
	




	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do


	


!	ramin=value(1,imenu)
!	ramax=value(2,imenu)
!	rastep=value(3,imenu)
!	decmin= value(4,imenu)
!	decmax= value(5,imenu)
!	decstep=value(6,imenu)

	ramin=value(1,imenu)
	ramax=value(3,imenu)
	rastep=value(5,imenu)
	decmin= value(2,imenu)
	decmax= value(4,imenu)
	decstep=value(6,imenu)


	else

	write(*,*) 'default all-sky uvplot RA range is'
	write(*,*) 'from 24h to 0h in steps of -2h'
	write(*,*) 'Change this default ? (y=yes) '
	read(*,'(a)') ans

	if(ans.eq.'y') then

	 write(*,*) 'ramin = ? (default = 24.00 (hours))'
	 read(*,'(a)') ramin
C-gam	 if(ramin.eq.'') ramin='24.00'
	 if(ramin.eq.'          ') ramin='24.00'

	 write(*,*) 'ramax = ? (default = 00.00 (hours))'
	 read(*,'(a)') ramax
C-gam	 if(ramin.eq.'') ramax='00.00'
	 if(ramin.eq.'          ') ramax='00.00'


	 write(*,*) 'rastep = ? (default = -2.00 (hours))'
	 read(*,'(a)') rastep

C-gam	 if(ramin.eq.'') rastep='-2.00'
	 if(ramin.eq.'          ') rastep='-2.00'

	else

	ramin ='24.00'	
	ramax ='00.00'	
	rastep='-2.00'	

	end if

	write(*,*) 'default all-sky uvplot Declination range is'
	write(*,*) 'from -80  to +80  in steps of 20 degrees'
	write(*,*) 'Change this default ? (y=yes) '
	read(*,'(a)') ans

	if(ans.eq.'y') then

	 write(*,*) 'decmin = ? (default = -80.00 (degrees))'
	 read(*,'(a)') decmin

C-gam	 if(decmin.eq.'') decmin='-80.00'
	 if(decmin.eq.'          ') decmin='-80.00'

	 write(*,*) 'decmax = ? (default = 80.00 (degrees))'
	 read(*,'(a)') decmax

C-gam	 if(decmin.eq.'') decmax='80.00'
	 if(decmin.eq.'          ') decmax='80.00'


	 write(*,*) 'decstep = ? (default = 20 (degrees))'
	 read(*,'(a)') decstep

C-gam	 if(decmin.eq.'') decstep='20.00'
	 if(decmin.eq.'          ') decstep='20.00'

	else

	decmin ='-80.00'	
	decmax ='80.00'	
	decstep='20.00'	

	end if


	end if !if(inter)

	if(output) then

	line(iline)='RAMIN       = '//ramin
	iline=iline+1
	line(iline)='RAMAX       = '//ramax
	iline=iline+1
	line(iline)='RASTEP       = '//rastep
	iline=iline+1

	line(iline)='DECMIN       = '//decmin
	iline=iline+1
	line(iline)='DECMAX       = '//decmax
	iline=iline+1
	line(iline)='DECSTEP       = '//decstep
	iline=iline+1

	end if !if(output)


	
	end if ! if(uvplotg) 



	if(plotsat) then

	 dx=15
 	 imenu=17

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do
		

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	if(select(1,imenu)) then
	  ans='n'
	else
	 ans='y'
	end if

	 if(output.and.ans.ne.'y') then
	  line(iline)='ADDUV       '
	  iline=iline+1
	 end if

	 dx=15
 	 imenu=42

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do
		

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	if(select(1,imenu)) then
	  ans='n'
	else
	 ans='y'
	end if

	 if(output.and.ans.ne.'y') then
	  line(iline)='ANGLES      '
	  iline=iline+1
	 end if


	end if 	! if(plotsat) 


	if(plotsat2) then

	if(inter) then

	imenu=18 ! header='field of View:'
	header='field of View:'



	 icol=1
	 irow=1
	 inum=1
	 dx=15
!	 dy=6
	 usevalue=.true.
	 onlyone=.false.
	 toggle=.false.

	 name(1)='FOV (deg)'
	 defvalue(1,imenu)='60.00'

	 dx=15
 	 imenu=18

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do
		

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do	

	angmax=value(1,imenu)

	ans='n'

	else

	 write(*,*) 'Default is to set field of view to 60 degrees? '
	 write(*,*) 'Change this default (y=yes)'
	 read(*,'(a)') ans

	  if(ans.eq.'y') then
	   write(*,*) 'what half-cone angle for field of view ?'
	   write(*,*) '(default = 30 degrees)'
	   read(*,'(a)') angmax

C-gam	   if(angmax.eq.'') angmax='30.0'
	   if(angmax.eq.'          ') angmax='30.0'

	  else
	  angmax='30.0'
	 end if

	  if(output) then
	  line(iline)='ANGMAX     = '//angmax
	  iline=iline+1
	  end if

	 write(*,*) 'Default is sh tracking stations as colored squares? '
	 write(*,*) 'Change this default (y=yes)'
	 read(*,'(a)') ans

	 if(output.and.ans.ne.'y') then
	  line(iline)='ADDUV       '
	  iline=iline+1
	 end if

	end if !if(inter)

	  if(output) then
	  line(iline)='ANGMAX     = '//angmax
	  iline=iline+1
	  end if

	 if(output.and.ans.ne.'y') then

	  line(iline)='ADDUV       ' 
	  iline=iline+1

	 end if

	end if 	! if(plotsat2) 

	if(uvplott) then

	if(inter) then

	imenu=19 ! header='N UV-plots every n days and h hours : '
	header='N UV-plots: '

	 icol=1
	 irow=1
	 inum=1
	 dx=15
!	 dy=6
	 usevalue=.true.
	 onlyone=.false.
	 toggle=.false.

	name(1)='N UV-plots'
	defvalue(1,imenu)='24'

	 dx=15
 	 imenu=19

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do

	
	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do



	nplots=value(1,imenu)

	
	imenu=20 ! header='every n days and h hours : '
	header='every n days and h hours : '

	 icol=2
	 irow=1
	 inum=2
	 dx=15
!	 dy=6
	 usevalue=.true.
	 onlyone=.false.
	 toggle=.false.

	name(1)='n days'
	name(2)='h hours'

	defvalue(1,imenu)='30.0'
	defvalue(2,imenu)='0.0'

	 dx=15
 	 imenu=20

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do
	



	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do



	dtuvd=value(1,imenu)	
	dtuvh=value(2,imenu)	

	imenu=21 ! header='# plots per axis'
	header='# plots per axis'

	 icol=2
	 irow=1
	 inum=2
	 dx=15
!	 dy=6
	 usevalue=.true.
	 onlyone=.false.
	 toggle=.false.

	name(1)='n-xaxis '
	name(2)='n-yaxis '

	defvalue(1,imenu)='6 '
	defvalue(2,imenu)='4 '

	 dx=15
 	 imenu=21

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do
	
	
	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do


	nx=value(1,imenu)	
	ny=value(2,imenu)


	else

	if(output) then

	write(*,*) 'produce a uvplot every n days and h hours'

	write(*,*) 'n = ? (default=30.0 days )'
	read(*,'(a)') dtuvd

C-gam	if(dtuvd.eq.'') dtuvd='30.0'
	if(dtuvd.eq.'          ') dtuvd='30.0'

	  line(iline)='DTUVD      = '//dtuvd
	  iline=iline+1
	write(*,'(a)') 'h = ? (default=0.0 hours )'
	read(*,'(a)') dtuvh

C-gam	if(dtuvh.eq.'') dtuvh='0.0'
	if(dtuvh.eq.'          ') dtuvh='0.0'

	  line(iline)='DTUVH      = '//dtuvh
	  iline=iline+1

	write(*,*) 'Total number of uvplots ? (default=24)'
	read(*,'(a)') nplots

C-gam	if(nplots.eq.'') nplots='24'
	if(nplots.eq.'          ') nplots='24'

	  line(iline)='NPLOTS     = '//nplots
	  iline=iline+1

	write(*,*) 'How many uvplots along x-axis ? (default=6)'
	read(*,'(a)') nx

C-gam	if(nx.eq.'') nx='6'
	if(nx.eq.'          ') nx='6'

	  line(iline)='NX         = '//nx
	  iline=iline+1

	write(*,*) 'How many uvplots along y-axis ? (default=4)'
	read(*,'(a)') ny

C-gam	if(ny.eq.'') ny='4'
	if(ny.eq.'          ') ny='4'

	  line(iline)='NY         = '//ny
	  iline=iline+1

	end if !if(output)

	end if !if(inter)

	  if(output) then
	  line(iline)='DTUVD      = '//dtuvd
	  iline=iline+1
	  line(iline)='DTUVH      = '//dtuvh
	  iline=iline+1
	  line(iline)='NPLOTS     = '//nplots
	  iline=iline+1
	  line(iline)='NX         = '//nx
	  iline=iline+1
	  line(iline)='NY         = '//ny
	  iline=iline+1
	  end if !if(output)


	end if 	! if(uvplott) 


	if(.not.ignore) then
	

! plotfile info:

	pscolor = .false.
	psnocolor = .false.

	if(inter) then

	imenu=22 ! header='output device: '
	header='output device: '



!	icol=1
!	irow=2

	icol=3
	irow=1

	inum=3
	dx=15
!	dy=6

	usevalue=.false.
	onlyone=.true.
	toggle=.false.

	name(1)='Xwindows'
	name(2)='pgdisp'
	name(3)='printer'

	defselect(1,imenu)=.true.



	 plot=.false.

	 if(plotsat.or.plotsat2) then

	 dx=15
 	 imenu=31

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do
	

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	  plotf = ' '


	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)

	  if(select(i,imenu)) then
	   if(name(i)(5:5).eq.')') then
            plotf(1:3)=name(i)(2:4)
	   else
            plotf(1:4)=name(i)(2:5)
	   end if
	  end if

	 
	 
	 end do

	
!	if(select(1,imenu)) plotf='/xserv'
!	if(select(2,imenu)) plotf='/xd'

	 else

	 dx=16
 	 imenu=22

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do
	

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	  plotf= ' '

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	
!	if(select(1,imenu)) plotf='/xserv'
!	if(select(2,imenu)) plotf='/xd'

	if(output) then

	if(.not.ignore) then

	do i=1,inum_max(imenu)
	if(select(i,imenu)) then
	 if(select(3,imenu).or.select(4,imenu)) then

	   plot=.true.

	  if(name(i)(5:5).eq.')') then
	   plotfname='.'//name(i)(3:4)
	   plotf='.'//name(i)(3:4)//'/'//name(i)(3:4)
	  else
	   plotfname='.'//name(i)(3:5)
	   plotf='.'//name(i)(3:5)//'/'//name(i)(3:5)
	  end if
  
	 else

	   if(name(i)(5:5).eq.')') then
             plotf(1:3)=name(i)(2:4)
	   else
             plotf(1:4)=name(i)(2:5)
	  end if

	  end if
	 end if
	end do

	end if !if(.not.ignore)

	end if 

	plot=.false.
	if(.not.select(1,imenu)) plot=.true.

!	write(*,*) 'plot is: ', plot

	if(select(2,imenu)) then
	 plotmenu=.true.
	else
	 plotmenu=.false.
	end if


	if(select(1,imenu)) plotf='/xserv'
	if(select(2,imenu)) plotf='.vps/vps'
	if(select(3,imenu)) plotf='.ps/ps'
	if(select(4,imenu)) plotf='.cps/cps'

	if(select(1,imenu)) plotfname='/xserv'
	if(select(2,imenu)) plotfname='.vps'
	if(select(3,imenu)) plotfname='.ps'
	if(select(4,imenu)) plotfname='.cps'

! if these options selected generate color instead
! of b+w plot. Required to get `grey-scale' to come out
! correctly

	if(plotcons.or.plotgrt) then
	 if(select(2,imenu)) plotf='.vcps/vcps'
	 if(select(2,imenu)) plotfname='.vcps'
	 if(select(3,imenu)) plotf='.cps/cps'
	 if(select(3,imenu)) plotfname='.cps'
	end if


!	if(select(2,imenu).or.select(3,imenu)) pscolor=.true.
!	if(select(4,imenu).or.select(5,imenu)) psnocolor=.true.
	
	 end if !if(plotsat.or.plotsat2)


	else 



	   write(*,*) ' '
	   write(*,*) 'input of plotfile information :'
	   write(*,*) ' '
	   write(*,*)'default plotfile is /xserv (i.e. xwindows) '
	   write(*,*) 'change default ? (y=yes)'
	   read(*,'(a)') ans

	 if(ans.eq.'y') then
	   write(*,*) 'what plotfile do you want? '
	   write(*,*) '(possible other options are:                   ) '
	   write(*,*) '( /xd                 pgdisp                   ) '
	   write(*,*) '(plotfilename.ps/ps   Portrait Postscript file )'
	   write(*,*) '(plotfilename.vps/vps Landscape Postscript file)'
	   read(*,'(a)') plotf

C-gam	   if(plotf.eq.'') plotf='/xserv'
	   if(plotf(1:1).eq.' ') plotf='/xserv'

	 else
	   plotf='/xserv'
	 end if

	end if !if(inter)

	end if !if(.not.ignore)

	



! can't fit everything on when uvplott option selected
! drop this information !


	if(uvplott.or.plotsat.or.plotsat2) then
	 ignore2=.true.
	else
	 ignore2=.false.
	end if

	if(.not.ignore2) then

	if(inter) then

	imenu=23 ! header='plotting parameters:   '
	header='plotting parameters:   '



!	 icol=1
!	 irow=2

!	 icol=2
!	 irow=1
!	 inum=2
!	 dx=15
!	 dy=6
!	 usevalue=.true.
!	 onlyone=.false.
!	 toggle=.false.
!	name(1)='linewidth'
!	name(2)='dotsize'
!	defvalue(17,1)='1'
!	defvalue(17,2)='1'

	 dx=15
 	 imenu=23

	 header  =header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do
	   

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	linewidth=value(1,imenu)
	dotsiz=value(2,imenu)

	else

	write(*,*) 'Linewidth ? (default=1)'
	read(*,'(a)') linewidth


C-gam	if(linewidth.eq.'') linewidth='1'
	if(linewidth(1:1).eq.' ') linewidth='1'


	write(*,*) 'Dotsize ? (default=1)'
	read(*,'(a)') dotsiz


C-gam	if(dotsiz.eq.'') dotsiz='1'
	if(dotsiz(1:1).eq.' ') dotsiz='1'



	end if !if(inter)


	if(output) then
!	 line(iline)='PLOTF      '//plotf//' '
!	 iline=iline+1
	 line(iline)='LINEWIDTH  = '//linewidth
	 iline=iline+1
	 line(iline)='DOTSIZ     = '//dotsiz
	 iline=iline+1
	end if !if(output)

	end if

	if(output.and.plot) then
	  line(iline)='HARDCOPY  '
	  iline=iline+1
	  line(iline)='DEF_FILE = '//def_file
	  iline=iline+1
	  if(plotmenu) then
	   line(iline)='PLOTMENU'
	   iline=iline+1
	   line(iline)='PLOT1X2Y'
	   iline=iline+1
	   if(simple_menu) then
	    line(iline)='SIMPLEM'
	    iline=iline+1
	   end if
	  end if
	if(plotfname.eq.'.cps'.or.plotfname.eq.'.vcps') then
	  line(iline)='PSCOLOR'
	  iline=iline+1
	  line(iline)='PLOTDEL '
	  iline=iline+1
	 else
	  line(iline)='PLOTDEL = -1 '
	  iline=iline+1
	 end if
	end if 


	if(uvplot.or.uvplotg.or.plotsat.or.uvplott) then

	if(inter) then

	imenu=24 ! header='plot UV-limits:   '
	header='plot UV-limits:   '

	imenulimits=imenu

!	 icol=1
!	 irow=2

	 icol=2
	 irow=1

	 inum=2
	 dx=15
!	 dy=6
	 usevalue=.true.
	 onlyone=.false.
	 toggle=.false.

	 dx=15
 	 imenu=24

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do
	
	 if(typsat.eq.'1') then
	  if(band.eq.'l') u1= 0.24
	  if(band.eq.'c') u1= 0.6
	  if(band.eq.'k') u1= 2.64
	  if(band.eq.'l') v1= 0.24
	  if(band.eq.'c') v1= 0.6
	  if(band.eq.'k') v1= 2.64
	end if
	 if(typsat.eq.'2') then
	  if(band.eq.'p') u1= 0.4
	  if(band.eq.'l') u1= 2.0 	 
	  if(band.eq.'c') u1= 5.0 
	  if(band.eq.'k') u1= 24.0 
	  if(band.eq.'p') v1= 0.4
	  if(band.eq.'l') v1= 2.0 	 
	  if(band.eq.'c') v1= 5.0 
	  if(band.eq.'k') v1= 24.0 
	 end if
	 if(typsat.eq.'3') then
	  if(band.eq.'p') u1= 0.02
	  if(band.eq.'l') u1= 0.06	 
	  if(band.eq.'c') u1= 0.20 
	  if(band.eq.'k') u1= 1.0
	  if(band.eq.'p') v1= 0.02
	  if(band.eq.'l') v1= 0.06	 
	  if(band.eq.'c') v1= 0.20 
	  if(band.eq.'k') v1= 1.0
	 end if


!	 name(1)='Umax G\gl'
!	 name(2)='Vmax G\gl'

	write(defvalue(1,imenu),'(f5.2)') u1
	write(defvalue(2,imenu),'(f5.2)') v1


!	write(*,*) 'band, bandold, initmenu(18) ',band, bandold, initmenu(18)
!	write(*,*) 'value(1,imenu), value(2,imenu) ',value(1,imenu),value(2,imenu)

	if(band.ne.bandold) initmenu(imenulimits)=.true.

	
	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do



	umax(1:5)=value(1,imenu)(1:5)
	vmax(1:5)=value(2,imenu)(1:5)


! get rid of blanks


	do i=1,5
	 if(umax(5:5).eq.' ') then
	   temp1(2:5)=umax(1:4)
	   temp1(1:1)=umax(5:5)
	   umax(1:5)=temp1(1:5)
!	  write(*,'(a)') umax
	 end if
	end do

	do i=1,5
	 if(vmax(5:5).eq.' ') then
	   temp1(2:5)=vmax(1:4)
	   temp1(1:1)=vmax(5:5)
	   vmax(1:5)=temp1(1:5)
!	  write(*,'(a)') vmax
	 end if
	end do

	  
	
	
!	write(*,'(a)') value(1,imenu)
!	write(*,'(a)') value(2,imenu)	
!	write(*,'(a)') umax
!	write(*,'(a)') vmax	

	else

	 write(*,*) 'Maximum U and V limits for plotfile: '	


	if(typsat.eq.'1') then
	 if(band.eq.'l') write(*,*) '(defaults are 0.2 Giga-Lambda)'
	 if(band.eq.'c') write(*,*) '(defaults are 0.5 Giga-Lambda)'
	 if(band.eq.'k') write(*,*) '(defaults are 2.2 Giga-Lambda)'
	else
	 if(band.eq.'l') write(*,*) '(defaults are 0.1 Giga-Lambda)'
	 if(band.eq.'l') write(*,*) '(defaults are 0.5 Giga-Lambda)'
	 if(band.eq.'c') write(*,*) '(defaults are 1.5 Giga-Lambda)'
	 if(band.eq.'k') write(*,*) '(defaults are 6.6 Giga-Lambda)'
	end if

	 write(*,*) 'change defaults ? (Y=yes)'
	 read(*,'(a)') ans

	if(ans.eq.'y') then

	 write(*,*) 'value of Maximum U-limit in Giga-lamda ?'
	 read(*,*) u1 
	 write(*,*) 'value of Maximum V-limit in Giga-lamda ?'
	 read(*,*) v1

	else

	 if(typsat.eq.'1') then
	  if(band.eq.'l') u1= 0.2
	  if(band.eq.'c') u1= 0.5
	  if(band.eq.'k') u1= 2.2
	  if(band.eq.'l') v1= 0.2
	  if(band.eq.'c') v1= 0.5
	  if(band.eq.'k') v1= 2.2
	 else
	  if(band.eq.'p') u1= 0.1
	  if(band.eq.'l') u1= 0.5 	 
	  if(band.eq.'c') u1= 1.5 
	  if(band.eq.'k') u1= 6.6 
	  if(band.eq.'p') v1= 0.1
	  if(band.eq.'l') v1= 0.5 	 
	  if(band.eq.'c') v1= 1.5 
	  if(band.eq.'k') v1= 6.6 
	 end if

	end if ! if(ans.eq.'y') 

	write(umax(1:5),'(f5.2)') u1
	write(vmax(1:5),'(f5.2)') v1

	end if !if(inter)



	umax(6:7)='E9'
	vmax(6:7)='E9'

	if(output) then
	line(iline)='UMAX       = '//umax
	iline=iline+1
	line(iline)='VMAX       = '//vmax
	iline=iline+1
	end if

	end if  ! if(uvplot.or.uvplotg.or.plotsat) 




	if(inter) then
         if(complot) then

	
	if(vsop) then

	 dx=15
 	 imenu=34

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do


	if(output) then
	 if(select(1,imenu)) then
	  line(iline)='ANGYZ =   '//name(1)
	 else
	  line(iline)='ANGYZ =   '//value(1,imenu)
	 end if
	  iline=iline+1
	end if

	else

	 dx=15
 	 imenu=33

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do

	if(output) then
	  line(iline)='YZ1 =   '//value(1,imenu)
	  iline=iline+1
	  line(iline)='YZ2 =   '//value(1,imenu)
	  iline=iline+1
	  line(iline)='YZ3 =   '//'5.0'
	  iline=iline+1
	end if

	end if

	 end if
        end if 

! switch off this feature as menu can longer display all menu items


!	if(uvplot.or.uvplotg) then
	if(.not.ignore) then

	if(inter) then

	imenu=25 ! header='invert U-axis of UV-plot:'
	header='invert U-axis of UV-plot:'

	 icol=1
	 irow=1
	 inum=1
	 dx=15
!	 dy=6
	 usevalue=.false.
	 onlyone=.false.
	 toggle=.true.

	name(1)='Invert U'
	defvalue(1,imenu)='NO invert'
	defselect(1,imenu)=.false.

	 dx=15
 	 imenu=25

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do
	

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do


	if(select(1,imenu)) then
	  ans='y'
	else
	 ans='n'
	end if

	

	else


	write(*,*) 'Default is to have conventional UV-plot with +U axis along -X'
	write(*,*) 'Change this default to +U axis along +X axis (y=yes)'
	read(*,'(a)') ans

	end if !if(inter)

	 if(output.and.ans.eq.'y') then
	  line(iline)='UINV       '
	  iline=iline+1
	 end if

	end if  ! if(uvplot.or.uvplotg)


	if(uvplot.or.uvplotg.or.uvplott) then

	if(inter) then

	


	imenu=26 ! header='plot every n-th earth-earth baseline:'
	header='plot every n-th earth-earth baseline:'


	 icol=1
	 irow=1
	 inum=1
	 dx=15
!	 dy=6
	 usevalue=.true.
	 onlyone=.false.
	 toggle=.false.

	name(1)='n-th'

	 if(uvplot.or.uvplott) then
!	  write(*,*) 'default is to plot only every 5th earth-earth baseline '
	  defvalue(1,imenu) = '5'  

	 dx=15
 	 imenu=26

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do

	 else
!	  write(*,*) 'default is to plot no earth-earth baselines '
	  defvalue(1,imenu) = '2000'

	 dx=15
 	 imenu=30

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do

	 end if



	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do


	

	ngrdil=value(1,imenu)

	else

	 if(uvplot.or.uvplott) then
	  write(*,*) 'default is to plot only every 5th earth-earth baseline '
	  ngrdil = '5'
	 else
	  write(*,*) 'default is to plot no earth-earth baselines '
	  ngrdil = '2000'
	 end if

	  write(*,*) 'Change this default ? (y=yes)'
	  read(*,'(a)') ans

	 if(ans.eq.'y') then
	  write(*,*) 'plot only every nth earth-earth baseline '
	  write(*,*) 'what is value of n ?'
	  read(*,'(a)') ngrdil
	 end if



	end if !if(inter)

	if(output) then
	line(iline)='NGRDIL     = '//ngrdil
	iline=iline+1
	end if

	end if ! if(uvplot.or.uvplotg) 


!DWM****

	if(uvplot.or.uvplotg.or.uvplott.or.plotsat.or.data) then
	if(inter) then

	imenu=27 ! header='Min # of Telescopes:'
	header='Min # of Telescopes:'

	 icol=1
	 irow=1
	 inum=1
	 dx=15
!	 dy=6
	 usevalue=.true.
	 onlyone=.false.
	 toggle=.false.

	 name(1)='NUP'

	if(typsat.ne.'2') then
	 defvalue(1,imenu)='4'
	else
	 defvalue(1,imenu)='2'
	end if


	 dx=15
 	 imenu=27

	 header=header_in(imenu)
	 icol    =icol_in(imenu,isat)
	 irow    =irow_in(imenu,isat)
	 inum    =inum_in(imenu,isat)
	 usevalue=usevalue_in(imenu)
	 onlyone =onlyone_in(imenu)
	 toggle  =toggle_in(imenu)

	 do i=1,inum_max(imenu)
	  name(i)=defname_in(i,imenu,isat)
	  defselect(i,imenu)=defselect_in(i,imenu,isat,1)
	  defvalue(i,imenu)=defvalue_in(i,imenu,isat,1)
	 end do


	

	call menu(icol,irow,inum,name,dx,nrows,x1vp,x2vp,y1vp,y2vp,
     1  usevalue,value(1,imenu),select(1,imenu),onlyone,toggle, 
     2  cursor,xc,yc,c1,found,header,ytop,tex_file(imenu),sh(imenu),
     3  defselect(1,imenu),defvalue(1,imenu),initmenu(imenu),colors)

	 do i=1,inum_max(imenu)
          defselect_in(i,imenu,isat,1)=select(i,imenu)
	  defvalue_in(i,imenu,isat,1) =value(i,imenu)
	 end do


	
	nup=value(1,imenu)

	ans='n'

	else

	 write(*,*) 'Min # of telescopes required to be observing source: '
	 write(*,*) '(default = '//defvalue(1,imenu)//')'
	 write(*,*) 'Change this default (y=yes)'
	 read(*,'(a)') ans

	  if(ans.eq.'y') then
	   write(*,*) 'what is Min # of telescopes ?'
	   read(*,'(a)') nup
	  else
	   nup=defvalue(1,imenu)
	  end if

	  if(output) then
	  line(iline)='NUP     = '//nup
	  iline=iline+1
	  end if

	end if !if(inter)

	  if(output) then
	  line(iline)='NUP     = '//nup
	  iline=iline+1
	  end if

	end if !if(uvplot.or.plotsat)


!*****


	initial=.false.
	typsatold=typsat
	bandold=band
	t_int_old = t_int
	bandwidth_old = bandwidth
	isampling_old = isampling

	cursor=.true.
	if(buffer) then
	  call pgebuf
	  buffer=.false.
	end if

	if(screen) then
!	  call pgend
!	  write(*,*) 'screen.ps file has been created'
          goto 2020
	end if

! create def file name
! create def file name
! create plt file name

	  if(plot) then
	     plotf=def_file(1:len1(def_file))//plotf(1:len1(plotf))
	     plotf='plt-'//plotf(5:len1(plotf))
	 end if

	if(.not.inter) then

	 write(*,*) ' '
	 write(*,*) 'creating output .csh file'
	 write(*,*) ' '
	 write(*,*) 'what .csh filename do you want ?'

	end if !if(.not.inter)


	 default=' '

	  if(vsop)    orbitn='vsop'
	  if(rastron) orbitn='rastron'
	  if(gronly)  orbitn='gronly'

	 if(ground) then   
	 temp = 'def-gr-'//year//'-d'//day//'-'//orbitn
	 end if

	 if(plotazel) then   
	 temp = 'def-azel-'//year//'-d'//day//'-'//orbitn
	 end if

	 if(ecliplot) then   
	 temp = 'def-ecl-'//year//'-d'//day//'-'//orbitn
	 end if


	 if(uvplot) then
           if(constra) then 
	    temp = 'def-uv-c-'//year//'-d'//day//'-'//
     1      orbitn//'-'//source
	   else
	    temp = 'def-uv-nc-'//year//'-d'//day//'-'//
     1      orbitn//'-'//source
	   end if
	 end if

	 if(data) then
           if(constra) then 
	    temp = 'def-uvd-c-'//year//'-d'//day//'-'//
     1      orbitn//'-'//source
	   else
	    temp = 'def-uvd-nc-'//year//'-d'//day//'-'//
     1      orbitn//'-'//source
	   end if
	 end if


	 if(plotgrt) then
           if(constra) then 
	    temp = 'def-grt-c-'//year//'-d'//day//'-'//
     1      orbitn//'-'//source
	   else
	    temp = 'def-grt-nc-'//year//'-d'//day//'-'//
     1      orbitn//'-'//source
	   end if
	 end if

	 if(grtmap) then
	    temp='def-grtmap'
      	 end if


	 if(plotcons) then
           if(constra) then 
	    temp = 'def-cons-c-'//year//'-d'//day//'-'//
     1      orbitn//'-'//source
	   else
	    temp = 'def-cons-nc-'//year//'-d'//day//'-'//
     1      orbitn//'-'//source
	   end if
	 end if

	 if(complot) then
           if(constra) then 
	    temp = 'def-tant-c-'//year//'-d'//day//'-'//
     1      orbitn//'-'//source
	   else
	    temp = 'def-tant-nc-'//year//'-d'//day//'-'//
     1      orbitn//'-'//source
	   end if
	 end if

	 if(yzplot) then
           if(constra) then 
	    temp = 'def-yz-c-'//year//'-d'//day//'-'//
     1      orbitn//'-'//source
	   else
	    temp = 'def-yz-nc-'//year//'-d'//day//'-'//
     1      orbitn//'-'//source
	   end if
	 end if


	 if(uvplott) then
           if(constra) then 
	    temp = 'def-uvtt-c-'//year//'-d'//day//'-'//
     1      orbitn//'-'//source
	   else
	    temp = 'def-uvtt-nc-'//year//'-d'//day//'-'//
     1      orbitn//'-'//source
	   end if
	 end if


	 if(uvplotg) then
           if(constra) then 
	    temp = 'def-all-c-'//year//'-d'//day//'-'//
     1      orbitn
	   else
	    temp = 'def-all-nc-'//year//'-d'//day//'-'//
     1      orbitn
	   end if
	  if(uvplott) temp(7:7)='t'
	 end if

	 if(plotsat) then
           if(constra) then 
	    temp = 'def-sou-c-'//year//'-d'//day//'-'//
     1      orbitn//'-'//source
	   else
	    temp = 'def-sou-nc-'//year//'-d'//day//'-'//
     1      orbitn//'-'//source
	   end if
	 end if


	 if(plotsat2) then   
	 temp = 'def-sat-'//year//'-d'//day//'-'//orbitn
	 end if

! remove blanks from default name

	  icount=0
	do i=1,len1(temp)

C-gam	 if(temp(i:i).ne.'') then
	 if(temp(i:i).ne.' ') then

	  icount=icount+1
	  default(icount:icount)=temp(i:i)
	 end if
	end do

!	  inquire(file=default,exist=exist)

!	  default2=date(1:9)//'/'//default
! 	  inquire(file=default2,exist=exist)

	  inquire(file=default,exist=exist)
!	  write(*,*) 'i1: exist, default: ',exist, default


	if(exist) then
!	   write(*,'(a)') 'default name already exists :'//default
	  exist=.false.
	  i1=len1(default)
	  default(i1+1:i1+2)='.1'

! 	  inquire(file=default,exist=exist)

!	  default2=date(1:9)//'/'//default
! 	  inquire(file=default2,exist=exist)


	  inquire(file=default,exist=exist)
!	  write(*,*) 'i2: exist, default: ',exist, default



	  if(exist) then
!	   write(*,'(a)') 'default name already exists :'//default
	  end if
	end if


	if(exist) then
200	continue
	  exist=.false.

	  i2=index(default,'.')

	  read(default(i2+1:i2+3),'(i3)') inum
          inum=inum+1


	  temp(1:3)='   '
	  if(inum.le.9) then
           write(temp(1:1),'(i1)') inum
	   else if(inum.le.99) then
           write(temp(1:2),'(i2)') inum
	   else 
           write(temp(1:3),'(i3)')
	  end if


	  default(i2+1:i2+3)=temp(1:3)

! 	  inquire(file=default,exist=exist)

!	  default2=date(1:9)//'/'//default
! 	  inquire(file=default2,exist=exist)

	  inquire(file=default,exist=exist)
!	  write(*,*) 'i3: exist, default: ',exist, default



	 if(exist) then
	  if(debug) then
	   write(*,'(a)') 'default name already exists :'//default
	  end if
          goto 200
	 end if
	end if

	if(.not.inter) then
 	 write(*,'(a)') 'default name is : '//default
	end if

	if(inter) then

	ans='n'

	else

	write(*,*) 'change default name ? (y=yes)'
	read(*,'(a)') ans

	end if !if(inter)



	if(ans.eq.'y') then
100	  continue
	  exist=.false.
          write(*,*) 'name for .csh file ?'
	  read(*,'(a)') cshname
 	  inquire(file=cshname,exist=exist)
	 if(exist) then
	  write(*,*) '***this filename already exist***'
	  goto 100
	 end if
	else
	 defname=default
	end if



!	  def_file = 'def-'//default(5:len1(default))
	  def_file = defname



	if(.not.output) goto 1000



	if(.not.ignore) then

! creating new STATIONS file

!2200  READ(INSTA,520,END=2400) XON, RR, TD,TM,TS, PD,PM,PS, XZL,XHL,
!     1   Q5, Q6, IY, IM, ID, UTH, UTM, UTS, STTYPE

!      OPEN ( UNIT=INSTA, NAME='STATIONS', 
!     1       FORM='FORMATTED', STATUS='OLD', ERR=2900 )

	t1=0.0
	t2=0.0
	t3=0.0
	t4=0.0
	t5=0.0

	uth=0.0
	utm=0.0
	uts=0.0

	sttype=2

        open(11,name='STATIONS',
     1  form='FORMATTED', status='unknown', err=2010)

! only write out orbital elements if VSOP or RADIOASTRON
	
	if(isat.le.2) then

         write(11,520) sname, asemi, eccen,incl,ran,
     1   aop,man,iys,ims,ids,uth,utm,uts,sttype

	end if



        open(10,name='STATIONS-FAKESAT',
     1 form='FORMATTED', status='OLD', err=2010,iostat=iostat)

!         write(*,*) 'orbital info:'

!         write(*,520) sname, asemi, eccen,incl,ran,
!     1   aop,man,iy,im,id,uth,utm,uts,sttype

	iostat=0

	do while(iostat.eq.0)
       read(10,'(a)',err=510) sline
       write(11,'(a)') sline(1:len1(sline))
	end do

510	continue

520    FORMAT(A8,F12.0,F16.6,9x,F16.6,9x,
     1 F5.1,5x,F5.1,F5.1,I5,I3,I4,F16.0,F3.0,F6.3,I5)

!  520 FORMAT(A8,F12.0,2(F16.0,F3.0,F6.3),4F5.0,I5,I3,I4,
!     1       (F16.0,F3.0,F6.3),I5)



	close(10)
	close(11)

	end if	!if(ignore) then



	 if(plotgrt.or.plotcons.or.plotazel.or.consplot
     1    .or.complot.or.yzplot.or.ecliplot) then


	 if(grtmap) then

C-gam	  line(iline)='PLOTF  '''//plotf(1:len1(plotf))//''''
	  line(iline)='PLOTF  '//plotf(1:len1(plotf))//' '

	  iline=iline+1
	 else

C-gam	  line(iline)='PLOT2F  '''//plotf(1:len1(plotf))//''''
	  line(iline)='PLOT2F  '//plotf(1:len1(plotf))//' '

	  iline=iline+1
	 end if

	 else


C-gam	 line(iline)='PLOTF  '''//plotf(1:len1(plotf))//''''
	 line(iline)='PLOTF  '//plotf(1:len1(plotf))//' '

	 iline=iline+1

	 end if

	if(.not.gronly.and..not.grtmap) then
	line(iline)='USEAEIOWM'
	iline=iline+1
	line(iline)='AEIOWM(1) '//ovalue(10)
	iline=iline+1
	line(iline)='AEIOWM(2) '//ovalue(2)
	iline=iline+1
	line(iline)='AEIOWM(3) '//ovalue(3)
	iline=iline+1
	line(iline)='AEIOWM(4) '//ovalue(4)
	iline=iline+1
	line(iline)='AEIOWM(5) '//ovalue(5)
	iline=iline+1
	line(iline)='AEIOWM(6) '//ovalue(6)
	iline=iline+1
	line(iline)='YORB '//ovalue(7)
	iline=iline+1
	line(iline)='MORB '//ovalue(8)
	iline=iline+1
	line(iline)='DORB '//ovalue(9)
	iline=iline+1
	line(iline)='UTORB 0.00 '
	iline=iline+1
	end if


	line(iline)='/'
	iline=iline+1

	line(iline)(1:3)='EOD'
	iline=iline+1

	if(dirty_beam.or.clean_map.or.modplot) then
	 if(band.eq.'p') wave = 91.0/100.0
	 if(band.eq.'l') wave = 20.0/100.0
	 if(band.eq.'c') wave = 6.0/100.0
	 if(band.eq.'k') wave = 1.35/100.0

	 re = 6378.0 * 1000.0

	 if(space) then
          rmax = 2.0*re + asemi*(1.0 + ecc)
	 else
          rmax = 2.0*re 
	 end if

	 xyint = (wave/rmax)*206264806.2
	 xyint = xyint/3.0

	 write(*,*) 'wave, rmax, ecc, xyint: ',wave, ecc, rmax, xyint

	 write(xyint_string,'(f9.5)') xyint
	 
	end if

	if(dirty_beam) then
	 line(iline)='fakesat_system dirty_beam'//xyint_string
	 iline=iline+1	 
	end if

	if(clean_map) then
	 line(iline)='fakesat_system clean_map'//xyint_string
	 iline=iline+1 
	end if

	if(visplot) then
	 line(iline)='fakesat_system visplot'
	 iline=iline+1 
	end if

	if(modplot) then

	 call system('/bin/rm .model')
	 open(3,file='.model',status='new')

         size = 56.0*xyint

	 write(*,*) 'size is ' ,size 

	if(band.eq.'p') write(3,'(f7.3,a)') size, ' 327 '//modfile
	if(band.eq.'l') write(3,'(f7.3,a)') size,' 1666 '//modfile
	if(band.eq.'c') write(3,'(f7.3,a)') size,' 5000 '//modfile
	if(band.eq.'k') write(3,'(f7.3,a)') size,' 22000 '//modfile
	 close(3)

	 line(iline)='fakesat_system modplot'
	 iline=iline+1 

	end if


	 line(iline)='exit'
	 iline=iline+1


! write orbital elements to .csh file :

	if(.not.ignore) then
	if(space) then

	line(iline)='# orbital elements: '
	iline=iline+1
	line(iline)='# semi-major axis (km)           : '//ovalue(1)
	iline=iline+1
	line(iline)='# eccentricity                   : '//ovalue(2)
	iline=iline+1
	line(iline)='# inclination (degrees)          : '//ovalue(3)
	iline=iline+1
	line(iline)='# RA of asc node (degrees)       : '//ovalue(4)
	iline=iline+1
	line(iline)='# arg of perigee (degrees)       : '//ovalue(5)
	iline=iline+1
	line(iline)='# Mean Anomaly at 0 UT (degrees) : '//ovalue(6)
	iline=iline+1
	line(iline)='# Epoch year  : '//ovalue(7)
	iline=iline+1
	line(iline)='# Epoch month : '//ovalue(8)
	iline=iline+1
	line(iline)='# Epoch day   : '//ovalue(9)
	iline=iline+1

	end if
	end if



	if(inter) then


!	 iout=iout+1

	 write(c1,'(i1)') iout

!	 if(inter) then
!	   cshname= '.fakesat-tmp.csh'
!          cshname2= default
!	 end if


	 if(plot) then
	  write(*,*)  '______________________________________________________________ '
	  write(*,*) ' '
	  write(*,*) '*** creating plot file : ***'
	  write(*,*) ' '
!	  write(*,'(a)') plotf(1:len1(plotf))//plotfname(1:len1(plotfname))
	  write(*,'(a)') plotf(1:len1(plotf))
	  write(*,*) ' '
	 end if
 

	 write(*,*)  '______________________________________________________________ '
	 write(*,*) ' '
	 write(*,*) 'creating .fakesat-tmp.csh file :'
	 write(*,*) ' '


	call system('/bin/rm -f  .fakesat-tmp.csh')

	open(1,file='.fakesat-tmp.csh',status='new')
!	open(2,file=default,status='new')



	do i=1,iline
	 write(*,'(a)') line(i)(1:len1(line(i)))
	 write(1,'(a)') line(i)(1:len1(line(i)))
!	 write(2,'(a)') line(i)(1:len1(line(i)))
	end do

	 close(1)
!	 close(2)

!	call system('fakesat_system mv_csh')

	 write(*,*) '______________________________________________________________ '

	if(uvplott.or.uvplotg) then
!	 call system('csh .fakesat-tmp.csh >& /dev/null &')
	 call system('csh .fakesat-tmp.csh > /dev/null &')
	else
	 call system('csh .fakesat-tmp.csh &')
	end if

!	plot=.false.
	output=.false.
	cursor=.true.
	goto 1000

	else

	write(*,*) ' '
	write(*,*) 'to use this command file type (or copy and paste): '
	write(*,*) ' '
	write(*,'(a)') 'csh '//defname
	write(*,*) ' '

	end if

2000	continue


!	 call pgvport(0.0,1.0,0.0,1.0)
	 call pgvport(x1vp,x2vp,y1vp,y2vp)
	 call pgwindow(0.0,1.0,0.0,1.0)
	 call pgsci(0)
	 call pgrect(0.0,1.0,0.0,1.0)

!	call pgend

	write(*,*) ' '
	write(*,*) '++++++++++++++ Have a nice day now ++++++++++++++'
	write(*,*) ' '
	write(*,*) ' '
	write(*,*) ' '	
	write(*,*) 'If you have any suggestions for possible upgrades'
	write(*,*) 'to this software or discover any bugs please send'
	write(*,*) 'email to :'
	write(*,*) '            zhur@asc.rssi.ru'
	write(*,*) ' '
	write(*,*) '+++++++++++++++++++++++++++++++++++++++++++++++++'
	write(*,*) ' '

	
	return

2010	continue

	write(*,*) '+++++++++I/O ERROR+++++++++'

        call pgsci(0)
!       call pgvport(0.0,1.0,0.0,1.0)
	call pgvport(x1vp,x2vp,y1vp,y2vp)
        call pgwindow(0.0,1.0,0.0,1.0)
        call pgsci(1)
        call pgtext(0.5,0.5,'Problems with STATIONS files') 

	return

2015	continue

	 call pgadvance
	 call pgsci(0)
!	 call pgvport(0.0,1.0,0.0,1.0)
	 call pgvport(x1vp,x2vp,y1vp,y2vp)
	 call pgwindow(0.0,1.0,0.0,1.0)
	 call pgsci(2)
	 call pgptext(0.5,0.5,0.0,0.5,'ABORTING: Problems with file: stations.cat')

!	 call pgend

	return

2016	continue

	 call pgadvance
	 call pgsci(0)
!	 call pgvport(0.0,1.0,0.0,1.0)
	 call pgvport(x1vp,x2vp,y1vp,y2vp)
	 call pgwindow(0.0,1.0,0.0,1.0)
	 call pgsci(2)
	 call pgptext(0.5,0.5,0.0,0.5,'ABORTING: Problems with file: sources.cat')

!	 call pgend

	return



2020    continue

!	return
!990	write(*,*) '*** error:                          ***'
!	write(*,*) '*** cannot open file: stations.cat  ***'
!	write(*,*) '*** aborting program                ***'

!	return
!991	write(*,*) '*** error:                               ***'
!	write(*,*) '*** cannot open file: .stations.cat.old  ***'
!	write(*,*) '*** aborting program                     ***'

	return

	end

	subroutine box2(x1,x2,y1,y2,up,ibb,ibw)

	integer ibb,ibw
	real x1,x2,y1,y2
	logical up

!	write(*,*) 'x1,x2,y1,y2,up : ',x1,x2,y1,y2,up

	iboxwhite = ibw
	iboxblack = ibb

        call pgslw(1)

	if(up) then
	 call pgsci(iboxblack)
	 call pgmove(x1,y1)
	 call pgdraw(x2,y1)
	 call pgdraw(x2,y2)
	 call pgsci(iboxwhite)
	 call pgdraw(x1,y2)
	 call pgdraw(x1,y1)
	else
	 call pgsci(iboxwhite)
	 call pgmove(x1,y1)
	 call pgdraw(x2,y1)
	 call pgdraw(x2,y2)
	 call pgsci(iboxblack)
	 call pgdraw(x1,y2)
	 call pgdraw(x1,y1)
	end if

	call pgslw(1)


	return

	end

	   subroutine headbox(x1vp,x2vp,y1vp,y2vp, ytop_start,xcin,ycin,
     1     header_top,itopbox,itoptext,iboxblack,iboxwhite,
     2     iselect,cursor)

! write info a top of screen:


	   character header_top*48,line*80
	   logical up,cursor
	   real x1vp,x2vp,y1vp,y2vp,xc,yc

		 
	 y1t= y1vp+ (y2vp-y1vp)*ytop_start
	 
	 x1=35
	 x2=65
	 y1=15
	 y2=90

	 dx=4

	 dy = 1.0 -  ytop_start
         ch = (y2vp-y1vp)*dy/0.05

! test if cursor is in box

	 if(cursor) then

	   xc = 100.0*(xcin-x1vp)/(x2vp-x1vp)
	   yc = 100.0*(ycin-y1t)/(y2vp-y1t)

!	   write(*,*) 'x1,x2,y1,y2: ',x1,x2,y1,y2
!	   write(*,*) 'xc,yc,xcin,ycin: ',xc,yc,xcin,ycin

	  if(xc.ge.x1.and.xc.le.x2.and.
     1       yc.ge.y1.and.yc.le.y2) then

	    write(*,*) '*** help box found ***'

! lowered box

	 call pgbbuf
	 call pgvport(x1vp,x2vp,y1t,y2vp)
	 call pgwindow(0.0,100.0,0.0,100.0)
	 call pgsci(iselect)
	 call pgrect(x1+dx,x2+dx,y1,y2)
	 call pgsci(itoptext)
	 call pgsch(ch)
	 call pgptext(50.0+dx,40.0,0.0,0.5,header_top)
	 up = .false.	 
         call box2(x1+dx,x2+dx,y1,y2,up,
     1   iboxblack,iboxwhite)
	 call pgebuf

! latex and xdvi appropriate files

	    call system('/bin/rm -f help.tex')

	    open(10,file='help.tex',status='new')

! VP add double \\ slashes, one slash ignored at output
 	    
	    line='\input tex/preamble.tex'
	    write(10,'(a)') line(1:len1(line))
	    line='\input tex/preamble2.tex'
	    write(10,'(a)') line(1:len1(line))
	    line='\input tex/intro.tex '
	    write(10,'(a)') line(1:len1(line))
	    line='\input tex/end.tex'
	    write(10,'(a)') line(1:len1(line))

	    close(10)


!	    call system('latex help.tex')
!	    call system('latex help.tex')
!	    call system('xdvi help.dvi &')

! two calls to latex required to get toc correct

	    call system('fakesat_system help 2')

	   else

!	    write(*,*) 'cursor not in headerbox'
	    goto 1000

	  end if

	 end if

! plot raised headerbox

	 call pgbbuf
	 call pgvport(x1vp,x2vp,y1t,y2vp)
	 call pgwindow(0.0,100.0,0.0,100.0)
	 call pgsci(itopbox)
	 call pgrect(x1+dx,x2+dx,y1,y2)
	 call pgsci(itoptext)
	 call pgsch(ch)
	 call pgptext(50.0+dx,40.0,0.0,0.5,header_top)
	 up = .true.	 
         call box2(x1+dx,x2+dx,y1,y2,up,
     1   iboxblack,iboxwhite)
	 call pgebuf

1000	continue

	 return

	 end

           subroutine stations_init(init)

! if init is false subroutine checks to see if the stations.cat file
! has been changed. If it has init is set to true

! DWM 11-Nov-95

	   logical init
	   character*113 line_in,line_in2
!	   character  n*5,n1*5

	   if(.not.init) then

! two methods available:
!
! imethod = 0   use unix system and getenv calls
! imethod = 1   use fortran code

	   imethod = 0

	   if(imethod.eq.0) then

	   call system('fakesat_system stdiff')

!	   call getenv(n,n1)
!	   if(n1.ne.'0') init = .true.
!	   write(*,*) 'n1 is: ',n1


	   open(10,file='.tmp-n',status='old',err=992)
	   read(10,*) i
	   close(10)

	   if(i.ne.0) init = .true.

!	   write(*,*) 'i,init: ',i,init

	  
	   else

	   open(10,file='stations.cat',status='old',err=990)
	   open(11,file='.stations.cat.old',status='old',err=991)

	  iostat=0

	  do while (iostat.eq.0)
	   read(10,'(a)',iostat=iostat1,end=30) line_in
30	   continue
	   read(11,'(a)',iostat=iostat2,end=31) line_in2
31	   continue

	   if(line_in.ne.line_in2) then
	   init=.true.
!	   write(*,*) 'differences between stations.cat and .stations.cat.old file:'
!	   write(*,'(a)') line_in
!	   write(*,'(a)') line_in2
	   goto 200
	   end if
	   
	   iostat= iostat1 + iostat2

!	   write(*,*) 'iostat,iostat1,iostat2: ',iostat1,iostat2

          end do

	   if(iostat1.eq.0) then
	    write(*,*) 'stations.cat has more lines that .stations.cat.old'
            init = .true.
	   end if

	   if(iostat2.eq.0) then
	    write(*,*) '.stations.cat.old has more lines that stations.cat'
            init = .true.
	   end if

200	  continue

	  close(10)
	  close(11)

	 end if !if(imethod.eq.0) then

	if(init) then
 	 write(*,*) 'There are differences between:'
	 write(*,*) 'stations.cat and .stations.cat.old file'
         write(*,*) 're-initializing menu_defaults file'
         write(*,*) ' '
	end if

	call system('/bin/rm .stations.cat.old')
	call system('/bin/cp -p stations.cat .stations.cat.old')

	end if

	return


990	write(*,*) '*** error:                          ***'
	write(*,*) '*** cannot open file: stations.cat  ***'
	write(*,*) '*** aborting program                ***'

	stop

991	write(*,*) '*** error:                               ***'
	write(*,*) '*** cannot open file: .stations.cat.old  ***'
	write(*,*) '*** aborting program                     ***'

	stop

992	write(*,*) '*** error:                               ***'
	write(*,*) '*** cannot open file: .tmp-n             ***'
	write(*,*) '*** fakesat_system file may have problems***'
	write(*,*) '*** aborting program                     ***'


	stop


	end



